        /* * * * * * * * * * * * * * * * *    
	 *  MARCconv        Version 2.3  *
         *   File:          MARCconv.c   *    
	 *        Main functions         *
         *    Last update: 28/01/1997    *    
         *      Michael S. Preminger     *    
         *      BRODD, OSLO COLLEGE      *    
         *        THE ONE PROJECT        *    
         * * * * * * * * * * * * * * * * */   

#undef LIBTEST



#include <time.h>
#define CR '\n'

#include "MARCproto.h"



jmp_buf marcconv_env;

static char from_Name[ 255 ];
static char to_Name[ 255 ];
static int MARC_init_flag = 0;
char *rcdStrmInName, *rcdStrmOutName;


/* * * * * * * * * * * * * * * * *
 *                               *
 *        ERROR LOGGING          *
 *                               *
 * * * * * * * * * * * * * * * * */

/*A substitute for the toolbox error logging function.
To be discarded and substituted by SIL on distribution 
int fildes (used throughout the program)
is declared in the closing line of datastruct.h */

#ifndef _ONETK_LIB_BUILD_
int ONETK_WriteLogFile(int fd, char *msg){
  printf("%s\n",msg);

}
#endif /* not _ONETK_LIB_BUILD_ */




char *convertRecord(char *fromFormat,
		    char *toFormat,
		    char *recordString

		    , char *main_sutrs_in[]
		    , char *main_sutrs_out[]
		    , generic_table *ctbl[]
		    , prefixing_table_str *pts
		    , xiferping_table_str *xts
		    , decision_table_str *dts
		    , indicator_table_str *its
		    , conditional_table_str *cts
		    , PortionTable_ISBD *itbl[]
		    
		    ) 
     /*convertRecord()*/{
  /*
   * Acceps a String containing a  single record in iso2709
   * format, and returns a string containing the converted
   * record
   */

  char *outputString, *inputString;
  int i, f, ret_int, resCtl=0, CTind;
  record *rcd_in, *rcd_out;
  field *fld, *fld000;
  char *sutrs_in, *sutrs_out;

#ifndef _ONETK_LIB_BUILD_ 
  rcd_cnt++;
  printf("rcd_cnt=%d\n", rcd_cnt);
#endif
  if (rcd_cnt==72){
      printf("rcd_cnt=%d\n", rcd_cnt);
  }
  if (strlen(recordString)>=MAX_RECORD_LENGTH){
    char m[200];
    sprintf(m, "record rejected - too long\n");
    if (ONETK_WriteLogFile(fildes, m)==-1){
      longjmp(marcconv_env,1);
    }
    return NULL;
  }
   

  

  /*
   *  PARSE 2709 STRING INTO A RECORD STRUCT
   *  ACCOMPANIED BY A CONVERSION TABLE THAT CONTAINS THE
   *  APPROPRIATE TEXT ATTRIBUTE FOR AN INPUT SUTRS
   *  RECORD.
   */

  /* 
   * First we find an appropriate table, for which the
   * format of the incoming record is a FROM format
   * remember: lt[]  and lt_ArrayLength are global!!
   */
  
  for (i=0;i<lt_ArrayLength;i++){
    if (strcmp(lt[i]->fromFormatName,fromFormat)==0)
      break;
  }

  /*
   * If we do not have a proper table - choose the first
   * one, in order to avoid that a NULL pointer is 
   * transfered with the function call. (SUN platforms
   * hate those)
   */
  if (i==lt_ArrayLength)
    i=0;

  /* 
   * Then we read the record 
   */
  rcd_in=(record *)inputRecord(recordString, lt[i], fromFormat);
  if (rcd_in==NULL)
    return NULL;
#ifndef  _ONETK_LIB_BUILD_


  updateRecordFieldLengths(rcd_in);
  updateRecordDataLength(rcd_in);

#endif
  /*
   * For USMARC RECORDS, THE ISBD PUNCTUATION,
   * IF EXISTING, IS TO BE REMOVED
   */
  if (memcmp(fromFormat,"USMARC",6)==0 
      /** to do:
       * CHECK LEADER[18] 
       **/
	) {
#ifndef MARC_NO_ISBD

    removeIsbdPunctuation(rcd_in,itbl);
#endif          

  }
  sutrs_in=(char *)malloc(RCD_SUTRS_LENGTH*sizeof(char));
  memset(sutrs_in , '\0', RCD_SUTRS_LENGTH);
  inputString=output2709Record(rcd_in, sutrs_in);
  free(inputString);
    

  /*
   * BUILD THE OUTPUT RECORD
   */

  rcd_out=createRecord();

  /*
   * Update format name
   */
  strcpy(rcd_out->format, toFormat);

  /*
   * Go through all the fields in the record
   */
  for ( f=0;  f<rcd_in->ArrayLength;f++){
    CTind= atoi(rcd_in->tags[f]);

    if ( ctbl[CTind]==NULL ){

#ifdef MARC_999_NON_STANDARD_FIELDS      
      char *privateFieldComment=
	(char *) 
	  malloc(PRIVATE_FIELD_COMMENT_SIZE
		 *sizeof(char));
      
      memset(privateFieldComment,'\0',
	     PRIVATE_FIELD_COMMENT_SIZE);
      sprintf(privateFieldComment,
	      "Field-tag %s Not in %s standard",
	      rcd_in->tags[f],
	      fromFormat);
      
      makePrivateField_FULL(fromFormat, rcd_out, rcd_in->fields[f],
			    privateFieldComment);
      free(privateFieldComment);
#endif /* MARC_999_NON_STANDARD_FIELDS */     
    } /*if ( ctbl[CTind]==NULL )*/

    else			/*ctbl[CTind]==NULL*/{ 

      if (ctbl[CTind]->portion_table_ctl!=NULL && resCtl!=-1){
#ifndef MARC_NO_CONVERT
	if (rcd_in->fields[f]->ctrlfield!=NULL)
	  resCtl=convertControlField(rcd_in,
				     f,
				     rcd_out,
				     ctbl[CTind]->portion_table_ctl,
				     its);
	else{
	  int g;
	  dataField *df=rcd_in->fields[f]->datafield;
	  
	  for(g=0;g<df->ArrayLength;g++)
	    convertCodedDataSF(rcd_in,
			       f,
			       g,
			       rcd_out,
			       ctbl[CTind]->portion_table_ctl,
			       its /*
				    * needed for 
				    *treating UNIMARC 
				    *indicators 
				    */
			       );
	  

	    
#endif /*not MARC_NO_CONVERT*/
	}
      }
      else			/*DATA FIELDS ?*/{	       	
	if (resCtl!=-1){
	  if (ctbl[CTind]->portion_table_vdt!=NULL){
#ifndef MARC_NO_CONVERT
	    convertDataField(rcd_in,
			     f,
			     rcd_out,
			     pts,
			     xts,
			     dts,
			     its,
			     cts,
			     ctbl[CTind]);

#endif /*not MARC_NO_CONVERT*/

	  }
	  else/*ctbl[CTind]->portion_table_vdt!=NULL*/{
	    if (ctbl[CTind]->copyField==TRUE){
	      if (duplicateField(rcd_out, rcd_in->fields[f])==NULL){
		char m[200];
		sprintf(m, "error in duplicateField()\n");
		if (ONETK_WriteLogFile(fildes, m)==-1){
		  longjmp(marcconv_env,1);
    }
		
		return NULL;
	      }
	     
	    }
	    else /*copField==TRUE*/{
	      if (ctbl[CTind]->defaultText!=NULL){
		
		/*
		 * In this case the tag is defined in the from format, 
		 * but not in the to format
		 */
		makePrivateField_FULL(rcd_in->format, rcd_out, rcd_in->fields[f], ctbl[CTind]->defaultText);
		
	      }
	      else		/*ctbl[CTind]->defaultText!=NULL*/{
		char *m=(char *)calloc(200, sizeof(char));
		sprintf(m, 
			"No conversion for Field tag %s and no description\n", 
			rcd_in->tags[f]
			);
		makePrivateField_FULL(rcd_in->format, rcd_out, rcd_in->fields[f] , m);
	      }
	    }
	  } /*else	ctbl[CTind]->portion_table_vdt!=NULL		*/
	}
      }
    }
  }
  
  /*
   * Now the record is built, with all the fileds. 
   * UPDATE ISBD PUNCTUATION OF USMARC RECORD
   */

  if (memcmp(toFormat, "USMARC",6)==0){ 
#ifndef MARC_NO_ISBD
    updateIsbdPunctuation(rcd_out, 
			  itbl);
    rcd_out->fields[0]->ctrlfield->data[18]='a';
#else /*not MARC_NO_ISBD*/
    /*
     * IF ISBD CONVERSION IS SWITCHED OFF
     * Update record leader to mark it
     */
    rcd_out->fields[0]->ctrlfield->data[18]=' ';
    insertF("040",rcd_out, "  ", (lookup_table *) NULL);
    insertSF(rcd_out, "040",'e',"AACR2");
#endif   /*not MARC_NO_ISBD*/ 
  }

  /*
   * SORT THE FIELDS RECORD
   */
#ifdef MARC_DEBUG
#ifndef MARC_NO_SORT 
  sortFields(rcd_out);
#endif /*not MARC_NO_SORT*/
#else /*MARC_DEBUG*/
  sortFields(rcd_out);
#endif /*MARC_DEBUG*/


  /*
   * CHECK THAT ALL DATA FIELDS IN RECORD
   * CONTAIN INFORMATION. 
   */
  
  for (i=0; i< rcd_out->ArrayLength; i++){
    if (rcd_out->fields[i]->datafield !=NULL){
      if (rcd_out->fields[i]->datafield->ArrayLength==0)
	removeField(rcd_out, i);
    }
  }

  /*
   * UPDATE THE LENGTHS OF THE FIELDS, 
   * TO FACILITATE CORRECT SPACE ALLOCATION
   */
  updateRecordFieldLengths(rcd_out);
  updateRecordDataLength(rcd_out);

  updateUndefinedIndicatorValues(rcd_out, 
				 getUndefinedIndValue(toFormat));

  /*
   * Write input record into sutrs file,
   * and sutrs string
   * but discard 2709 string
   */
 goingOut:
  /* moved to update2709record
  updateRecordFieldLengths(rcd_in);
  updateRecordDataLength(rcd_in);
  */
#ifdef MARC_DEBUG
/** to do SAVE SPACE FOR THE MAIN SUTRS STRING
  main_sutrs_in=(char *)realloc(main_sutrs_in, 
				strlen(main_sutrs_in)
				+strlen(sutrs_in)+2);
  memset(main_sutrs_in+strlen(main_sutrs_in),
	 '\0',
	 strlen(sutrs_in)+2);
**/


  for(i=0;i<SUTRS_ARRAY_LENGTH;i++){
    if(main_sutrs_in[i]==NULL)
      break;
  }
  if(i==SUTRS_ARRAY_LENGTH){
    char m[200];
    sprintf(m, "converting only %d records in MARC_DEBUG mode\n", SUTRS_ARRAY_LENGTH);
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    return "SUTRS_ARRAY_LENGTH exceeded";
  }
  else{
        sutrs_in=realloc(sutrs_in, strlen(sutrs_in)+1);
	  main_sutrs_in[i]=sutrs_in;
  }
  sutrs_out=(char *)malloc(RCD_SUTRS_LENGTH*sizeof(char));
  memset(sutrs_out , '\0', RCD_SUTRS_LENGTH);


  /*
   * WRITE OUTPUT-RECORD STRUCTURE INTO A STRING
   * create also a sutrs string
   */
  outputString=output2709Record(rcd_out
				,sutrs_out
				);



/** to_do : SAVE SPACE FOR THE MAIN SUTRS STRING
  main_sutrs_out=(char *)realloc(main_sutrs_out, 
				strlen(main_sutrs_out)
				+strlen(sutrs_out)+2);
  memset(main_sutrs_out+strlen(main_sutrs_out),
	 '\0',
	 strlen(sutrs_out)+2);
**/

  for(i=0;i<SUTRS_ARRAY_LENGTH;i++){
    if(main_sutrs_out[i]==NULL)
      break;
  }
  if(i==SUTRS_ARRAY_LENGTH){
    char m[200];
    sprintf(m, "sutrs array not long enough. Increase SUTRS_ARRAY_LENGTH in the file datastruct.h");
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    
  }
  else{/*Reduce the length*/
    sutrs_out=(char *)realloc(sutrs_out, strlen(sutrs_out)+1);
    main_sutrs_out[i]=sutrs_out;
  }
#else/*MARC_DEBUG*/


  outputString=output2709Record(rcd_out);
#endif   /*MARC_DEBUG*/
  freeInRecord(rcd_in);
  /*  free(rcd_in);*/
  freeOutRecord(rcd_out);
  /*  free(rcd_out);*/
  return outputString;
  
  /*printf("%s\n",outputString);*/
}

char *readToEOR(FILE *fl){
  /*
   * READS A SINGLE RECORD FROM THE INPUT FILE
   */
  char ch, *chr, *ptr_c;
  int ctr=0;
  /** to do:
   * FACILITATE FOR RECORDS > 10000?
   **/

  ptr_c = chr=(char *)calloc( 1+MAX_RECORD_LENGTH,sizeof(char));
  ch=fgetc(fl);
  
  
  while(ch!=END_OF_RECORD && !feof(fl)){
    ctr++;
    if (ctr==MAX_RECORD_LENGTH){
      char m[200];

      sprintf(m, "readToEOR(): record rejected - too long\n");
      if (ONETK_WriteLogFile(fildes, m)==-1){
	longjmp(marcconv_env,1);
      }
      free(chr);
      return NULL;
    }
      
    *ptr_c++ = ch; 
    ch=fgetc(fl);
  }

  /** to do: 
   * Add a Mechanism that scans through tailing 
   * blanks between records, and before an EOF
   **/

  if (feof(fl)){

    if (chr!=NULL)
      free(chr);
    
    return (char *)EOF;
  }
else{
    *ptr_c = ch; 
    return chr;
  }
}

FILE *convertRecordStream(

			  FILE *rcdStrmIn,
			  char *fromFormat, 
			  char *toFormat,

			  char *Sutrs_In[],
			  char *Sutrs_Out[]
/*#ifdef _ONETK_LIB_BUILD_*/
			  ,char *outFile
/*#endif  _ONETK_LIB_BUILD_ */
			  ,char *fLineFIn, char *fLineFOut
			  ,char *recordStrIn, char **precordStrOut
			  )
{
  char ch;
  int q, i, convset, rcdCtr=0;
  char *recordStrOut, *pathRcdFileNames;
#ifndef _ONETK_LIB_BUILD_
  FILE *rcdFileNames;
#endif /* _ONETK_LIB_BUILD_ */
			  
#ifndef MARC_MULTI_TABLE
  generic_table *Conversion_Table[1000];
  PortionTable_ISBD *isbd_tbl[1000];
#endif /* not MARC_MULTI_TABLE */

  conversion_tbl_str *cns;
  decision_table_str *dts;
  indicator_table_str *its;
  conditional_table_str *cts;
  prefixing_table_str  *pts;
  xiferping_table_str *xts;
/*  char *recordStrIn;*/
  FILE *recordStrmIn = NULL;
  FILE *recordStrmOut = NULL;

  int use_files_flag = 0;
#ifdef MARC_DEBUG
  FILE *lineFOut = NULL; 
  FILE *lineFIn = NULL;

  if ( !fLineFIn ){
    lineFIn=fopen("lineFormat.in", "w") ;
    if (lineFIn== NULL){
      char m[200];
      sprintf(m, "Unable to open %s\n","lineFormat.in" );
      if (ONETK_WriteLogFile(fildes, m)==-1){
	longjmp(marcconv_env,1);
      }
      longjmp(marcconv_env,1);
      
      
    }
  }
  else{
    lineFIn=fopen( fLineFIn, "w");
    if (lineFIn==NULL){
      char m[200];
      sprintf(m, "Unable to open %s\n",fLineFIn );
      if (ONETK_WriteLogFile(fildes, m)==-1){
	longjmp(marcconv_env,1);
      }
      longjmp(marcconv_env,1);
      
    }
  }
  if ( !fLineFOut ){
    lineFOut=fopen("lineFormat.out", "w");
    if(lineFOut==NULL){
           char m[200];
      sprintf(m, "Unable to open %s\n", "lineFormat.out");
      if (ONETK_WriteLogFile(fildes, m)==-1){
	longjmp(marcconv_env,1);
      }
      longjmp(marcconv_env,1);
    }
  }
  else{
    lineFOut=fopen( fLineFOut, "w");
    if(lineFOut==NULL){
      char m[200];
      sprintf(m, "Unable to open %s\n", fLineFOut);
      if (ONETK_WriteLogFile(fildes, m)==-1){
	longjmp(marcconv_env,1);
      }
      longjmp(marcconv_env,1);
      
    }
  }
#endif /*MARC_DEBUG*/

  /*Initialize sutrs records*/
  
#ifdef MARC_REDIRECT
  recordStrmOut=stdout;
#else
  if ( outFile ){
    recordStrmOut=fopen(outFile, "w");
    if(recordStrmOut==NULL){
      char m[200];
      sprintf(m, "Unable to open %s\n", outFile);
      if (ONETK_WriteLogFile(fildes, m)==-1){
	longjmp(marcconv_env,1);
      }
      longjmp(marcconv_env,1);
      
    }
  }
  recordStrmIn=rcdStrmIn;

#endif


#ifndef MARC_MULTI_TABLE
  if (strcmp(toFormat,"USMARC")==0
      ||
      strcmp(fromFormat,"USMARC")==0){
    readISBDTable(iss->isbd_tbl);
  }
#endif 
 
#ifdef MARC_MULTI_TABLE
  convset=findLookupTable(fromFormat, toFormat);
  if(lt[convset]==NULL){
    char m[200];
    sprintf(m, "convertRecordStream()\n  Tables do not exist for %s to %s\n",
	    fromFormat,
	    toFormat);
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    longjmp(marcconv_env, 1);


  }
  cns=lt[convset]->cns;
  dts=lt[convset]->dts;
  its=lt[convset]->its;
  cts=lt[convset]->cts;
  pts=lt[convset]->pts;
  xts=lt[convset]->xts;
#else /*MARC_MULTI_TABLE*/
  cns=(conversion_tbl_str *)calloc(1, sizeof(conversion_tbl_str));
  for (q=0;q<1000;q++)
    cns->Conversion_Table[q]=lt[convset]->Conversion_Table[q];
  readCtrlTable(fromFormat , toFormat, cns);
  readVdfTable(fromFormat , toFormat, cns);
  dts=readDecisionTable(fromFormat, toFormat);
  its=readIndicatorTable(fromFormat, toFormat);
  cts=readConditionalTable(fromFormat, toFormat);
  pts=readPrefixTable(fromFormat, toFormat);
  xts=readXiferpTable(fromFormat, toFormat);

#endif/*MARC_MULTI_TABLE*/


  if ( !recordStrIn )
     {
     use_files_flag = -1;
 
     recordStrIn=readToEOR(recordStrmIn);
     } /* End if */
  rcdCtr=0;
  while(recordStrIn!=(char *)EOF /*&& rcdCtr <  20*/){
    rcdCtr++;
    /** to do:
     * MAKE A MECHANISM TO SAVE ISBD-TABLE-SPACE WHEN
     * toFormat != USMARC
     **/
    recordStrOut=NULL;
    if (recordStrIn!=NULL)
      recordStrOut=convertRecord(fromFormat,
				 toFormat,
				 recordStrIn
				 , Sutrs_In, Sutrs_Out
				 , cns->Conversion_Table
				 , pts
				 , xts
				 , dts
				 , its
				 , cts
				 , iss->isbd_tbl);

#ifdef MARC_DEBUG
    if (recordStrOut!=NULL 
	&& 
	strncmp(recordStrOut, "SUTRS_ARRAY_LENGTH exceeded",25)==0)
      goto ThatsIt;
#endif

    if (recordStrOut==NULL && recordStrIn==(char *)EOF)
      goto ThatsIt;
    else 
      if (recordStrOut!=NULL && use_files_flag ){
      fputs(recordStrOut , recordStrmOut);
      free(recordStrOut);
      }
    if (recordStrIn!=NULL && use_files_flag )
      free(recordStrIn);

    /* Only allowed to convert one record at a time via memory */
    /* otherwise memory requirements could be too great        */

    if ( !use_files_flag )
       break;

    recordStrIn=readToEOR(recordStrmIn);

  }
ThatsIt:
  for (i=0;i<SUTRS_ARRAY_LENGTH;i++){
    if (Sutrs_In[i]==NULL)
      break;
#ifdef MARC_DEBUG
    fprintf(lineFIn,"%s\n------------------------------------------------------------------------\n",Sutrs_In[i]);
#endif /*MARC_DEBUG*/
    free(Sutrs_In[i]);
  }
  for (i=0;i<SUTRS_ARRAY_LENGTH;i++){
    if (Sutrs_Out[i]==NULL)
      break;
#ifdef MARC_DEBUG
    fprintf(lineFOut,"%s\n------------------------------------------------------------------------\n",Sutrs_Out[i]);
#endif /*MARC_DEBUG*/
    free(Sutrs_Out[i]);
  }

#ifdef MARC_DEBUG
   fclose( lineFIn );
   fclose( lineFOut );
#endif

if ( !use_files_flag )
   {
   *precordStrOut = recordStrOut;
   return( (FILE*)-1 );
   } /* End if */

return recordStrmOut;
}


#ifndef _ONETK_LIB_BUILD_

void *MARCconv(){
  /*
   * MAIN ROUTINE OF THE MARC CONVERTER
   * when outside the toolbox
   */
  
  FILE *inRcdfile, *outRcdfile ;
  char *fromFormatName;
  char *toFormatName;
  char *Sutrs_array_In[SUTRS_ARRAY_LENGTH];
  char *Sutrs_array_Out[SUTRS_ARRAY_LENGTH];
  int i,h;
#ifndef MARC_REDIRECT
  char *tmpRecName;
#endif /*MARC_REDIRECT*/
/*
 * Barry Change comment.  The following has been added so enable the
 * recordTest.2 file to be located anywhere in the file system. See path.c
 * for further comments on this facility.
 */
  
/*INTEGRATION COMMENT 2
 * the two lines below determine the input and output MARC formats.
 * The fromFormatName and toFormatName will have to come from a
 * Z39.50 APDU, or some other program bit that determines the
 * formats. The choice of table files is determined by processing 
 * the two format names. see readConversionTables(), readDecisionTable(),
 * and the call to readISBDTable().
 */

/*
 * We have gone over to use an array  of
 * lookup tables. The table we need to test will now
 * be represented in one line of the file "table_of_the_day"
 * e.g. {LIBRISMARC} {UKMARC}, and the correct number 
 * (the position of the a.m. line in the file) is sent 
 * with convertRecordStream. For the time being we assume 
 * that the 0th line 
 * contains our two formats.
*/
#ifdef MARC_MULTI_TABLE
  FILE *fromTo, *rcdFileNames ,*recordStrmIn, *recordStrmOut;
  char *pathFileName, *pathRcdFileNames, *rcdStrmInName, *rcdStrmOutName ;

  /*
   * initialize "sutrs" arrays:
   */

  for (h=0;h< SUTRS_ARRAY_LENGTH;h++){
    Sutrs_array_In[h]=NULL;
    Sutrs_array_Out[h]=NULL;
  }

  /*
   * Retrieve formats to convert between 
   */
  pathFileName=ONETK_FilePath("fromToFormat.txt");
  fromTo=fopen(pathFileName,"r");
  if(fromTo==NULL){
      char m[200];
      sprintf(m, "Unable to open %s\n", pathFileName);
      if (ONETK_WriteLogFile(fildes, m)==-1){
	longjmp(marcconv_env,1);
      }
      longjmp(marcconv_env,1);
    
  }
  fromFormatName=readStringItem(fromTo);
  toFormatName=readStringItem(fromTo);
  fclose(fromTo);

  TABREAD();
  mtrace();
#else /*MARC_MULTI_TABLE*/
  fromFormatName=(char *)malloc(12*sizeof(char));
  toFormatName=(char *)malloc(12*sizeof(char));
  strcpy(fromFormatName,"LIBRISMARC");
  strcpy(toFormatName, "UKMARC");
#endif /*MARC_MULTI_TABLE*/



  pathRcdFileNames =ONETK_FilePath("recordFileNames.txt");
  rcdFileNames=fopen(pathRcdFileNames, "r");
  if (rcdFileNames==NULL){
      char m[200];
      sprintf(m, "Unable to open %s\n", pathRcdFileNames);
      if (ONETK_WriteLogFile(fildes, m)==-1){
	longjmp(marcconv_env,1);
      }
      longjmp(marcconv_env,1);
    
  }
  free(pathRcdFileNames);
  if (rcdFileNames==NULL){
    char m[200];
    
    sprintf(m, "file recordFileNames.txt not found\n");
    if (ONETK_WriteLogFile(fildes, m)==-1){
      longjmp(marcconv_env,1);
    }
    longjmp(marcconv_env, 1);
  }  
  rcdStrmInName=readStringItem(rcdFileNames);
  recordStrmIn=fopen(rcdStrmInName ,"r");
  if(recordStrmIn==NULL){
      char m[200];
      sprintf(m, "Unable to open %s\n", rcdStrmInName);
      if (ONETK_WriteLogFile(fildes, m)==-1){
	longjmp(marcconv_env,1);
      }
      longjmp(marcconv_env,1);
    
  }

  rcdStrmOutName=readStringItem(rcdFileNames);
  fclose(rcdFileNames);


/*
 * INTEGRATION COMMENT 3
 * The passing of MARC data to the converter will happen 
 * before the converter is called.
 */
#ifdef MARC_REDIRECT
  inRcdfile=stdin;
#else
#endif  
#ifndef _ONETK_LIB_BUILD_  
  rcd_cnt=0;
#endif
  outRcdfile=convertRecordStream(
#ifdef _ONETK_LIB_BUILD_
				 inRcdfile,
#else
				 recordStrmIn,
#endif
				 fromFormatName, 
				 toFormatName,
				 Sutrs_array_In,
				 Sutrs_array_Out,
#ifdef _ONETK_LIB_BUILD_
				 "test.txt",
#else
				 rcdStrmOutName,
#endif
				 NULL, NULL, NULL, NULL );
  fclose(outRcdfile);
  /*TABFREE();*/
  
}

int main(){
  char *test;
  


  if (setjmp(marcconv_env) != 0)
      exit( 0 );

  readTexts=TRUE;

  MARCconv();
  muntrace();
}

#endif /* _ONETK_LIB_BUILD_ */













