/* * * * * * * * * * * * * * * * *     
 *  MARCconv        Version 2.3  *
 *   File:     controlFields.c   *     
 *    Converting control and     *
 *      coded data fields        *
 *    Last update: 28/01/1997    *     
 *      Michael S. Preminger     *     
 *      BRODD, OSLO COLLEGE      *     
 *        THE ONE PROJECT        *     
 * * * * * * * * * * * * * * * * */    

#include "MARCproto.h"


extern jmp_buf marcconv_env;
char *Unimarc_date_modify(char *outstr,
			  subPortionTable_Control *tbl,
			  int idx
			  ){
  /**Search the pre-defined date table, to determine
    whether a to_unimarc date conversion is applicable**/
  return outstr;
}
char *Util_makeSubString(char *string,
			 int length,
			 int startPositionInString)
{
  char *subStr = (char *) NULL;
  int k;  
  
  subStr= (char *)calloc((length+1),sizeof(char));
  for (k=0;k<length;k++)
    subStr[k]=*(string+startPositionInString+k);
  subStr[k]='\0';
  return subStr;
  
}
char *controlFieldsUpdateIndicators(field *fromFld,
				    indicator_table_str *its,
				    record *fromRcd){
  /*
   * The function returns the string "%[ind1][ind2]"
   * That goes directly into the field structure
   */  
  
  char ind;
  char *tmpInd=(char *)calloc(4,sizeof(char));
  char *fromFormat=fromRcd->format;
  memset(tmpInd, '%', 1);

  

  /*indicator1*/
  ind=setIndicatorZ(1,'\0',fromRcd,fromFld,its,NULL);
  if (ind!='\0')
    memset(tmpInd+1, ind, 1);
  else
    memset(tmpInd+1, '#', 1);
  /*indicator2*/
  ind=setIndicatorZ(2,'\0',fromRcd,fromFld,its,NULL);
  if (ind!='\0')
    memset(tmpInd+2, ind, 1);
  else
    memset(tmpInd+2, '#', 1);
  
  return tmpInd;
}
char *ControlFieldsFindIndicators(field *fld, InitialIndicatorTable *init_ind_tbl){

  /*Field tags which indicators are always blank (undefined) are not
    in the table*/
  
  dataField *dtfld;
  int i;
  

  dtfld=fld->datafield;
  for(i=0;i<init_ind_tbl->ArrayLength;i++){
    if (memcmp(init_ind_tbl->tag[i],dtfld->tag,3)==0)
      return init_ind_tbl->indicators[i];
  }
  return (char *)NULL;
  
  
  /**If any of the non-NULL table entries has a predefined control 
    character, 
    for any of the indicators, a special table
    is consulted.
    **/

  /**Look at spcific  case tables**/

}

int *convertControlField(record *rcd_in,
			 int fromFieldIndex,
			 record *rcd_out,
			 PortionTable_Control *cfpPtr,
			 indicator_table_str *its /*
						   * needed for 
						   *treating UNIMARC 
						   *indicators 
						   */
			 /*int *fromSFIndex*/
			 )
     /*
	A control field from the incoming record (non unimarc)
	is converted, and result returned in an adequate output field.
	*/
/*convertcontrolfields*/{
  /*Counters*/
  int i;                        /*Position in FROM sub Field*/
  int ii;			
  int j;			/*Position in table (table index)*/
  int k; 
  field *fromField=rcd_in->fields[fromFieldIndex];
  controlField *fromCFPtr;
  dataField *fromDtFld;
  char consultedpos[2];
  subPortionTable_Control *cfspPtr;
  field *toFieldPtr;
  Boolean codeC_encountered_fromValue; 
  Boolean codeC_encountered_toValue ;
  char *dataString;
  int dataLength;
  /*FIND CORRECT SUB TABLE PORTION*/

  if (fromField->ctrlfield!=NULL){
    fromCFPtr=fromField->ctrlfield;
    switch (atoi(fromCFPtr->tag)){
    case 8:{			/*008*/
      consultedpos[0]=rcd_in->leader[6];
      consultedpos[1]=rcd_in->leader[7];
      
      for (ii=0;ii<cfpPtr->Arraylength;ii++){
	
	if ( cfpPtr->consultValue1[ii]!=NULL
	     &&
	     ( strchr(cfpPtr->consultValue1[ii],consultedpos[0])!=NULL) 
	     &&
	     ( cfpPtr->consultValue2[ii]==NULL 
	       ||
	       strchr(cfpPtr->consultValue2[ii],consultedpos[1])!=NULL
	       )	      
	     )
	  {
	    cfspPtr =cfpPtr->subPortion_CTL[ii];
	    break;		/*(exit from for loop)*/
	    
	  }
      }
      if (ii==cfpPtr->Arraylength){
	char *m, *n;
	m=(char *)calloc(250, sizeof(char));
	sprintf(m, 
		"convertConvtrolField()\n   Unable to update this type of record. Conversion table (008) not updated for the types %c and %c, record not converted:\n %s\n",
		consultedpos[0],
		consultedpos[1],
		rcd_in->fields[1]->ctrlfield->data
		);
	
	
	if (ONETK_WriteLogFile(fildes, m)==-1){
	  /**Error handle**/
	  longjmp(marcconv_env, 1);
	  
	}
	n=(char *)calloc(200, sizeof(char));
	sprintf(n,
		"Unable to convert this type of record. Leader:  %s\n",
		rcd_in->leader
		);
	makePrivateField_FULL(rcd_in->format,
			      rcd_out,
			      rcd_in->fields[fromFieldIndex],
			      n
			      );
	free (m);
	free(n);
	return -1;
      }
    }
      break;
    case 6:
    case 7:{			/*006/7*/
      /**consult position 0 of the field for 006/7,
	and find the correct portion of the control
	field conversion table.
	**/
      for (ii=0;ii<cfpPtr->Arraylength;ii++)
	if (cfpPtr->consultValue1[ii]!=NULL 
	    &&
	    memcmp(cfpPtr->consultValue1[ii],fromCFPtr->data+0,1)==0)
	  break;		/*(exit from for loop)*/
      if (ii==cfpPtr->Arraylength){
	char *m, *n;
	m=(char *)calloc(250, sizeof(char));
	sprintf(m, 
		"convertConvtrolField()\n   Unable to update this type of record. Conversion table  not updated for the types %c and %c, record not converted:\n %s\n",
		consultedpos[0],
		consultedpos[1],
		rcd_in->fields[1]->ctrlfield->data
		);

      
	if (ONETK_WriteLogFile(fildes, m)==-1){
	  /**Error handle**/
	  longjmp(marcconv_env, 1);
	}
	n=(char *)calloc(200, sizeof(char));
	sprintf(n,
		"Unable to convert this type of record. Leader:  %s\n",
		rcd_in->leader
		);
	makePrivateField_FULL(rcd_in->format,
			      rcd_out,
			      rcd_in->fields[fromFieldIndex],
			      n
			      );
	free (m);
	free(n);
	return -1;
      }
      
      
      cfspPtr =cfpPtr->subPortion_CTL[ii];
  
    }
      break;
    case 1:
    case 3:                     /*003*/
    case 0:{			/*000*/
      /**000, go directly to the only sub portion**/
      cfspPtr =cfpPtr->subPortion_CTL[0]; 
  
    }
      break;
    default:{
  
    }
    }
    dataString=fromCFPtr->data;
    dataLength=strlen(dataString);
    
  }
  else{				/*WE ARE DEALING WITH A CODED DATA SUB-FIELD*/
    subField *sf=findSubField(fromField, cfspPtr->fromSubField[0]);
    if (sf==NULL){
   
    }
    dataString=sf->data;
    dataLength=strlen(dataString);
  } 
  i=0;j=0;
  while (i<dataLength		/*All positions(subFields) in field*/ 
	 &&  
	 j<cfspPtr->Arraylength
	 &&  
	 cfspPtr->fromPosition[j]<dataLength
	 )
    
    /*mainwhile*/{ 
      char *copy = (char *) NULL;
      if (i<cfspPtr->fromPosition[j])
	/*FIRST POSITION IN SUBFIELD NOT USED. GO TO NEXT POSITION*/
	i=cfspPtr->fromPosition[j];
      if (strlen(cfspPtr->fromValue[j])>1
	  ||
	  memcmp(cfspPtr->fromValue[j],"N",1)==0 
	  ||
	  memcmp(cfspPtr->fromValue[j],"C",1)==0){ 
	
	

	char *modifiedCopy;
	int c_table_position=-1;
	
	/*CREATE A NULL terminated COPY OF THE STRING TO
	  ALLOW CONVENIENT  PASSING OF ARGUMENTS*/
	copy=Util_makeSubString(dataString,cfspPtr->fromLength[j],i);

	codeC_encountered_fromValue=FALSE;
	codeC_encountered_toValue=FALSE;

	while(cfspPtr->fromPosition[j]==i)
	  {
	    if (memcmp(cfspPtr->fromValue[j],"N",1)==0)
	      {
		modifiedCopy=Unimarc_date_modify(copy,cfspPtr,j);
		toFieldPtr 
		  = ControlField_CopyDirect(rcd_out,
					    cfspPtr,
					      
					    /*Array Index with information*/
					    j,
					      
					    modifiedCopy
					    ); 
		if (toFieldPtr==NULL){
		  if (copy!=NULL){
		    free(copy);
		    copy=NULL;
		  }
		  break;
		}
		if (toFieldPtr->datafield!=NULL
		    &&
		    its!=NULL){
		  char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
		  strncpy(toFieldPtr->datafield->indicators, inds,3);
		  free(inds);
		}
		if (copy!=NULL){
		  free(copy);
		  copy=NULL;
		}
		break;		/*Exit WHILE loop*/
		  
	      }
	      
	    /*subfield substring matches a table given string?*/
	    if (memcmp(copy,cfspPtr->fromValue[j],cfspPtr->fromLength[j])==0)
	      {
		toFieldPtr 
		  = ControlField_CopyFromTable(rcd_out,
					      cfspPtr,
					      j);
		if (toFieldPtr==NULL){
		  if (copy!=NULL)
		    free( copy );
		  break;
		}
		if (toFieldPtr->datafield!=NULL
		    &&
		    its!=NULL){
		  char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
		  strncpy(toFieldPtr->datafield->indicators, inds,3);
		  free(inds);
		    
		}
		if (copy!=NULL)
		  free( copy );
		break;		/*Exit WHILE loop*/
	      }
	    if (memcmp(cfspPtr->fromValue[j],"C",1)==0)
	      {
		codeC_encountered_fromValue=TRUE;
		if ((memcmp(cfspPtr->toValue[j],"C",1)==0))
		  codeC_encountered_toValue=TRUE;
		else		/*remember table position*/
		  c_table_position=j;
	      }
	    j++;
	  } /*WHILE cfspPtr->fromPosition[j]==i*/

	/*Check if the wHILE loop is "broken from" or exited normally*/
	if (cfspPtr->fromPosition[j]!=i || j>=cfspPtr->Arraylength){

	  /*since while exited normally, index j exceeds 
	    points to the next field position to be treated.
	    The correct from_position is pointed to by j-1*/
	  if (codeC_encountered_fromValue==TRUE){
	    if (codeC_encountered_toValue==TRUE){
		  
	      /*
	       * copy from the from_field position
	       */
	      toFieldPtr = ControlField_CopyDirect(rcd_out,
						   cfspPtr,
						   j-1,
						   copy
						   );
	    }
	    else
	      {			/*
				 * copy from the array entry where the fromC 
				 * was encountered. We want to impose a constant
				 * output string, whatever the input string was
				 */
		  if (c_table_position != -1)
		    ControlField_CopyFromTable(rcd_out,
					      cfspPtr,
					      c_table_position
					      );
		  else{
		    char m[200];
		    sprintf(m, 
			    "convertControlField()\n  Some thing very strange indeed is happening\n  Did not remember a table position\n"
			    );
		    if (ONETK_WriteLogFile(fildes, m)==-1){
		      /**Error handle**/
		    }
		    /*
		     * exit(1);
		     */
		    return 0;
		    
		  }     
		}
	      /*%%%*/
	      if (copy!=NULL){
		free(copy);
		copy=NULL;
	      }
	      if (toFieldPtr==NULL)
		break;
	      if (toFieldPtr->datafield!=NULL
		  &&
		  its!=NULL){
		char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
		strncpy(toFieldPtr->datafield->indicators, inds,3);
		free(inds);
	      
	      }
	    }
	    else{/*If table  indicates neither what should be put a position- 
		   nor that the contents in from field is copied directly -
		   Put blanks into the position in the field*/
	      
	      /*BUILD a string of blanks with length = toLength[j-1]. remember the NULL!!*/
	      copy=malloc(cfspPtr->toLength[j-1]+1); /*We have advanced 1 beyond the correct j*/
	      memset(copy,' ',cfspPtr->toLength[j-1]);
	      *(copy+cfspPtr->toLength[j-1])='\0';
	      toFieldPtr = ControlField_CopyDirect(rcd_out,
						   cfspPtr,
						   j-1,
						   copy
						   );
	      if (toFieldPtr==NULL){
		free(copy);
		copy=NULL;
		break;
	      }
	      if (toFieldPtr->datafield!=NULL
		  &&
		  its!=NULL){
		char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
		strncpy(toFieldPtr->datafield->indicators, inds,3);
		free(inds);
	      }
	      free(copy);
	      copy=(char *)NULL;
	    }

	  }/*if (cfspPtr->fromPosition[j]!=i)*/
       }/*if (strlen(cfspPtr->fromValue[j])>1)*/

	else {
	    /*CHARACTER SEQUENCES*/
	    int l;
	    char *pad;
	    pad=(char *)malloc((1+cfspPtr->toLength[j])*sizeof(char));
	    memset(pad, ' ',cfspPtr->toLength[j]);
	    memset(pad +cfspPtr->toLength[j], '\0',1);

	    /*We are padding the region in the to field string with blanks,
	     to compansate for missing data in the from field*/
	    toFieldPtr = ControlField_CopyByPosition(rcd_out,
						     cfspPtr,
						     0,
						     j,
						     pad);
	    if (toFieldPtr==NULL){
	      free(pad);
	      break;
	    }
	    if (toFieldPtr->datafield!=NULL
		&&
		its!=NULL){
	      char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
	      strncpy(toFieldPtr->datafield->indicators, inds,3);
	      free(inds);
	    }

	    free(pad);
	    while(cfspPtr->fromPosition[j]==i)
	      {
		/*This can (and will ) be done by turning around the "for" and the "while"*/
		for (l=0;l<cfspPtr->fromLength[j];l++){
		  if (*(dataString + i + l) == *(cfspPtr->fromValue[j])){
		    /*Check if there is a toTag in the table*/
/* ROB mod here - not sure about this one */
/*		    if (cfspPtr->toTag[j]!=NULL){
*/
		    if ((cfspPtr->toTag[j]!=NULL) && (cfspPtr->toValue[j]!=NULL)){
/* end of Rob mod */
		      toFieldPtr 
			= ControlField_CopySeqChar(rcd_out,
						    cfspPtr,
						    j
						   );
		      if (toFieldPtr==NULL){
			if (copy!=NULL){
			  free(copy);
			  copy=(char *)NULL;
			}
			break;
		      }
		      if (toFieldPtr->datafield!=NULL
			  &&
			  its!=NULL){
			char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
			strncpy(toFieldPtr->datafield->indicators, inds,3);
			free(inds);

		      }

		      /* 
		       * if (copy!=NULL)
		       * free(copy);
		       */
		    }
		    else{
		      /**ADD TAG TO PORTION TABLE!!**/
		      char m[200];
		      sprintf(m, 
			      "convertConvtrolField()\n   missing to-tag in conversion table\n");
		      if (ONETK_WriteLogFile(fildes, m)==-1){
			/**Error handle**/
		      }
		    }
		    break;
		    
		  }/*if (*(fromCFPtr...*/
		}/*for (l=i;l<...*/
		j++;
	      }/*while(cfspPtr->...*/
           }/*ELSE LOOP*/				     

      /*
       * Next piece of data in from-field
       */
      
      if (i==cfspPtr->fromPosition[j]){
	/*WHILE broken*/
	i=i+cfspPtr->fromLength[j];
      }
      else 
	if (i==cfspPtr->fromPosition[j-1])
	  /*WHILE terminated without 'breaking'*/
	  i=i+cfspPtr->fromLength[j-1];
	else{
	  char m[200];
	  sprintf(m, 
		  "convertControlField()\n   Something very strange is going on: \n"
		  );
	  if (ONETK_WriteLogFile(fildes, m)==-1){
	    /**Error handle**/
	    longjmp(marcconv_env, 1);
	  }
	  return 0;
	}
      
      
      /*
       * If one or more  positions are ignored in the table.
       * the field position variable <i> has to climb to the
       * first position after these.
       */
      while (i<cfspPtr->fromPosition[j] && i<dataLength)
	      i++;
      /*Adjust table position to the new field position if necessary*/
      while (cfspPtr->fromPosition[j]<i && j< cfspPtr->Arraylength){
	j++;
	
      }
  }
  return 0;
}
int *convertCodedDataSF(record *rcd_in,
			int fromFieldIndex,
			int fromSFIndex,
			record *rcd_out,
			PortionTable_Control *cfpPtr,
			indicator_table_str *its /*
						   * needed for 
						   *treating UNIMARC 
						   *indicators 
						   */
			 /*int *fromSFIndex*/
			 )
     /*
	A control field from the incoming record (non unimarc)
	is converted, and result returned in an adequate output field.
	*/
/*convertcontrolfields*/{
  /*Counters*/
  int i;                        /*Position in FROM sub Field*/
  int ii;			
  int j;			/*Position in table (table index)*/
  int k; 
  field *fromField=rcd_in->fields[fromFieldIndex];
  dataField *fromDF;
  subField *fromSF;
  subPortionTable_Control *cfspPtr;
  field *toFieldPtr;
  Boolean codeC_encountered_fromValue; 
  Boolean codeC_encountered_toValue ;
  char *dataString;
  int dataLength;
  char fromSFcode;
  /*FIND CORRECT SUB TABLE PORTION*/
#ifdef MARC_TEST_VARIABLES  
  globRecord=rcd_out;
#endif /*MARC_TEST_VARIABLES*/
  if (fromField->datafield!=NULL){
    fromDF=fromField->datafield;
    fromSF=fromDF->subFields[fromSFIndex];
    fromSFcode=fromSF->subFieldCode;
    dataString=fromSF->data;
    dataLength=strlen(dataString);
    
  }
  else{				
    char m[200];
    sprintf(m, 
	    "convertcodedDataSF()\n   strange error - wrong type of field\n"
	    );
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    /*
     * exit(1);
     */
    longjmp(marcconv_env, 1);
  } 
  cfspPtr =cfpPtr->subPortion_CTL[0]; 

  /*find the correct part of the table*/
  for (j=0;j<cfspPtr->Arraylength;j++){
    if (cfspPtr->fromSubField[j]==fromSFcode)
      break;
  }
  if (j==cfspPtr->Arraylength){
    char m[200];
    sprintf(m, 
	    "convertcodedDataSF()\n field %s  sub field $%c not convertable by table file %s\n",
	    fromDF->tag,
	    fromSFcode,
	    getFileName(rcd_in->format, rcd_out->format, "control")
	    );
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }

    return 0;
  }
  i=0;
  while (i<dataLength		/*All positions(subFields) in field*/ 
	 &&  
	 j<cfspPtr->Arraylength
	 &&
	 cfspPtr->fromSubField[j]==fromSFcode
	 )
    { 
      char *copy=(char *)NULL;
      if (i<cfspPtr->fromPosition[j])
	/*FIRST POSITION IN SUBFIELD NOT USED. GO TO NEXT POSITION*/
	i=cfspPtr->fromPosition[j];

      if (strlen(cfspPtr->fromValue[j])>1
	  ||
	  memcmp(cfspPtr->fromValue[j],"N",1)==0 
	  ||
	  memcmp(cfspPtr->fromValue[j],"C",1)==0){ 
	
	

	char *modifiedCopy;
	int c_table_position=-1;
	
	/*CREATE A NULL terminated COPY OF THE STRING TO
	  ALLOW CONVENIENT  PASSING OF ARGUMENTS*/
	copy=Util_makeSubString(dataString,cfspPtr->fromLength[j],i);

	codeC_encountered_fromValue=FALSE;
	codeC_encountered_toValue=FALSE;

	while(j<cfspPtr->Arraylength && cfspPtr->fromPosition[j]==i
	      && 
	      cfspPtr->fromSubField[j]==fromSFcode
	      )
	  {
	    if (memcmp(cfspPtr->fromValue[j],"N",1)==0)
	      {
		modifiedCopy=Unimarc_date_modify(copy,cfspPtr,j);
		toFieldPtr 
		  = ControlField_CopyDirect(rcd_out,
					    cfspPtr,
					      
					    /*Array Index with information*/
					    j,
					      
					    modifiedCopy
					    ); 
		if (toFieldPtr==NULL){
		  if (copy!=NULL)
		    free(copy);
		  break;
		}
		if (toFieldPtr->datafield!=NULL
		    &&
		    its!=NULL){
		  char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
		  strncpy(toFieldPtr->datafield->indicators, inds,3);
		  free(inds);
		}
		if (copy!=NULL){
		  free(copy);
		  copy=NULL;
		}
		break;		/*Exit WHILE loop*/
		  
	      }
	      
	    /*subfield substring matches a table given string?*/
	    if (memcmp(copy,cfspPtr->fromValue[j],cfspPtr->fromLength[j])==0)
	      {
		toFieldPtr 
		  = ControlField_CopyFromTable(rcd_out,
					      cfspPtr,
					      j);
		if (toFieldPtr==NULL){
		  if (copy!=NULL)
		    free( copy );
		  break;
		}

		if (toFieldPtr->datafield!=NULL
		    &&
		    its!=NULL){
		  char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
		  strncpy(toFieldPtr->datafield->indicators, inds,3);
		  free(inds);
		    
		}
		if (copy!=NULL)
		  free( copy );
		break;		/*Exit WHILE loop*/
	      }
	    if (memcmp(cfspPtr->fromValue[j],"C",1)==0)
	      {
		codeC_encountered_fromValue=TRUE;
		if ((memcmp(cfspPtr->toValue[j],"C",1)==0))
		  codeC_encountered_toValue=TRUE;
		else		/*remember table position*/
		  c_table_position=j;
	      }
	    j++;
	  } /*WHILE cfspPtr->fromPosition[j]==i*/

	/*Check if the wHILE loop is "broken from" or exited normally*/
	if (cfspPtr->fromPosition[j]!=i || j>=cfspPtr->Arraylength
	    || 
	    cfspPtr->fromSubField[j]!=fromSFcode
	    ){

	  /*since while exited normally, index j exceeds 
	    points to the next field position to be treated.
	    The correct from_position is pointed to by j-1*/
	  if (codeC_encountered_fromValue==TRUE){
	    if (codeC_encountered_toValue==TRUE){
		  
	      /*
	       * copy from the from_field position
	       */
	      toFieldPtr = ControlField_CopyDirect(rcd_out,
						   cfspPtr,
						   j-1,
						   copy
						   );
	    }
	    else
	      {			/*
				 * copy from the array entry where the fromC 
				 * was encountered. We want to impose a constant
				 * output string, whatever the input string was
				 */
		  if (c_table_position != -1)
		    ControlField_CopyFromTable(rcd_out,
					      cfspPtr,
					      c_table_position
					      );
		  else{
		    char m[200];
		    sprintf(m, 
			    "convertControlField()\n  Some thing very strange indeed is happening\n  Did not remember a table position\n"
			    );
		    if (ONETK_WriteLogFile(fildes, m)==-1){
		      /**Error handle**/
		    }
		    /*
		     * exit(1);
		     */
		    return 0;
		    
		  }     
		}
	      /*%%%*/
	    if (copy!=NULL){
	     free(copy);
	     copy=NULL;
	    }
	   if (toFieldPtr==NULL)
	     break;
	      if (toFieldPtr->datafield!=NULL
		  &&
		  its!=NULL){
		char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
		strncpy(toFieldPtr->datafield->indicators, inds,3);
		free(inds);
	      
	      }
	  }
	    else{/*If table  indicates neither what should be put a position- 
		   nor that the contents in from field is copied directly -
		   Put blanks into the position in the field*/
	      
	      /*BUILD a string of blanks with length = toLength[j-1]. remember the NULL!!*/
	      copy=malloc(cfspPtr->toLength[j-1]+1); /*We have advanced 1 beyond the correct j*/
	      memset(copy,' ',cfspPtr->toLength[j-1]);
	      *(copy+cfspPtr->toLength[j-1])='\0';
	      toFieldPtr = ControlField_CopyDirect(rcd_out,
						   cfspPtr,
						   j-1,
						   copy
						   );
	      if (toFieldPtr==NULL){
		free(copy);
		copy=(char *)NULL;
		break;
	      }
	      if (toFieldPtr->datafield!=NULL
		  &&
		  its!=NULL){
		char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
		strncpy(toFieldPtr->datafield->indicators, inds,3);
		free(inds);
	      }
	      free(copy);
	      copy=(char *)NULL;
	    }

	  }/*if (cfspPtr->fromPosition[j]!=i)*/
       }/*if (strlen(cfspPtr->fromValue[j])>1)*/

	else {
	    /*CHARACTER SEQUENCES*/
	    int l;
	    char *pad;
	    pad=(char *)malloc((1+cfspPtr->toLength[j])*sizeof(char));
	    memset(pad, ' ',cfspPtr->toLength[j]);
	    memset(pad +cfspPtr->toLength[j], '\0',1);

	    /*We are padding the region in the to field string with blanks,
	     to compansate for missing data in the from field*/
	    toFieldPtr = ControlField_CopyByPosition(rcd_out,
						     cfspPtr,
						     0,
						     j,
						     pad);
	    if (toFieldPtr==NULL){
	      free(pad);
	      break;
	    }
	    if (toFieldPtr->datafield!=NULL
		&&
		its!=NULL){
	      char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
	      strncpy(toFieldPtr->datafield->indicators, inds,3);
	      free(inds);
	    }

	    free(pad);
	    while(cfspPtr->fromPosition[j]==i)
	      {
		/*This can (and will ) be done by turning around the "for" and the "while"*/
		for (l=0;l<cfspPtr->fromLength[j];l++){
		  if (*(dataString + i + l) == *(cfspPtr->fromValue[j])){
		    /*Check if there is a toTag in the table*/
/* ROB mod here - not sure about this one */
/*		    if (cfspPtr->toTag[j]!=NULL){
*/
		    if ((cfspPtr->toTag[j]!=NULL) && (cfspPtr->toValue[j]!=NULL)){
/* end of Rob mod */
		      toFieldPtr 
			= ControlField_CopySeqChar(rcd_out,
						    cfspPtr,
						    j
						    );
		      if (toFieldPtr==NULL){
			free(copy);
			copy=(char *)NULL;
			break;
		      }
		      if (toFieldPtr->datafield!=NULL
			  &&
			  its!=NULL){
			char *inds=controlFieldsUpdateIndicators(fromField, its, rcd_in);
			strncpy(toFieldPtr->datafield->indicators, inds,3);
			free(inds);

		      }
		      /*if (copy!=NULL)
			free(copy);*/
		    }
		    else{
		      /**ADD TAG TO PORTION TABLE!!**/
		      char m[200];
		      sprintf(m, 
			      "convertConvtrolField()\n   missing to-tag in conversion table\n");
		      if (ONETK_WriteLogFile(fildes, m)==-1){
			/**Error handle**/
		      }
		    }
		    break;
		    
		  }/*if (*(fromCFPtr...*/
		}/*for (l=i;l<...*/
		j++;
	      }/*while(cfspPtr->...*/
           }/*ELSE LOOP*/				     

      /*
       * Next piece of data in from-field
       */
      
      if (/* j<cfspPtr->Arraylength 
	  ||*/
	  i==cfspPtr->fromPosition[j]){
	/*WHILE broken*/
	i=i+cfspPtr->fromLength[j];
      }
      else 
	if (i==cfspPtr->fromPosition[j-1])
	  /*WHILE terminated without 'breaking'*/
	  i=i+cfspPtr->fromLength[j-1];
	else{
	  char m[200];
	  sprintf(m, 
		  "convertControlField()\n   Something very strange is going on: \n"
		  );
	  if (ONETK_WriteLogFile(fildes, m)==-1){
	    /**Error handle**/
	    longjmp(marcconv_env, 1);
	  }
	  return 0;
	}
      
      
      /*
       * If one or more  positions are ignored in the table.
       * the field position variable <i> has to climb to the
       * first position after these.
       */
      while (i<cfspPtr->fromPosition[j] && i<dataLength)
	      i++;
      /*Adjust table position to the new field position if necessary*/
      while (cfspPtr->fromPosition[j]<i 
	     &&
	     j<cfspPtr->Arraylength 
	     && 
	     cfspPtr->fromSubField[j]==fromSFcode ){
	j++;
	
      }
    }
  return 0;
}
























