/* * * * * * * * * * * * * * * * *    
	  *  MARCconv        Version 2.3  *
	  *   File:    dataFields_cnd.c   * 
	  *   Conditional conversion of   * 
	  *           sub fields          * 
	  *    Last update: 28/01/1997    * 
	  *      Michael S. Preminger     * 
	  *      BRODD, OSLO COLLEGE      * 
	  *        THE ONE PROJECT        * 
	  * * * * * * * * * * * * * * * * */

#include <setjmp.h>

#include "MARCproto.h"


extern jmp_buf marcconv_env;

char *trim(char *str){
  char *tmp=(char *)malloc((1+strlen(str))*sizeof(char));
  int ileft=0, iright=strlen(str)-1;

  memset(tmp, '\0', strlen(str)+1);

  /*Left Trim*/
  while(*(str+ileft)==' '){
    ileft++;
  }

  /*Right Trim*/
  while(*(str+iright)==' '){
    iright--;
  }

  strncpy(tmp, str+ileft, (iright-ileft)+1);
  return tmp;
}

Boolean Cnd_matchSFData(char *sfData,
			regex_t *pattern,
			char *contents
			) {
  if (contents==NULL)
    return TRUE;
  if (strlen(contents)==1){
    if (strlen(sfData)==1
	&&
	*sfData==*contents
	){
      return TRUE;
    }
    return FALSE;
  }
  if (regexec(pattern, sfData, 0,NULL,REG_NOTBOL)==0)
    return TRUE;
  return FALSE;
}


Boolean contentMatch(char *sfData,
		     char *contents
		     ) {
  if (contents==NULL)
    return TRUE;
  if (strlen(contents)==1){
    if (strlen(sfData)==1
	&&
	*sfData==*contents
	){
      return TRUE;
    }
    return FALSE;
  }
  if (strstr(sfData, contents)!=NULL)
    return TRUE;
  return FALSE;
}

/**UPON EXTENDING THE REPERTOIRE OF CONVERSION ROUTINES
  FOR SUBFIELDS:
  ------------------------------------------------------
  -WRITE THE NEW ROUTINE AS AN 'INT' RETURNING FUNCTION, FOLLOWING
  THE CONVENTION IN 'directConvert()'
  -ADD THE ROUTINE TO THE SEQUENCE BELOW, AND ADD A CASE STATEMENT
  WITH AN APPROPRIATE CALL TO THE 'SWITCH-CASE' CONSTRUCT 
  IN convertSubField() DOWN THIS FILE**/


int C_directConvert(field *toFld, 
		    subField *fromSF,
		    PortionTable_Conditional *pc, 
		    int index ){
  
  subField *toSF;
  int res=0;
  
  toSF=(subField *)createSubField(toFld, *(pc->toSubField[index]));
  toSF->data=(char *)malloc((strlen(fromSF->data)+1)*sizeof(char));
  memset(toSF->data,'\0',strlen(fromSF->data)+1);
  strcat(toSF->data, fromSF->data);
  
  
  
  /**MAKE USE OF THE RETURN VALUE**/
  return res;
}

/*
 * _to_ field to be updated from a third field
 * (not the current _from_ field)
 */
int C_updateFromCopyField(record *from_rcd,
			  field *toFld, 
			  PortionTable_Conditional *pc, 
			  int index ){

  char *tag=(char *)calloc(4,sizeof(char));
  char *subFieldCodes=(char *)calloc((strlen(pc->treatment_par[index])+1),sizeof(char));
  int i, toDataLength=0;
  char *toData=(char *)malloc(MAX_RECORD_LENGTH*sizeof(char));
  subField *toSF, *copySF;
  field *copyField;

  memset(toData, '\0', 100);
  memset(tag, '\0', 4);
  tag=strncpy(tag, pc->treatment_par[index],3);
  
  subFieldCodes=strcpy(subFieldCodes, 
		       pc->treatment_par[index]+4);

  copyField=findField(from_rcd, tag);
  for (i=0;i<strlen(subFieldCodes);i++){
    if (strlen(toData) > 0) strcat(toData, ", ");
    copySF = findSubField(copyField, *(subFieldCodes+i));
    if (copySF!=NULL)
      strcat(toData, copySF->data);
  }

  toSF=(subField *)createSubField(toFld, *(pc->toSubField[index]));
  toSF->data=(char *)malloc((strlen(toData)+1)*sizeof(char));
  memset(toSF->data,'\0',strlen(toData)+1);
  strcpy(toSF->data, toData);
  free(toData);
  
}

int C_prefixSubField(field *toFld, PortionTable_Conditional *pc, int index){
}
int C_mergeSubField(field *toFld, field *fromFld, int sbFldIdx, PortionTable_Conditional *pc, int index){

  dataField *toDtFld;
  subField *fromSF, *toSF;

  int res=0;

  if (toFld->datafield==NULL){
    toFld->datafield=(dataField *)calloc(1,sizeof(dataField));
  }
  toDtFld=toFld->datafield;

  /* 
   * The entire merge will be executed upon encountering the first of the
   * source subfields in the from field. it means that the fuinction takes
   * control, finds the other from_Subfields, and performs the merge. 
   * This means that the first thing is
   * to check if the merge has already been performed. A straightforward 
   * method is to check for the  existence of the to sub field string.
   * and if it exists - the    occurence of the from subfield string 
   * in the to sub field (probably unnecessary) 
   */
  fromSF=fromFld->datafield->subFields[sbFldIdx];
  if (pc->toSubField[index]!=NULL)
    toSF=accessSubField(toFld, *pc->toSubField[index]);
  else{
    char m[200];
    sprintf(m, "C_mergeSubField()\n   Tag: %s subField: %c - Merge failed.\n toSubField[%d] has null value in conditional table portion\n", 
	    fromFld->datafield->tag, 
	    fromSF->subFieldCode,
	    index
	    );
                
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    return -1;

  }

  if (toSF->data!=NULL && 
      strlen(toSF->data)>=strlen(fromSF->data)&& 
      strstr(toSF->data,fromSF->data)!=NULL){ 
				   
    /*Merge already performed*/
    return res;
  }
  else/*merge*/{
    
    subField *tmpFromSF;
    char tmpFromSFCode;
    int sf_cnt=0;
    int i=0;
    int j=0;
    int cntSF, tmpIndex;
    int sfSize=findMergeSize(fromFld, pc->treatment_par[index]);
    int toSFDataLgt, tmpFromSFDataLgt;

    toSF->data=(char *)calloc((sfSize+1), sizeof(char));
    cntSF=strlen(pc->treatment_par[index]);

    /*
     * Go through the cell in the conversion table  containing 
     * the codes of the from sub fields to be merged, 
     * 1. find the subFields in the from record by its code
     * 2. Find the code in the conversion table and decide how
     * to merge it
     * 3. Perform the merge	 
     */
    for (i=0;i<cntSF;i++){

      tmpFromSFCode=*(pc->treatment_par[index]+i);
      tmpFromSF=findSubField(fromFld, tmpFromSFCode);

      /*Make sure that all the subfields to be merge are present
	in this from record. Otherwise you have to skip!*/
      if (tmpFromSF!=NULL){
	sf_cnt++;
	/*find correct merge code (m, p or s) in table pc*/
	/**SHOULD BE OPTIMIZED. STARTS AGAIN FOR
	  EVERY SUBFIELD MERGE. ON THE OTHER HAND IT IS
	  MORE ROBUST TO SEQUENCE ERRORS IN THE CONDITIONAL
	  TABLE.**/
	for(j=0;j<pc->ArrayLength;j++){
	  if (tmpFromSFCode==pc->fromSubFieldCode[j]
	      &&
	      conditionMet(fromFld,
			   tmpFromSF->index,
			   pc->condition[j],
			   pc->parameter[j]
			   )==TRUE){
	    break;
	  }
	
	}
	switch (pc->fromFunction[j]){
	case 'b':{		/*leading " =/"*/
	  if (sf_cnt>1) strcat(toSF->data, " =/ ");
	  strcat(toSF->data, tmpFromSF->data);
	  
	}
	break;
	case 'e':{		/*leading " = "*/
	  if (sf_cnt>1) strcat(toSF->data, " = ");
	  strcat(toSF->data, tmpFromSF->data);
	  
	}
	break;
	case 'g':{              /*leading "-" */
	  if (sf_cnt>1) strcat(toSF->data, "-");
	  strcat(toSF->data, tmpFromSF->data);

	}
	break;
	case 'h':{		/*leading " "*/
	  if (sf_cnt>1) strcat(toSF->data, " ");
	  strcat(toSF->data, tmpFromSF->data);
	  
	}
	break;
	case 'k':{		/*leading " : "*/
	  if (sf_cnt>1) strcat(toSF->data, " : ");
	  strcat(toSF->data, tmpFromSF->data);
	}
	break;
	case 'm':{		/*leading ", "*/
	  if (sf_cnt>1) strcat(toSF->data, ", ");
	  strcat(toSF->data, tmpFromSF->data);
	  
	}
	break;
	case 'n':{		/*leading " ; "*/
	  if (sf_cnt>1) strcat(toSF->data, " ; ");
	  strcat(toSF->data, tmpFromSF->data);
	  
	}
	break;
	case 'p':{		/*Put between parantheses*/
	  strcat(toSF->data, "(");
	  strcat(toSF->data, tmpFromSF->data);
	  strcat(toSF->data, ")");
	}
	break; 
	case 's':{		/*leading period*/
	  if (sf_cnt>1) strcat(toSF->data, ".");
	  strcat(toSF->data, tmpFromSF->data);
	}
	break;
	case 't':{		/*leading " / "*/
	  if (sf_cnt>1) strcat(toSF->data, " / ");
	  strcat(toSF->data, tmpFromSF->data);
	}
	break;
	case 'w':{		/*No prefix*/
	  strcat(toSF->data, tmpFromSF->data);
	}
	break;
	default: {
	  char m[200];
	  sprintf(m, "mergeSubField()\n   Tag: %s subField: %c - No merge of subField.\nProbably error in conditional table\n", 
		  fromFld->datafield->tag, 
		  tmpFromSFCode);
	  if (ONETK_WriteLogFile(fildes, m)==-1){
	    /**Error handle**/
	  }
	  
	}

	}
      }/*switch (pc->fromFunction[jj])*/
    }
    if (toSF->data!=NULL){
      toSF->data=realloc(toSF->data, 1+strlen(toSF->data));
    }
    return res;
  }/*for (i=0;i<cntSF;i++){*/
  return res;
}

int C_splitSubField(field *toFld, subField *fromSF,PortionTable_Conditional *pc, int index){
  /*This is a version of splitSubField that only splits sub fields
    that split in 2. Larger sub fieds are at the moment not split.
    The entire sub field is converted into the first of the to sub fields,
    using directConvert()*/
  int res=0;

  /*
   *  SPLIT BY CHARACTER COUNT k|l|...|n
   *  From sub field is split into subfields of k, l,...n characters
   *  long by positions. One of the number may be unknown, and
   *  denoted by 'x'. In such a case pc->treatment_par = e.g. "3|x|4" 
   */

  /*Check if split is done on number of characters k|l|...|n*/
  if (strchr(pc->treatment_par[index], '|')!=NULL){
    char subFieldCodes[10];
    int lengths[10]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1}; /*length 0 means unknown (x)*/
    char *data[10]={NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
    char *ptr=pc->treatment_par[index];
    char *nr_chr=pc->treatment_par[index]+strlen(pc->treatment_par[index])-1;
    int i,j,s,t, Nelem=0;

    for(i=0;i<strlen(pc->toSubField[index]);i++){
      subFieldCodes[i]=*(pc->toSubField[index]+i);
      while(*ptr=='|')
	ptr++;
      if (*ptr=='x')
	lengths[i]=0;
      else
	lengths[i]=toNumber(*ptr);
      ptr++;
    }
    /*update the data[] array with data*/
    /*if x is not first - start at the beginning of the array*/


    s=0;
    for (j=0;j<i;j++){

      /*If the "rest" - unknown number of characters 
	(x) is not to be taken from the end of the subfield 
	text, then we need to count from the end.*/
      if (lengths[j]==0 ){
	int t = strlen(fromSF->data);
	int k;
	for (k=i-1;k>j;k--){
	  data[k]=(char *)malloc(lengths[k]+1);
	  memset(data[k], '\0', lengths[k]+1);
	  t=t-lengths[k];
	  if (t<s){
	    /*ERROR MESSAGE*/
	  }
	  else{
	    strncpy(data[k],fromSF->data+t,lengths[k]);
	  }
	}
	/*now k is on the "rest" position of the array */
	if (t>s){
	  data[k]=(char *)malloc(((t-s)+1)* sizeof(char));
	  memset(data[k], '\0', (t-s)+1);
	  strncpy(data[k],fromSF->data+s,t-s);
	  lengths[k]=t-s;
	}
	break;
      }
      else{
	data[j]=(char *)malloc(lengths[j]+1);
	memset(data[j], '\0', lengths[j]+1);
	strncpy(data[j],fromSF->data+s,lengths[j]);
	s+=lengths[j];
      }
    }

    /*Now construct the necessary sub fields*/
    i=0;
    while (lengths[i]!=-1){

      if (lengths[i]!=0){
	subField *toSF = 
	  (subField *)createSubField(toFld, 
				     subFieldCodes[i]);
	toSF->data=data[i];
      }
      i++;
    }
  }
  else{
  
    /*  
     *   SPLIT BY DELIMITER MATCH
     */
     
    /*Check if there are more than 2 target subfields  if so - skip*/
    if (strlen(pc->toSubField[index]) == 2
	&&
	isalnum(*(pc->treatment_par[index]))==0
	/*With only two subfields to split, on an ISBD character, 
	  the splitting is going to make sense*/
	
	/*Now check that the splitting character really is on the
	  sub field*/
	&&
	strchr(fromSF->data, *(pc->treatment_par[index]))!=NULL
	)

      {
	int len1, len2;
	subField *toSF1 = 
	  (subField *)createSubField(toFld, 
				     *(pc->toSubField[index]));
	subField *toSF2 = 
	  (subField *)createSubField(toFld, 
				     *(pc->toSubField[index]+1)
				     );
      
	/*find lengths of 2 "split" strings*/
	/*len1=strcspn(fromSF->data, pc->treatment_par[index]);*/
	len1=mystrcspn(fromSF->data, pc->treatment_par[index]);
	len2=strlen(fromSF->data)- (len1+1);
      
	toSF1->data=(char *)malloc((len1+1)*sizeof(char));
	strncpy(toSF1->data, fromSF->data, len1);
	memset(toSF1->data+len1,'\0',1); /*terminate*/
	toSF2->data=(char *)malloc((len2+1)*sizeof(char));
	strncpy(toSF2->data,fromSF->data+len1+1,len2);
	memset(toSF2->data+len2,'\0',1); /*terminate*/
      }
    else /*MORE THAN 2  OR NON ISBD DELIMITERS*/ 
      C_directConvert(toFld, fromSF, pc, index);
  }
  return res;
}
int C_makeSubfield(field *toFld, subField *fromSF,PortionTable_Conditional *pc, int index){

}
int C_multiCopySubField(field *toFld, subField *fromSF,PortionTable_Conditional *pc, int index){


}
/*-------------END OF SUBFIELD ROUTINE REPERTOIRE--------------------*/

int cond_convert(record *rcd_in,
		 field *toF,
		 field *fromF,
		 int sfind, /*Position of subfield in
			      from field*/
		 char *toTag,
		 conditional_table_str *cts
		 ){
  PortionTable_Conditional *ptc;
  int i, res=0;
  dataField *df=fromF->datafield;
  subField *fromSF=df->subFields[sfind];
  char fromSfCode=df->subFieldCodes[sfind];
  char *sfdata;

  /*
   * Find correct conditional table portion
   */
  for (i=0;i<cts->ArrayLength;i++)
    if (cts->toTags[i]==NULL){
      if (strcmp(cts->fromTags[i],df->tag)==0){
	break;
      }
    }
    else{
      if (strcmp(cts->fromTags[i],df->tag)==0
	  &&
	  strcmp(cts->toTags[i],toTag)==0)
	break;
    }
  if (i==cts->ArrayLength){
    char m[200];

    sprintf(m, "cond_convert()\n  conversion table not updated for tag %s, to-tag %s\n",
	    df->tag, 
	    toTag==NULL?
	    "NONE":
	    toTag);

    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    return -1;
  }

  /*
   * Point at the correct table
   */
  ptc=cts->Table[i];

  
  sfdata=(char *)calloc(1+strlen(fromSF->data),sizeof(char));
  if (ptc->sf_contents[0]!=NULL){
    if (strlen(ptc->sf_contents[0])==1)
      /*
       * Here we treat a case in which the content of the
       * sub field is a one character code, 
       * making it important to process it without any
       * leading or trailing blanks.
       */
      sfdata=trim(fromSF->data);
    else
      strcpy(sfdata, fromSF->data);
  }
  else
    strcpy(sfdata, fromSF->data);

  /*
   * Find entry for FROM subfield
   */
  for(i=0;i<ptc->ArrayLength;i++){
    if (ptc->fromSubFieldCode[i]==fromSfCode
	&&
	conditionMet(fromF,
		     sfind,
		     ptc->condition[i],
		     ptc->parameter[i])==TRUE
	&&
	/*
	 * contentMatch(sfdata, ptc->sf_contents[i])==TRUE)
	 */
	Cnd_matchSFData(sfdata, ptc->sf_content_compExp[i], ptc->sf_contents[i])==TRUE)
      break;
  }

  /*
   * Now we have matched the data, 
   * so we dont need the temporary anymore
   */
  free(sfdata);

  if (i==ptc->ArrayLength){
    char m[200];
    sprintf(m, 
	    "Field %s, $%c not converted - $%c not found in conditional table, or condition check failed  \n", 
	    df->tag,
	    fromSfCode,
	    fromSfCode
	    );
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/

    }

    return -1;
  }

  /*
   * Go through entries, convert
   * normally
   */
  if (i<ptc->ArrayLength){
    switch(ptc->fromFunction[i]){
    case 'a':
      res=C_directConvert(toF, fromSF,ptc, i);
      break;
    case 'b':
      res=C_mergeSubField(toF,fromF, sfind, ptc, i);
      break;
    case 'e':
      res=C_mergeSubField(toF,fromF, sfind, ptc, i);
      break;
    case 'k':
      res=C_mergeSubField(toF,fromF, sfind, ptc, i);
      break;

    case 'm':
      res=C_mergeSubField(toF,fromF, sfind, ptc, i);
      break;
    case 'n':
      res=C_mergeSubField(toF,fromF, sfind, ptc, i);
      break;
    case 'p':
      res=C_mergeSubField(toF, fromF, sfind , ptc , i);
      break;
    case 's':
      res=C_mergeSubField(toF, fromF, sfind, ptc, i);
      break;
    case 't':
      res=C_mergeSubField(toF,fromF, sfind, ptc, i);
      break;
    case 'w':
      res=C_mergeSubField(toF,fromF, sfind, ptc, i);
      break;
    case 'c':
      res=C_splitSubField(toF, fromSF,ptc, i);
      break;
    case 'y':
      res=C_updateFromCopyField(rcd_in,toF,ptc,i);
      break;

    case 'q':
      res=C_multiCopySubField(toF, fromSF,ptc, i);
      break;
    default:
      {
	char m[200];
	
	sprintf(m, "function for code %c not yet implemented\n",ptc->fromFunction[i]);
	if (ONETK_WriteLogFile(fildes, m)==-1){
	  /**Error handle**/
	}
      }
      break;
    }
    return res;
  }
  
  return res;
  
}











