        /* * * * * * * * * * * * * * * * *    
	 *  MARCconv        Version 2.3  *
	 *   File:    dataFields_dcs.c   * 
	 *   Primary content dependent   * 
	 *          conversion           * 
	 *    Last update: 28/01/1997    * 
	 *      Michael S. Preminger     * 
	 *      BRODD, OSLO COLLEGE      * 
	 *        THE ONE PROJECT        * 
	 * * * * * * * * * * * * * * * * */


#include <setjmp.h>

#include "MARCproto.h"



extern jmp_buf marcconv_env;

PortionTable_VarDat 
*findCorrectTablePortionByIndicators(char undefined,
				     char *indicators, 
				     PortionTable_VarDat *dp){
  
  
  Boolean matchInd1, matchInd2;
  int i1, i2;
  /* 
     Find correct conversion table portion, if more than
     one are present. This is the first one that recognizes
     both indicators.
     */
  
  matchInd1=FALSE;
  matchInd2=FALSE;
  
  if (dp==NULL)
    return NULL;
  while(dp!=NULL){
    if (indicators[1]!=undefined){
      if ((isdigit(indicators[1])!=0 && strchr(dp->ind1fromValue, 'N')!=NULL)
	  ||
	  strchr(dp->ind1fromValue,indicators[1])!=NULL
	  )
	matchInd1=TRUE;
      else
	matchInd1=FALSE;
	  
    }

    /**if an indicator is "space", it is undefined,
      and the program can suffice identifying the second
      indicator.**/
    else matchInd1=TRUE;

    if (indicators[2]!=undefined){

      if ((isdigit(indicators[2])!=0 && strchr(dp->ind2fromValue, 'N')!=NULL)
	  ||
	  strchr(dp->ind2fromValue,indicators[2])!=NULL
	  )
	matchInd2=TRUE;
      else
	matchInd2=FALSE;


    }
    else matchInd2=TRUE;

    if (matchInd1==TRUE && matchInd2==TRUE)
      /*Exit While. We have found the correct table part.*/
      break;			
    else {  
      dp = dp->NextPT_DT;
      matchInd1=matchInd2=FALSE;
    }

  } /*while*/
  
  if (matchInd1==TRUE && matchInd2==TRUE){
  /*  if (indicators[1]!=undefined){
      treatIndicator(1,indicators[1],dp,i1);
    }

    if (indicators[2]!=undefined){
      treatIndicator(2,indicators[2],dp,i2);
    }*/
  }
  else
    return NULL;
  
  return dp;
}

char *DCS_MatchDataWithSF(PortionTable_Decision *pd, 
			  char *dt)
{
  /*This function rooms special cases of comparison that
    are necessary for a decision about a correct to-tag.
    If more cases are to be added, caution is required so 
    that new cases do not conflict with old ones.*/
  
  int i=0;
  char *str;
  if (pd->lowerLevelTable_txt[0]==NULL || pd->lowerLevelTable_toTag[0]==NULL)
    return pd->toTag;
  for (i=0;i<pd->ArrayLength;i++){
    /* return pd->toTag;*/
    /*CHECK FOR SPECIAL CASES*/
    /*Case 1 - two 4 digit years combined with a hyphen*/
    if (strncmp(pd->lowerLevelTable_txt[i], "*nnnn-nnnn",10)==0){

      str=strchr(dt,'-');
      while (str!=NULL){
	char *str1, *str2;
	str1=(char *)calloc(5,sizeof(char));
	str2=(char *)calloc(5,sizeof(char));

	/*found a hyphen. check if a 4 digit year 
	  reference may be preceeding the hyphen.*/
	if (str-dt>=4){
	  str1=strncpy(str1,str-4,4);
	  if (isInteger(str1)==TRUE){
	    /*O.K This may be a year. Now find if a year is 
	      succeeding the hyphen.*/
	    str2=strncpy(str2,str+1,4);
	    if (isInteger(str2)==TRUE){
	      /*O.K, we have two hyphenated, 4 digits dates. */
	      free(str1);
	      free(str2);
	      return pd->lowerLevelTable_toTag[i];
	    }
	    /* Found A PRECEEDING, but no SUCCEEDING 4 digit 
	       year reference to the hyphen. So we give
	       a 2 digit succeeding year reference a chance.*/
	    memset(str2,'\0',5);
	    str2=strncpy(str2,str+1,2);
	    if (isInteger(str2)==TRUE){
	      /*O.K, we have two years  formatted yyyy-yy. */
	      free(str1);
	      free(str2);
	      return pd->lowerLevelTable_toTag[i];
	    }
	    
	  }
	}
	/*if the previous hyphen was not a date range, maybe
	  the next one is?*/
	str=str+1;
	str=strchr(str, '-');
      }	/*while*/
    }

    /*Case 2 - an integer which comprises
      the whole sub field*/
    if (strncmp(pd->lowerLevelTable_txt[i], "+N",2)==0){
      if (isInteger(dt)==TRUE){
	return pd->lowerLevelTable_toTag[i];
      }
    }

    /*Case 3 - both '.' and ',' occur in the subfield */
#ifdef VMS
    if (memcmp(pd->lowerLevelTable_txt[i], ", .",3)=='\0'){
#else
    if (memcmp(pd->lowerLevelTable_txt[i], ", .",3)==0){
#endif
      if (strchr(dt, ',')!=NULL || strchr(dt, '.')!=NULL){
	return  pd->lowerLevelTable_toTag[i];
      }
    }

    /*NORMAL MATCH SHOULD ALWAYS BE THE LAST
      MATCH CASE THAT IS CHECKED*/
    /*Last Case - Normal match*/
    if (strstr(dt,pd->lowerLevelTable_txt[i])!=NULL)
      return pd->lowerLevelTable_toTag[i];
  } /*for*/

  return NULL;
}

char *MatchSubfield_code_and_contents(field *fromF, 
				      PortionTable_Decision *pd){
  dataField *fromDataFld=fromF->datafield;
  int i;
  for(i=0;i<fromDataFld->ArrayLength;i++){

    /*Remember that most sub field codes are repeatable
      in a field, so we cannot stop on found subfield!!!*/
    if (fromDataFld->subFieldCodes[i]==pd->subFieldCode){
      char *tg;
      tg=DCS_MatchDataWithSF(pd, fromDataFld->subFields[i]->data);
      if (tg!=NULL)
	return tg;
    }
  }
  return NULL;
}

/**                         USE THE GLOBAL CTind**/
PortionTable_VarDat *decisionTable_findTag(record *rcd,
					   field *fromF,
					   char undefIndValue,
					   PortionTable_VarDat *dfpPtr,
					   decision_table_str *dts){
  /*All the parts of the decision table entry have to
    match so that the "non-default" to tag will be used */
  dataField *fromDF=fromF->datafield;
  char *toTag=NULL, *fromTag=fromDF->tag; /**move tag into generic field**/
  PortionTable_Decision *ptd;
  int i, idxInField;
  
  Boolean dcsMatch=FALSE;
  /*Find correct entry by tag*/
  for (i=0;i<dts->ArrayLength;i++){
    if (strcmp(dts->fromTags[i], fromTag)==0){
      break;
    }
  }
  if (i==dts->ArrayLength){
    char m[200];
    sprintf(m, 
	    "warning: ( decisionTable_findTag()\n   decision_table not updated for tag %s\n", 
	    fromTag
	    );
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/

    }
    /*Use indicator values*/
    dfpPtr=
      findCorrectTablePortionByIndicators(undefIndValue,
					  fromDF->indicators, 
					  dfpPtr->NextPT_DT); 
  }
  
  else{
    ptd=dts->Table[i];

    /*LOOP*/
    while (ptd!=NULL){
      if/**/ (
	   (
	    ptd->indicator1=='N' 
	    &&
	    isdigit(fromDF->indicators[1])!=0
	   ||
	   ptd->indicator1==fromDF->indicators[1]
	  )
	  &&
	  
	   (
	    ptd->indicator2=='N' 
	    &&
	    isdigit(fromDF->indicators[2])!=0
	    ||
	   ptd->indicator2==fromDF->indicators[2]
	  )

	  &&
	    (
	     ptd->material=='\0'
	     ||
	     memchr(ptd->material, rcd->leader[6], 
		    strlen(ptd->material))!=NULL
	     )
	  &&
	
	  (toTag=MatchSubfield_code_and_contents(fromF, 
						 ptd  )) != NULL
	  )
	break;			/*exit while loop*/
      else       ptd=ptd->NextPT_DCS;
    } /*while*/
    if (toTag==NULL)
      toTag=dts->Table[i]->defaultToTag;

    dfpPtr=
      findCorrectTablePortionByIndicators(undefIndValue,
					  fromDF->indicators, 
					  dfpPtr);

    while (dfpPtr!=NULL){
      if (strcmp(dfpPtr->toTag,toTag)==0)
	return dfpPtr;
      dfpPtr=
	findCorrectTablePortionByIndicators(undefIndValue,
					    fromDF->indicators, 
					    dfpPtr->NextPT_DT);  
    }
  }
  return NULL;
}

