        /* * * * * * * * * * * * * * * * *     
	 *  MARCconv        Version 2.3  *
	 *   File:     dataFields_ind.c  * 
	 *     Special functions for     * 
	 *     setting of indicators     * 
	 *    Last update: 28/01/1997    * 
	 *      Michael S. Preminger     * 
	 *      BRODD, OSLO COLLEGE      * 
	 *        THE ONE PROJECT        * 
	 * * * * * * * * * * * * * * * * */

#include <setjmp.h>

#include "MARCproto.h"


extern jmp_buf marcconv_env;

char Ind_matchSFData(char *data,
		     int ArrayLength,
		     regex_t *patterns[],
		     char indValues[]){
  int i;
  for (i=0;i<ArrayLength;i++){
    if (patterns[i]!=NULL){
      if (regexec(patterns[i], data, 0,NULL,REG_NOTEOL)==0)
	return indValues[i];
    }
  }
#ifdef VMS
  return '\0';
#else
  return NULL;
#endif
}
subField *checkCheckSubField(field *fld,
			     PortionTable_Indicator *pi
			     ){
  
  return findSubField(fld, pi->checkSubField);
}
char getUndefinedIndValue(char *format){

  if (strcmp (format, "USMARC")==0 
      ||
      strcmp(format, "NORMARC")==0
      ||
      strcmp(format, "LIBRISMARC")==0
      ||
      strcmp(format, "FINMARC")==0
      )
    return ' ';
  else
    return '0';
}
/*Creating a subfield due to indicator value*/
char setIndicatorU(
		   field *fld,
		   char tableToValue,/*S2 see *M* comment below.*/
		   char *info /*Subfield:'$' + code + contents*/
		   ){
  subField *sf=createSubField(fld, *(info+1));
  int lgt=strlen(info+2)+1;
  
  
  sf->data=(char *)malloc(lgt*sizeof(char));
  memset(sf->data,'\0',lgt);
  strcpy(sf->data,info+2);
  
  /*M* Actually superfluous, but retains uniformity 
   of indicator treatment*/
  return tableToValue;
}

/*Creating a subfield due to indicator value*/
char setIndicatorV(record *rcd,
		   field *fld,
		   char tableToValue,/*S2 see *M* comment below.*/
		   char *info /*Subfield:'$' + code + contents*/
		   ){
  subField *sf=createSubField(fld, *(info+1));
  int lgt=strlen(info+2)+1;
  
  if (rcd->leader[6]!='d'&&rcd->leader[6]!='h'){
    sf->data=(char *)malloc(lgt*sizeof(char));
    memset(sf->data,'\0',lgt);
    strcpy(sf->data,info+2);
  }
  /*M* Actually superfluous, but retains uniformity 
   of indicator treatment*/
  return tableToValue;
}
/* This  routine has actually nothing to do with indicator */
/* treatment. It is a dirty solution to the need to prefix */
/* a sub-field with a constant string.  */
/*  * The string is written in the  */
/*    S2 field in the table next to all the possible indicator values. */
/*  * A dummy field with sub field code $* is generated and appended to the */
/*    from field */
/*  * a merge directive between $* and the actual sub field */
/*    sees to perform the merge. */
char setIndicatorH(field *fld, /*The FROM field*/
		   char tableToValue,/*S2 see *M* comment below.*/
		   char *info /*Subfield:'$' + code + contents*/
		   ){
  subField *sf=createSubField(fld, '*');
  int lgt=strlen(info)+1;
  

  sf->data=(char *)calloc(lgt, sizeof(char));
  strcpy(sf->data,info);

  /*M* Actually superfluous, but retains uniformity 
   of indicator treatment*/
   return tableToValue;
}


/*The LIBRISMARC way of setting non-sorting indicators*/
char setIndicatorQ(field *fld,
		   char ToTableIndValue, /*S2*/
		   char undefinedValue, /*either ' ' or '0'*/
		   char *treatmentPar,/*TO*/
		   char fromTableIndValue /*S1*/
		   ){
  subField *sf;
  char *sf_data;
  char sf_code;

  char *retInd, *tmp;
  int offset;
  if (ToTableIndValue!='N'){
    if (ToTableIndValue==undefinedValue)
      return undefinedValue;
  }
  
  sf_code=(treatmentPar) ? *treatmentPar : 'a';
  sf=findSubField(fld, sf_code);
  sf_data= (sf) ? sf->data : (char *)NULL ;
    
  if (sf_data==NULL){
    char m[300];
    sprintf(m, 
	    "warning: ( setIndicatorQ()\n   field %s subfield %c not found or empty.\n   Sorting indicator set to 0.\n  Check vdt table. ", 
	    fld->datafield->tag,
	    sf_code);
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/

    }
    
    return '0';	    
  }

  /*
   *  Search for the special character 
   * (given as the incoming indicator value)
   * in the subfield content string
   */
  tmp=strchr(sf_data,fromTableIndValue);
  if (tmp==NULL){
    char m[200];
    sprintf(m, 
	    "warning: ( setIndicatorQ()\n   Special character %c Not found in the subfield string\n  <%s>\n. Sorting indicator set to 0\n", 
	    fromTableIndValue,
	    sf_data);
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/

    }
    
    return '0';	    
		  }
 else  
  {  

    /*Pointer arithmetics*/
    offset=(tmp-sf_data)-1;
    offset=
      offset<=9?
      offset:
      0;
    
    retInd=itoalgt(offset,1);
     
    return *retInd;
  }
}

char setIndicatorZ(int which, /*ind1 or ind2*/
		   char toValue,
		   record *from_rcrd,
		   field *from_fld,
		   indicator_table_str *its,
		   char *toTag /*Non null only with xiferp table*/
		  )
/*setIndicatorZ*/{
  int i;
  PortionTable_Indicator *pi;
  field *ChkFld, *retFld;
  subField *retSF;
  char defaultToInd;
  /*find correct indicator_table_portion list(using the tag)*/
  /**SHOULD CONDITION APPLY?**/
  for (i=0;i<its->ArrayLength;i++){
    /*
     * First if part to be used with a xiferp table
     */
    if (its->fromTags[i]==NULL){
      if (toTag==NULL && which==its->whichInds[i])
	break;
      if (strcmp(its->toTags[i], toTag)==0
	  &&
	  which==its->whichInds[i]
	  )
	break;
    }
    if (its->toTags[i]==NULL){
      if (strcmp(its->fromTags[i], from_fld->datafield->tag)==0
	  &&
	  which==its->whichInds[i]
	  )
	break;
    }
    
    /*
     * Second if used both for vdt table and xiferp table
     */
    if (strcmp(its->fromTags[i], from_fld->datafield->tag)==0
	&&
	which==its->whichInds[i]){
      break;
    }
  }
  if (i==its->ArrayLength){
    char m[200];
    sprintf(m, 
	    "warning: ( setIndicatorZ()\n   indicator_table not updated for tag %s\n", 
	    from_fld->datafield->tag
	    );
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/

    }
    return '#';
  }
  pi=its->Table[i];

  /*
   * pi is now a head of a list of sub tables, 
   * associated with
   * datafield->fromTag and indicator
   */
    
  while (pi!=NULL)
    {
    defaultToInd = pi->defaultToInd;
    if (testConditionInd(from_fld, pi)==TRUE)	
      break;
    pi=pi->NextPT_IND;
  }
  if (pi==NULL)
    return defaultToInd;	/*The default from the last sub table
			  in the list.*/
  
  retFld=checkCheckField(from_rcrd, from_fld, pi);
  if (retFld==NULL)
    return pi->defaultToInd;

#ifdef VMS
  if (pi->checkSubField=='\0')
#else
  if (pi->checkSubField==NULL)
#endif
    return pi->nonDefaultToInd;
  retSF=checkCheckSubField(retFld, pi);
  if (retSF==NULL)
    return pi->defaultToInd;
  
  /*If lower level table does not exist - return the non default 
    value because then it is the mere presense of checkSubField
    in the field that is checked.*/
  if (pi->lowerLevelTable_txt==NULL)
    return pi->nonDefaultToInd;
  
  if (toValue!='N'){
    /*set indicator By pattern occurence*/
    char val;
    val=Ind_matchSFData(retSF->data, 
			  pi->ArrayLength,
			  pi->lowerLevelTable_compExp,
			  pi->lowerLevelTable_toInd);
#ifdef VMS
    if (val!='\0')
#else
    if (val!=NULL)
#endif
      return val;
    return pi->defaultToInd;
  }
  
  /*NON SORTING CHARACTERS*/
  /*Language aspect not yet implemented. A single
    list is checked*/
  /* * * * * * * * * * * * * * * * * * * * * * * * * *
   *  Language aspect not yet implemented. A single  *
   *  list is checked                                *
   *  char *language;                                *
   *  language=findRecordLanguage(from_rcrd, from_rcrd->format); *
   *  if (language==NULL                             *
   *      ||                                         *
   *      strncmp(language,"   ",3)==0)              *
   *    return NULL;                                 *
   *  else                                           *   
   *   language not NULL    {                        *	      
   * * * * * * * * * * * * * * * * * * * * * * * * * */
  
  for (i=0;i<pi->ArrayLength;i++){
    /*
     * find the table entry with the correct 
     * first word, which should not be more than 9
     * characters long. This is of course only a theoretic
     * check. The table generator will prevent a value
     * larger than 9.
     */
    if (compareFirstWord(pi->lowerLevelTable_txt[i], 
			 retSF->data
			 )==0)
      if (strlen(pi->lowerLevelTable_txt[i]) > 9){
	return '0';
      }
      else
	return pi->lowerLevelTable_toInd[i];
  }
  return '0';
}
Boolean testConditionInd(field *fld,
			 PortionTable_Indicator *pi
			 ){
#ifdef VMS  
  if (pi->condition=='\0')
#else
  if (pi->condition==NULL)
#endif
    return TRUE;
  if (conditionMet(fld, 
		   -1, 
		   pi->condition, 
		   pi->parameter)==TRUE){
    return TRUE;
  }
  return FALSE;
}
/*Find if 'word' is the first word in 'string'*/
int compareFirstWord(char *word, 
		     char *string){
  char *tmp=(char *)malloc((strlen(word)+2)*sizeof(char));
  int res;
  memset(tmp, '\0',strlen(word)+2);
  strcat(tmp,word);
  strcat(tmp, " ");
  res = strncmp(tmp, string, strlen(tmp));
  free(tmp);
  return res;
}
/*A utility function that checks the existence of fields/
which fields to use for the indicator setting routine*/
field *checkCheckField(record *rcd, 
	       field *fld, 
	       PortionTable_Indicator *pi){
  if (pi->checkField==NULL)
    return fld;
  if (isRegexp(pi->checkField)==TRUE){
    if (findFieldByRegexp(rcd, pi->checkField)==NULL)
      return NULL;
    else
      return fld;
  }    
  else 
    return findField(rcd, pi->checkField);
}
