/* * * * * * * * * * * * * * * * *    
 *  MARCconv        Version 2.3  * 
 *   File:   dataFields_main.c   *
 *      Variable data fields     *
 *          Main routine         *
 *    Last update: 28/01/1997    * 
 *      Michael S. Preminger     * 
 *      BRODD, OSLO COLLEGE      * 
 *        THE ONE PROJECT        * 
 * * * * * * * * * * * * * * * * */

#include <setjmp.h>


#include "MARCproto.h"

extern jmp_buf marcconv_env;

Boolean isRegexp(char *str){
  /*
   * By our definition, a regexp can occur anywhere in the
   * string, and thereby must be enclosed by the beginning(^) and
   * end($) of that string, and zero or more non-null characters
   */
  if (strstr(str, ".*")!=NULL 
      ||
      (strstr(str, "[")!=NULL 
       &&
       strstr(str, "]")!=NULL)) 
    return TRUE;
  return FALSE;
}

int toNumber(char ch){
  char tmp[2];
  memset(tmp,ch,1);
  memset(tmp+1,'\0',1);
  return atoi(tmp);
}

int findMergeSize(field *fld, char *subFields){
  return MAX_RECORD_LENGTH;
  /** to do
   * give us a better solution here, please!
   **/
}
field *findFieldByRegexp(record *rcd,
			 char *tag_pt){
  regex_t *tag_re=(regex_t *)calloc(1, sizeof(regex_t));
  int rescomp,i;
  rescomp=regcomp(tag_re, tag_pt, REG_NOSUB);
  if (rescomp!=0){
    char m[200];
    sprintf(m, 
	    " findFieldByRegexp: Compilation of regexp %s failed\n", 
	    tag_pt 
	    );
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/

    }

    
  }
  for (i=0;i<rcd->ArrayLength; i++){
    if (regexec(tag_re, rcd->tags[i], 0, NULL,REG_NOTBOL )==0)
      return rcd->fields[i];
  }
  return NULL;
}


/*
 * A condition checker for the conditional indicator 
 * setting, and the
 * conditional subfield conversion
 */
Boolean conditionMet(field *fld,
		     int index, /* index is the placement of the
				   subfield in the field.
				   -1 means indicator setting
				   thus index not relevant*/
		     char cond, 
		     char *param){
  
  dataField *df=fld->datafield;
  int i,j,ln; 
  Boolean Found=FALSE;
  
  if (param!=NULL)
    ln=strlen(param);
  else 
    ln=0;
  
  
  switch(cond){
  case '!':
    if (index == -1){
      /*ERROR MESSAGE*/
    }
    for (i=0;i<ln;i++)
      if (df->subFieldCodes[index-1]==*(param+i))
	return FALSE;
    return TRUE;
    break;
  case '+':
    if (index == -1){
      /*ERROR MESSAGE*/
    }
    for (i=0;i<ln;i++)
      if (df->subFieldCodes[index-1]==*(param+i))
	return TRUE;
    return FALSE;
    break;
  case ',':
    if (index == -1){
      /*ERROR MESSAGE*/
    }
    if (index>=df->ArrayLength)
      return TRUE;
    for (i=0;i<ln;i++)
      if (df->subFieldCodes[index+1]==*(param+i))
	return TRUE;
    return FALSE;

    break;
    
  case '&':
    if (index == -1){
      /*ERROR MESSAGE*/
    }
    if (index>=df->ArrayLength)
      return TRUE;
    for (i=0;i<ln;i++)
      if (df->subFieldCodes[index+1]==*(param+i))
	return FALSE;
    return TRUE;

    break;
  case '-':
    for (i=0;i<ln;i++)
      for (j=0;j<df->ArrayLength;j++)
	if (df->subFieldCodes[j]==*(param+i))
	  return FALSE;
    return TRUE;
  case '*':			/*All param subfield exist in field*/
    for (i=0;i<ln;i++){
      Found=FALSE;
      for (j=0;j<df->ArrayLength;j++){
	if (df->subFieldCodes[j]==*(param+i)){
	  Found=TRUE;
	  break;
	}
      }
      if (Found==FALSE)
	return FALSE;
    }
    return TRUE;
  case (char)NULL: /* meaning no condition */
    return TRUE;
  default:{
    char m[200];
    sprintf(m, 
	    " <%c> Unsupported condition code in conditional table \n", 
	    cond
	    );
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/

    }

    return TRUE;
  }
  }
  
}

/* * * * * * * * * * * * * * * * *
 *                               *
 * FIND THE ITEM  LANGUAGE       *
 *        OF A RECORD            *
 *                               *
 * * * * * * * * * * * * * * * * */

char *findRecordLanguage(record *rcd, char *format){
  char *lang;
  field *fld;
  if (strcmp (format, "USMARC")==0 
      ||
      strcmp(format, "NORMARC")==0
      ||
      strcmp(format, "UKMARC")==0
      ||
      strcmp(format, "DANMARC")==0
      ||
      strcmp(format, "LIBRISMARC")==0
      ||
      strcmp(format, "FINMARC")==0
      ){
    fld=findField(rcd, "008");
    if (fld==NULL)
      return NULL;
    lang=(char *)malloc(4*sizeof(char));
    strncpy(lang, 
	    fld->ctrlfield->data+35,
	    3);
    memset(lang+3,'\0',1);
    return lang;
  }
  if (strcmp (format, "UNIMARC")==0) {
    subField *sf;
    fld=findField(rcd, "100");
    if (fld==NULL)
      
      sf=findSubField(fld, 'a');
    lang=(char *)malloc(4*sizeof(char));
    strncpy(lang, 
	    sf->data+22,
	    3);
    memset(lang+3,'\0',1);
    return lang;
  }
  return NULL;
}
Boolean isInteger(char *str){
  Boolean tmp;
  int i=0;
  int len=strlen(str);
  for (i=0;i<len;i++){
    if (isdigit(*(str+i))==0)
      return FALSE;
  }
  return TRUE;
}

int makePrivateField_FULL(char *fromFormatName, 
			  record *rcd,
			  field *fromfld,
			  char *comment){
  /*
   * This version of makePrivateField
   * generates a field representing an entire unconvertible
   * field of the from format
   */
  
  field *tofld;
  dataField *todtfld;
  dataField *fromDF=fromfld->datafield;
  subField *fmtNameSF, *contentSF, *commentSF, *sbfld_aSF,  *fromF_sfA;
  char *fieldContents;
  
  tofld=createField(rcd, "999");
  
  
  fmtNameSF=createSubField(tofld, PRIVATE_FIELD_FORMAT_NAME_SF);
  
  /*subFIeld  containing the name of the from format*/
  fmtNameSF->data=(char *)malloc((1+strlen(fromFormatName))*sizeof(char));
  strncpy(fmtNameSF->data, fromFormatName, strlen(fromFormatName));
  memset(fmtNameSF->data+strlen(fromFormatName),'\0',1);
  
  contentSF= createSubField(tofld, PRIVATE_FIELD_CONTENT_SF);
  
  /*Sub field containing the contents of the field*/
  fieldContents=fieldToString_privateTag(fromfld);
  
  contentSF->data=(char *)calloc(1+strlen(fieldContents),sizeof(char));
  strcpy(contentSF->data, fieldContents);
  free(fieldContents);
  fieldContents=NULL;
  
  commentSF= createSubField(tofld, PRIVATE_FIELD_COMMENT_SF);
  
  /*Sub field  containing a comment*/
  commentSF->data=(char *)malloc((1+strlen(comment))*sizeof(char));
  strcpy(commentSF->data, comment);
  memset(commentSF->data+strlen(comment),'\0',1);
  
  
  /*
   * Sub field citing the content of 
   * subfield $a in the from field (up to
   * 30 characters
   */
  
  sbfld_aSF=createSubField(tofld, PRIVATE_FIELD_CITE_SF_A_COMMENT_SF);
  
  sbfld_aSF->data = (char *)calloc(sizeof(char), 40);
  if (fromfld->datafield!=NULL){
    fromF_sfA=findSubField(fromfld, 'a');
    if (fromF_sfA!=NULL && fromF_sfA->data!=NULL){
      strcpy(sbfld_aSF->data, fromDF->tag);
      strncat(sbfld_aSF->data, fromDF->indicators+1,2);
      strcat(sbfld_aSF->data, "$a ");
      strncat(sbfld_aSF->data, fromF_sfA->data, 30);
    }
    else
      strcpy(sbfld_aSF->data, "Field had no subfield $a");
  }
  else
    strcpy(sbfld_aSF->data, "Field had no subfield $a");

  if (fieldContents!=NULL)
    free(fieldContents);
}
int makePrivateField_PART(char *fromFormatName, 
			  record *rcd,
			  field *fromfld,
			  int idxInFromFld,
			  char *comment){
  /*
   * This version of makePrivateField
   * generates a field representing one or more subfields
   * of the from field, that are not convertible into the
   * to field. It creates the field, and update the first
   * such subfield in the "contentSF" subfield. The content of 
   * subsequent unconvertible subfields of the same from field
   * will be concatenated into this subfield.
   */
  field *tofld;
  dataField *todtfld;
  dataField *fromDF=fromfld->datafield;
  subField *fmtNameSF, *contentSF, *commentSF, *sbfld_aSF,  *fromF_sfA, *missingSF=fromDF->subFields[idxInFromFld];
  char *fieldContents;
  
  tofld=createField(rcd, "999");
  
  
  fmtNameSF=createSubField(tofld, PRIVATE_FIELD_FORMAT_NAME_SF);
  
  /*subFIeld  containing the name of the from format*/
  fmtNameSF->data=(char *)malloc((1+strlen(fromFormatName))*sizeof(char));
  strncpy(fmtNameSF->data, fromFormatName, strlen(fromFormatName));
  memset(fmtNameSF->data+strlen(fromFormatName),'\0',1);
  
  contentSF= createSubField(tofld, PRIVATE_FIELD_CONTENT_SF);
  
  /*Sub field containing the contents of the field*/
  fieldContents=(char *)calloc((
				strlen(missingSF->data)+
				+3 /*tag*/
				+2 /*indicatorer*/
				+1 /*$*/
				+1 /*sub field code*/
				+1 /*ZERO_TERMINATOR*/
				+3 /*JUST IN CASE*/
				), sizeof(char) );

  strncpy(fieldContents, fromDF->tag,3);
  strncat(fieldContents, fromDF->indicators+1,2);
  strncat(fieldContents, "$",1);
  strncat(fieldContents, &(missingSF->subFieldCode),1);
  strncat(fieldContents, missingSF->data, strlen(missingSF->data));
  contentSF->data=(char *)calloc(1+strlen(fieldContents),sizeof(char));
  strcpy(contentSF->data, fieldContents);
  
  
  commentSF= createSubField(tofld, PRIVATE_FIELD_COMMENT_SF);
  
  /*Sub field  containing a comment*/
  commentSF->data=(char *)malloc((1+strlen(comment))*sizeof(char));
  strcpy(commentSF->data, comment);
  memset(commentSF->data+strlen(comment),'\0',1);
  
  
  /*
   * Sub field citing the content of 
   * subfield $a in the from field (up to
   * 30 characters
   */
  
  sbfld_aSF=createSubField(tofld, PRIVATE_FIELD_CITE_SF_A_COMMENT_SF);
  
  sbfld_aSF->data = (char *)calloc(sizeof(char), 40);
  fromF_sfA=findSubField(fromfld, 'a');
  if (fromF_sfA!=NULL){
    strcpy(sbfld_aSF->data, fromDF->tag);
    strncat(sbfld_aSF->data, fromDF->indicators+1,2);
    strcat(sbfld_aSF->data, "$a ");
    strncat(sbfld_aSF->data, fromF_sfA->data, 30);
  }
  else
    strcpy(sbfld_aSF->data, "Field had no subfield $a");
}

int treatIndicator(int which, 
		   char indicator, 
		   PortionTable_VarDat *ptvd, 
		   int index){
  /**IMPLEMENT**/
  
  
}
/* * * * * * * * * * * * * * * * *
 *                               *
 *    SPECIAL TREATMENT OF       * 
 *          INDICATORS           *
 *                               *
 * * * * * * * * * * * * * * * * */


/* * * * * * * * * * * * * * * * *
 *                               *
 *  INDICATOR AND DECISION TABLE *
 *          FUNCTIONS            *
 *                               *
 * * * * * * * * * * * * * * * * */



/* * * * * * * * * * * * * * * * *
 *                               *
 * SUBFIELD CONVERSION ROUTINES  *
 *                               *
 * * * * * * * * * * * * * * * * */


void *copyField(field *fld,
		record *toRcd,
		char *tag)
{
  field *toFld;
  subField *sbFld;
  int i;
  toFld=createField(toRcd, tag);
  if (toFld->datafield==NULL){
    if (toFld->ctrlfield!=NULL){
      toFld->ctrlfield->data=(char *)
	calloc(strlen(fld->ctrlfield->data)+1, sizeof(char));
      strcpy(toFld->ctrlfield->data, fld->ctrlfield->data);
    }
  }
  else{
    if (fld->datafield->text!=NULL){
      if (toFld->datafield->text != NULL) free(toFld->datafield->text);
      toFld->datafield->text=(char *)
	calloc(strlen(fld->datafield->text)+1, sizeof(char));
      strcpy(toFld->datafield->text, fld->datafield->text);
    }
    for (i=0;i<fld->datafield->ArrayLength;i++){
      sbFld=createSubField(toFld, fld->datafield->subFieldCodes[i]);
      sbFld->subFieldCode=fld->datafield->subFieldCodes[i];
      sbFld->data= (char *)
	calloc(strlen(fld->datafield->subFields[i]->data)+1, sizeof(char)); 
      strcpy(sbFld->data, fld->datafield->subFields[i]->data);
    }
  }
}



int convertDataField(record *rcd_in,
		     int fromFieldIndex, /*The position of the field
					   in the record*/
		     record *rcd_out,
		     prefixing_table_str *pts,
		     xiferping_table_str *xts,
		     decision_table_str *dts,
		     indicator_table_str *its,
		     conditional_table_str *cts,
		     generic_table *gnTbl)
     
{				/*Start function*/
  PortionTable_VarDat *dfpPtr, *dp;
  field *fromField=rcd_in->fields[fromFieldIndex];
  dataField *toDataFld, *fromDataFld=fromField->datafield;
  field *toFieldPtr;
  char fromUndefinedIndValue=getUndefinedIndValue(rcd_in->format);
  char toUndefinedIndValue=getUndefinedIndValue(rcd_out->format);
  subField *toSubFld;
  char *realToTag;
  int i;
  int res=1;
  subField *fromSFPtr;
  subField *toSFptr;
  char *privateFieldComment;
  Boolean NFld;
  
  int k;
  char *toTag;
  field *toFld; 
  char *toInd;			/* 
				 * A pointer to the actual indicator character
				 * that should be used. Points either to 
				 * toFld->datafield->indicators[1]
				 * or to toFld->datafield->indicators[2]
				 */
  
  char ind;			/*
				 * A container to absorb the returning value
				 * from the special indicator conversion routines
				 */
  /*
   * Tell the program a new field is coming, to create a 
   * new field, and to avoid appending data to older 
   * fields with the same tags.
   */
  /*Dirty solution for NORMARC 020, 700, 740 and 500*/
  if (strncmp(fromDataFld->tag, "020", 3) == 0 || 
      strncmp(fromDataFld->tag, "700", 3) == 0 ||
      strncmp(fromDataFld->tag, "247", 3) == 0 ||
      strncmp(fromDataFld->tag, "740", 3) == 0 ||
      strncmp(fromDataFld->tag, "500", 3) == 0 ||
      strncmp(fromDataFld->tag, "505", 3) == 0 
      ){
    NFld=TRUE;
  }
  else{
    NFld=FALSE;
  }
  
  /*
   * Find conversion table entry
   */

  /*
   * Check if the field is to be duplicated 
   * into the from_record, under a new tag. 
   * of tables. This is a dirty solution to allow
   * two types of conversion for the same field.
   */

  if (gnTbl->copyTag!=NULL){
    copyFieldOtherTag(rcd_in, rcd_in->fields[fromFieldIndex], gnTbl->copyTag);
  }

  dfpPtr=gnTbl->portion_table_vdt; 

  
  /*
   * Check if the field is to be duplicated 
   * into the to_record. This eases up editing
   * of tables.
   */
  if ( (gnTbl->specialTreatment==TRUE
	||			/*prefix*/
        (char)gnTbl->prefixTreatment==TRUE
	||			/*xiferp*/
	(char)gnTbl->xiferpTreatment==TRUE
	)
      &&
      dts!=NULL)
    {				/*5*/
      /*look at the decision table, to find the TO TAG,
	and thereby identify the correct conversion table
	portion.*/
      dfpPtr=decisionTable_findTag(rcd_in, 
				   fromField, 
				   fromUndefinedIndValue,
				   dfpPtr, 
				   dts);

      if (dfpPtr==NULL){
	char m[200];
	sprintf(m, 
		"error: ( convertDataField() )\n  decision table %s mismatch with conversion table %s:\n      from tag %s : to tag not found\n",
		getFileName(rcd_in->format, rcd_out->format, "decision"),
		getFileName(rcd_in->format, rcd_out->format, "data"),
		fromField->datafield->tag
		);
	if (ONETK_WriteLogFile(fildes, m)==-1){
	  /**Error handle**/
	}
	return 0;
      }
      
    }
  else /*5*/{
  /*%%%%%%%%%%    TO-TAG AND INDICATORS  %%%%%%%%%%%%%*/    
    if (  (gnTbl->specialTreatment==TRUE 
	   ||
	   (char)gnTbl->prefixTreatment==TRUE
	   ||			/*xiferp*/
	   (char)gnTbl->xiferpTreatment==TRUE
	   )
	  && dts==NULL)/*4*/{		
      /*A Decision table should actually be here. Warn but
	proceed with the conversion anyway, emiting a warning*/
      char m[200];
      sprintf(m, 
	      "warning: ( convertDataField() )\n  decision table file %s not found", 
	      getFileName(rcd_in->format, rcd_out->format, "decision")
	      );
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
      }
      dfpPtr=
	findCorrectTablePortionByIndicators(fromUndefinedIndValue,
					    fromDataFld->indicators, 
					    gnTbl->portion_table_vdt);
      
      if (dfpPtr==NULL){
	char m[200];
	sprintf(m, "convertDataField()\n   error converting Field %s, indicator1='%c', indicator2='%c'\n",
		fromDataFld->tag, 
		fromDataFld->indicators[1],
		fromDataFld->indicators[2]);
	if (ONETK_WriteLogFile(fildes, m)==-1){
	  /**Error handle**/
	  
	}
	return 0;
      }
    }/*if 4*/
    else /*4*/{
      dfpPtr=
	findCorrectTablePortionByIndicators(fromUndefinedIndValue,
					    fromDataFld->indicators, 
					    gnTbl->portion_table_vdt);
      
      if (dfpPtr==NULL){
	char m[200];
	sprintf(m, "convertDataField()\n   error converting Field %s, indicator1='%c', indicator2='%c'\n",
		fromDataFld->tag, 
		fromDataFld->indicators[1],
		fromDataFld->indicators[2]);
	if (ONETK_WriteLogFile(fildes, m)==-1){
	  /**Error handle**/
	  
	}
	return 0;
      

      }
    }/*else 4*/
  }/*else 5*/
  
  /*HERE we have a dfpPtr*/
  if(dfpPtr->toTag==NULL){
    char m[200];
    sprintf(m, "convertDataField()\n   error converting Field %s, No %s compatible field found.\n",
	    fromDataFld->tag, rcd_out->format );
      
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
	
    }
    
    return 0;
  }
    
  /*
   * dfpPtr->toTag!=NULL. 
   * FOUND PORTION TABLE, 
   * AND AN APPROPRIATE TO_TAG IN IT.
   */
  
  toTag=dfpPtr->toTag;

      
  if (NFld==TRUE)		/*NEW FIELD? Generally yes.*/
    toFld=(field *)createField(rcd_out, toTag);
  else
    toFld=(field *)accessField(rcd_out, toTag);
    
  /* * * * * * * * *
   *      TEXT     *
   * * * * * * * * */
  if (dfpPtr->text!=NULL){
    if (toFld->datafield->text != NULL) free (toFld->datafield->text);
    toFld->datafield->text=(char *)calloc(strlen(dfpPtr->text)+1,sizeof(char));
    strcpy(toFld->datafield->text,dfpPtr->text);
  }

  /*%%%%%%%%%%    PREFIX AND XIFERP ROUTINES  %%%%%%*/
  
  
  if(gnTbl->prefixTreatment==TRUE){
    /*Converting to A UNIMARC linking field - prefix*/
    
    int resPfx;
    if (pts!=NULL)
      resPfx=convertUnimarcLinkingField(pts,
					rcd_out, 
					fromField, 
					toFld
					);
    if (resPfx==-1){
      char m[200];
      sprintf(m, 
	      "warning: ( convertDataField() )\n  Failed to convert UNIMARC linking field\n" 
	      );
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
      }
          makePrivateField_FULL(rcd_in->format, rcd_out, fromField, "Could not create  a linking field");
    }
    return resPfx;
  }
  
  if (gnTbl->xiferpTreatment==TRUE){
    /*Converting from A UNIMARC linking field - prefix*/
    
    int resXfp;
    
    /*
     * We initialize and send a pair of indicators that will
     * return with the indicator values resulting from the indicator
     * treatment within the xiferp routine. For either indicator, if its
     * corresponding value in tmpInd remains '#' on exit from 
     * convertLinkingFieldFromUNIMARC() - Dont change its value.
     * Update the value on any other tmpInd value than '#'
     */
    char *tmpInd=(char *)calloc(4,sizeof(char));
    strcpy(tmpInd, "%##");
    if (xts!=NULL){
      resXfp=convertLinkingFieldFromUNIMARC(its,
					    xts,
					    fromField,
					    toFld,
					    tmpInd	);
      
      if(  tmpInd[1]!='#' )
	toFld->datafield->indicators[1]=tmpInd[1];
      if(  tmpInd[2]!='#' )
	toFld->datafield->indicators[2]=tmpInd[2];
      
      
    }
    else{
      makePrivateField_FULL(rcd_in->format, rcd_out, fromField,
		       "No suitable table to convert linking field\n");
    }
    
    return resXfp;
  }
  


  /* * * * * * * * *
   *  INDICATOR1   *
   * * * * * * * * */
  /*Put correct indicators into the to-field*/
  /** to do
   *
   * treatment_parX=indXtoValue!!! CHANGE!
   **/
  for (k=0;k<dfpPtr->ind1ArrayLength;k++){
    toInd = dfpPtr->ind1toInd[k]==1?
      toFld->datafield->indicators+1:
    toFld->datafield->indicators+2;
    
    switch (dfpPtr->ind1function[k]){
    case (char)NULL:
      if (dfpPtr->ind1fromValue[k]=='N'){ /*S1*/
	
	*toInd = dfpPtr->ind1toValue[k]=='N'? /*S2*/
	  fromDataFld->indicators[1]: /*copy from_Ind regardless of value*/
	dfpPtr->ind1toValue[k]; /*Copy from conversion table*/
      }
      else{			/*Copy on equality between indicator value and
				  table value*/
	if (dfpPtr->ind1fromValue[k]/*S1*/ 
	    == fromDataFld->indicators[1]){
	  *toInd =  dfpPtr->ind1toValue[k];
	}
      }
      break;
    case 'z':{
      /*Set indicator through special table lookup*/
      if (its!=NULL){
	ind=setIndicatorZ(dfpPtr->ind1toInd[k], /**1?**/
			  dfpPtr->ind1toValue[k],/*S2*/
			  rcd_in,
			  fromField,
			  its,
			  NULL);
      }
      else{
	ind='0';
      }
      *toInd = ind=='0' ? toUndefinedIndValue : ind;
      
    }
      break;
    case 'h':
      ind=setIndicatorH(fromField,
			dfpPtr->ind1toValue[k],/*S2*/
			dfpPtr->ind1special[k]/*TO*/
			);
      
      *toInd = ind=='0' ? toUndefinedIndValue : ind;
      break;
    case 'u':
      ind=setIndicatorU(toFld,
			dfpPtr->ind1toValue[k],/*S2*/
			dfpPtr->ind1special[k]/*TO*/
			);
      
      *toInd = ind=='0' ? toUndefinedIndValue : ind;
      break;
    case 'v':
      ind=setIndicatorV(rcd_in,
			toFld,
			dfpPtr->ind1toValue[k],/*S2*/
			dfpPtr->ind1special[k]/*TO*/
			);
      *toInd = ind=='0' ? toUndefinedIndValue : ind;
      break;
    case 'q':{
      
      ind=setIndicatorQ(fromField,
			dfpPtr->ind1toValue[k],/*S2*/
			fromUndefinedIndValue,
			dfpPtr->ind1special[k],/*TO*/
			dfpPtr->ind1fromValue[k]/*S1*/
			);
      *toInd = ind=='0' ? toUndefinedIndValue : ind;
      break;
    }
    }
    
  }
      
    
  /* * * * * * * * *
   *  INDICATOR2   *
   * * * * * * * * */
  
  /*Put correct indicators into the to-field*/
  /**treatment_parX=indXtoValue!!! CHANGE!**/
  for (k=0;k<dfpPtr->ind2ArrayLength;k++){
    toInd = dfpPtr->ind2toInd[k]==1?
      toFld->datafield->indicators+1:
      toFld->datafield->indicators+2;
    switch (dfpPtr->ind2function[k]){
      
    case (char)NULL:
      if (dfpPtr->ind2fromValue[k]=='N'){ /*S1*/
	
	*toInd = dfpPtr->ind2toValue[k]=='N'? /*S2*/
	  fromDataFld->indicators[2]: /*copy from_Ind regardless of value*/
	    dfpPtr->ind2toValue[k]; /*Copy from conversion table*/
      }
      else{			/*Copy on equality between indicator value and
				  table value*/
	if (dfpPtr->ind2fromValue[k]/*S1*/ 
	    == fromDataFld->indicators[2]){
	  *toInd =  dfpPtr->ind2toValue[k];
	}
      }
      break;
    case 'z':{
      /*Set indicator through special table lookup*/
      if (its!=NULL){
	ind=setIndicatorZ(dfpPtr->ind2toInd[k], /**1?**/
			  dfpPtr->ind2toValue[k],/*S2*/
			  rcd_in,
			  fromField,
			  its,
			  NULL);
      }
      else
	ind='0';
      
      *toInd = ind=='0' ? toUndefinedIndValue : ind;
    }
      break;
    case 'h':
      ind=setIndicatorH(fromField,
			dfpPtr->ind2toValue[k],/*S2*/
			dfpPtr->ind2special[k]/*TO*/
			);
      
      *toInd = ind=='0' ? toUndefinedIndValue : ind;
      break;
    case 'u':
      ind=setIndicatorU(toFld,
			dfpPtr->ind2toValue[k],/*S2*/
			dfpPtr->ind2special[k]/*TO*/
			);
      
      *toInd = ind=='0' ? toUndefinedIndValue : ind;
      break;
    case 'v':
      ind=setIndicatorV(rcd_in,
			toFld,
			dfpPtr->ind2toValue[k],/*S2*/
			dfpPtr->ind2special[k]/*TO*/
			);
      *toInd = ind=='0' ? toUndefinedIndValue : ind;
      break;
    case 'q':{
      
      ind=setIndicatorQ(fromField,
			dfpPtr->ind2toValue[k],/*S2*/
			fromUndefinedIndValue,
			dfpPtr->ind2special[k],/*TO*/
			dfpPtr->ind2fromValue[k]/*S1*/
			);
      *toInd = ind=='0' ? toUndefinedIndValue : ind;
      break;
    }
    }
    
  }
  
  /*Put correct indicators into the to-field*/
  /**treatment_parX=indXtoValue!!! CHANGE!**/
  
  /*%%%%%%%%%%    SUBFIELDS  %%%%%%%%%%%%%*/
  
  /*Go through all subFields*/
  for (i=0;i<fromDataFld->ArrayLength; i++){
    /*	if (fromDataFld->subFields[i]->subFieldCode==32){
	int v=1;
	}*/
    res=convertSubField(rcd_in, rcd_out, toFld, fromField, i, dfpPtr, cts);
    
    if (res!=0){
      char m[200];
      
      sprintf(m, "convertDataField()\n   error converting Field %s, subField '%c'\n   ignoring\n",
	      fromDataFld->tag, 
	      fromDataFld->subFields[i]->subFieldCode);
      
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
      }
      
      
    }
    else{
      /*reset flag*/
      NFld=FALSE;
      
      /**return a value for correct result**/
    }
  } /*for*/
  
  return 0;
  
  
} /*convertDataField*/





