       /* * * * * * * * * * * * * * * * *    
        *  MARCconv        Version 2.3  * 
        *   File:    dataFields_pfx.c   * 
        *        Prefixing and          *
	*      xiferping routines       * 
        *    for UNIMARC minirecords    * 
        *    Last update: 28/01/1997    * 
        *      Michael S. Preminger     * 
        *      BRODD, OSLO COLLEGE      * 
        *        THE ONE PROJECT        * 
        * * * * * * * * * * * * * * * * */



#include <setjmp.h>

#include "MARCproto.h"




extern jmp_buf marcconv_env;


/* * * * * * * * * * * * * * * * *    
 *          UTILITIES            *
 * * * * * * * * * * * * * * * * */

char  *updateRgData(char *toData,/*tmpSF->data,*/
		    char *fromData,/*fromSubFieldString, */
		    int start,/*rg->start[i+1], */
		    int end/*rg->end[i+1]*/){
  int lenToData=end-start;
  if (lenToData<=0)
    return NULL;
  toData=(char *)calloc(lenToData+1,sizeof(char));
  strncpy(toData,fromData+start,lenToData);
  return toData;
}


int copySubFieldInformation(char *codes, char *from, char *subFieldData[]){
  int i=0,j=0;
  while (*(from+i)!='$' && *(from+i)!='\0')
    i++;

  if (*(from+i)=='\0')
    return -1;
  while (*(from+i)!='\0'){
    if (*(from+i)=='$'){
      if(isalnum(*(from+i+1)))
	memset(codes+strlen(codes),*(from+i+1),1);
      else{
	
	char m[200];
	sprintf(m, "copySubFieldInformation() an error in prefix table or incoming record: %s\n", codes);
	if (ONETK_WriteLogFile(fildes, m)==-1){
	  /**Error handle**/
	}
	return -1;
	
      }
      j=findIndex(from+i+1, '$')+1;
      subFieldData[strlen(codes)-1]=(char *)calloc(j+1,sizeof(char));
      strncpy(subFieldData[strlen(codes)-1], from+i+2,j-2);
      i+=j;
    }
    
  }
  return 0;
}
Boolean compareIndicators(char field_ind, char table_ind){
  if (table_ind=='N' && isdigit(field_ind)!=0)
    return TRUE;
  if (table_ind==field_ind)
    return TRUE;
  return FALSE;
}

/* * * * * * * * * * * * * * * * *    
 *         CONVERSION OF         *
 *        LINKING  FIELDS        *
 *          TO  UNIMARC          *
 * * * * * * * * * * * * * * * * */

PortionTable_Prefix *findPrefixTablePortion(prefixing_table_str *ps,
					    char *tag, 
					    char *indicators){

  int i;
  for (i=0;i<ps->ArrayLength;i++){
    if (strncmp(ps->fromTags[i], tag, 3)==0
      &&
	compareIndicators(*(indicators+1),ps->fromInd1[i])==TRUE
	&&
	compareIndicators(*(indicators+2),ps->fromInd2[i])==TRUE
	)
      return ps->Table[i];
    /**ERROR MESSAGE**/
  }
  if (i== ps->ArrayLength){ 
    char m[200];
    sprintf(m, "findPrefixTablePortion: No table found for tag %s indicators %s\n\n",
	    tag, indicators+1
	    );
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    return NULL;
  }
}
int prefixSbTblMatch(PortionTable_Prefix *ptPfx,
		     field *fld,
		     int idx
){
  dataField *df=fld->datafield;
  subField *sf=df->subFields[idx];
  char sfCode=df->subFieldCodes[idx];
  int i, resexec;
  for (i=0;i<ptPfx->ArrayLength; i++){
    if(ptPfx->fromSubFieldCode[i]==sfCode) {
       if  (ptPfx->sf_contents[i]==NULL 
	    ||
	    regexec(ptPfx->sf_content_compExp[i], 
		    sf->data, 0,NULL,REG_NOTBOL)==0){
	 return i;
       }
       else return -1;
     }
  }
  return -1;
}
int extractFieldData(char *fieldStr,
		     char *tag, 
		     char *ind,
		     char *sfCodes,
		     char *subFieldData[]){
     /*should come allocated and zeroed*/
  int res;
  if (fieldStr==NULL)
    return -1;
  strncpy(tag, fieldStr,3);
  memset(tag+3,'\0',1);

     /*Check if both indicators are present*/
  if (*(fieldStr+3)=='$' 
      || 
      *(fieldStr+4)=='$'){
    /*error message*/
    return -1; 
  }
  memcpy(ind, fieldStr+3,2);
  /*Check if subfields start correctly*/
  if (*(fieldStr+5)!='$'){
    /*error message*/
    return -1;
  }
  res = copySubFieldInformation(sfCodes, fieldStr, subFieldData);
  if (res==-1){
    char m[200];
    sprintf(m, "extractFIeldData() : copySubFieldInformation failed\n");
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }

  }
  return ;
}



void *miniRcdToFld_ToUnimarc(record *mRcd,
		   field *toFld /*
				 * The toFld comes 
				 * allocated, linked to 
				 * the output record 
				 * structure and
				 * assigned a field tag
				 */
		   ){
  
  int fldIdx, sfIdx;
  char *tmpStr;
  dataField *fromDF, *toDF;  
  char *fieldStr;


  toDF=toFld->datafield;

  for (fldIdx=0;fldIdx< mRcd->ArrayLength; fldIdx++){
    subField *toSF;

    fromDF=mRcd->fields[fldIdx]->datafield;
    
    toSF=createSubField(toFld,'1');
    toSF->data=(char *)malloc(1000);
    memset(toSF->data, '\0', 1000);
    
    
    /*
     * tag
     */
    strcat(toSF->data, fromDF->tag);

    /*
     * indicators
     */
    memcpy(toSF->data+strlen(toSF->data), fromDF->indicators+1,2);
    
    /*
     * subfields
     */
    for (sfIdx=0;sfIdx<fromDF->ArrayLength;sfIdx++){
      subField *fromSF;

      fromSF=fromDF->subFields[sfIdx];

      /*
       * $+subFieldCode
       */
      *(toSF->data+strlen(toSF->data))='$';
      *(toSF->data+strlen(toSF->data))=
	fromSF->subFieldCode;

      /*
       * contents
       */
      strncat(toSF->data, fromSF->data, strlen(fromSF->data));
    }
  }
}

int P_directConvert(field *toFld, 
		    subField *fromSF,
		    PortionTable_Prefix *ptpx, 
		    int index ,
		    char sfcode/*
			   * extracted previously
			   * from ptpx
			   * by extractFieldData
			   */
		    ){
  
  subField *toSF;
  int res=0;
  
  toSF=(subField *)createSubField(toFld, sfcode);
  toSF->data=(char *)malloc((strlen(fromSF->data)+1)*sizeof(char));
  memset(toSF->data,'\0',strlen(fromSF->data)+1);
  strcat(toSF->data, fromSF->data);
  
  
  
  /** to do
   * MAKE USE OF THE RETURN VALUE
   **/
  return res;
}

int P_splitSubField(field *toFld, 
		    subField *fromSF,
		    PortionTable_Prefix *ptvd, 
		    int index,
		    char *sfCodes/*
			    * Extracted previously
			    * from ptvd
			    */
		    ){
  /*
   * This is a version of splitSubField that only splits 
   * sub fields that split in 2. (let alone cases 
   * of character count split) 
   * Larger sub fieds are at the moment not split.
   * The entire sub field is converted into the first 
   * of the to sub fields, using directConvert()
   */
  int res=0;
  int resmatch;
  /*
   * SPLIT BY CHARACTER COUNT k|l|...|n
   * From sub field is split into subfields of 
   * k, l,...n characters
   * long by positions. 
   * One of the number may be unknown, and
   * denoted by 'x'. In such a case 
   * ptvd->treatment_par = e.g. "3|x|4" 
   */
 
  if (ptvd->treatment_par[index]==NULL){
    char m[200];
    sprintf(m, "splitSubField()\n   toTag: %s subField: %c - No splitting information in VDF table.\n", 
	    toFld->datafield->tag,
	    ptvd->fromSubFieldCode[index]!=(char)NULL?
	    ptvd->fromSubFieldCode[index]:
	    '#');
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    return -1;
    
  }
  
  /*
   * Check if split is done on number 
   * of characters k|l|...|n
   */

  if (strchr(ptvd->treatment_par[index], '|')!=NULL){
    char subFieldCodes[10];
    int lengths[10]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1}; /*length 0 means unknown (x)*/
    char *data[10]={NULL, NULL, NULL, NULL, NULL, 
		      NULL, NULL, NULL, NULL, NULL};
    char *ptr=ptvd->treatment_par[index];
    char *nr_chr=ptvd->treatment_par[index]+strlen(ptvd->treatment_par[index])-1;
    int i,j,s,t, Nelem=0;

    for(i=0;i<strlen(sfCodes);i++){
      subFieldCodes[i]=*(sfCodes+i);
      while(*ptr=='|')
	ptr++;
      if (*ptr=='x')
	lengths[i]=0;
      else
	lengths[i]=toNumber(*ptr);
      ptr++;
    }
    /*update the data[] array with data*/
    /*if x is not first - start at the beginning of the array*/


    s=0;
    for (j=0;j<i;j++){

      /*If the "rest" - unknown number of characters 
	(x) is not to be taken from the end of the subfield 
	text, then we need to count from the end.*/
      if (lengths[j]==0 ){
	int t = strlen(fromSF->data);
	int k;
	for (k=i-1;k>j;k--){
	  data[k]=(char *)malloc(lengths[k]+1);
	  memset(data[k], '\0', lengths[k]+1);
	  t=t-lengths[k];
	  if (t<s){
	    /*ERROR MESSAGE*/
	  }
	  else{
	    strncpy(data[k],fromSF->data+t,lengths[k]);
	  }
	}
	/*now k is on the "rest" position of the array */
	if (t>s){
	  data[k]=(char *)malloc(((t-s)+1)* sizeof(char));
	  memset(data[k], '\0', (t-s)+1);
	  strncpy(data[k],fromSF->data+s,t-s);
	  lengths[k]=t-s;
	}
	break;
      }
      else{
	data[j]=(char *)malloc(lengths[j]+1);
	memset(data[j], '\0', lengths[j]+1);
	strncpy(data[j],fromSF->data+s,lengths[j]);
	s+=lengths[j];
      }
    }

    /*Now construct the necessary sub fields*/
    i=0;
    while (lengths[i]!=-1){

      if (lengths[i]!=0){
	subField *toSF = 
	  (subField *)createSubField(toFld, 
				     subFieldCodes[i]);
	toSF->data=data[i];
      }
      i++;
    }
  }
  else/*DELIMITER MATCH*/{
    /*  
     *   SPLIT BY DELIMITER MATCH
     */

#ifdef SPLIT_REGEX  
    /* 
     *Entire expression matches?
     */
    struct re_registers *rg=(struct re_registers *)calloc(1, sizeof(struct re_registers));
    char *fromSubFieldString=fromSF->data;
    resmatch=re_match (ptvd->sf_content_compExp[index],
		       fromSubFieldString,
		       strlen(fromSubFieldString),
		       0,rg);
    if (resmatch<0) return -1;
    if (rg->num_regs==0){
      return P_directConvert(toFld, fromSF, ptvd, index, *sfCodes);
    }
      
    if (rg->start[0]==0 
	&&
	rg->end[0]==strlen(fromSubFieldString)
	&&
	strchr(ptvd->sf_contents[index],'(')!=NULL
	)
      {
	int i;
	subField *tmpSF;
	char *tmpData;
	/*
	 * Go through all part-expressions
	 */
	if (strlen(sfCodes)!=rg->num_regs){
	  /*error, return*/
	}
	/*Create sub fields to split into*/
	/*	pointerToFirstSubField=datafield->ArrayLength;*/
	for (i=0;i<strlen(sfCodes);i++){
	  tmpSF=createSubField(toFld, *(sfCodes+i));
	  tmpData=updateRgData(tmpSF->data,fromSubFieldString, 
				      rg->start[i+1], 
				      rg->end[i+1]);
	  if(tmpData==NULL){
	    char m[200];
	    sprintf(m, "Failed to update subFields from prefix table\n");
	    if (ONETK_WriteLogFile(fildes, m)==-1){
	      /**Error handle**/
	    }
	    return -1;
	    
	    
	  }
	  tmpSF->data=tmpData;
	}
      }
#else      
    /*
     * Check if there are more than 2 target subfields  
     * if so - reduce to 2
     */
    if (strlen(sfCodes)>2){
      /*Leave only the first two TO subfields.*/
      *(sfCodes+2)='\0';

      /*Done without a check. The check belongs in the TABGEN MACRO*/
      *(ptvd->treatment_par+1)='\0';
    }
    
    if (strlen(sfCodes) == 2 /*Should always yield true*/ 
	&&
	isalnum(*(ptvd->treatment_par[index]))==0
	/*With only two subfields to split, 
	 * on an ISBD character, 
	 * the splitting is going to make sense
	 */
	
	/*
	 * Now check that the splitting character 
	 * really is on the
	 * sub field
	 */
	&&
	strchr(fromSF->data, *(ptvd->treatment_par[index]))!=NULL
	)

      {
	int len1, len2;
	subField *toSF1 = 
	  (subField *)createSubField(toFld, 
				     *(sfCodes));
	subField *toSF2 = 
	  (subField *)createSubField(toFld, 
				     *(sfCodes+1)
				     );
      
	/*find lengths of 2 "split" strings*/
	/*len1=strcspn(fromSF->data, ptvd->treatment_par[index]);*/
	len1=mystrcspn(fromSF->data, ptvd->treatment_par[index]);
	len2=strlen(fromSF->data)- (len1+1);
      
	toSF1->data=(char *)malloc((len1+1)*sizeof(char));
	strncpy(toSF1->data, fromSF->data, len1);
	memset(toSF1->data+len1,'\0',1); /*terminate*/
	toSF1->data=trim(toSF1->data);
	toSF2->data=(char *)malloc((len2+1)*sizeof(char));
	strncpy(toSF2->data,fromSF->data+len1+1,len2);
	memset(toSF2->data+len2,'\0',1); /*terminate*/
	toSF2->data=trim(toSF2->data);
      }
    else			/*MORE THAN 2  OR NON ISBD DELIMITERS*/ 
      P_directConvert(toFld, fromSF, ptvd, index, *sfCodes);
    #endif /*SPLIT_REGEX*/
  }
  return res;
}

record *createMiniRecord(prefixing_table_str *ps,
field *fld)
{
  
  record *miniRcd;
  char *mRcdStr;
  dataField *df=fld->datafield;
  field *tmpFld;
  int sfIdx, ptIdx;
    int ptxEntryIdx;
  PortionTable_Prefix *pt_pfx;
  /*
   * Create a mini record
   * structure
   */
  miniRcd=(record *)createRecord();
  
  pt_pfx=findPrefixTablePortion(ps, df->tag, df->indicators);
  if (pt_pfx==NULL){
      char m[200];
      sprintf(m, "No sub table exists for tag %s, indicators %c%c\n",
	                            df->tag,   *(df->indicators+1),
	      *(df->indicators+2)
	      );
      if (ONETK_WriteLogFile(fildes, m)==-1){
	longjmp(marcconv_env,1);
      }
      return NULL;
  }

/*
 * GO THROUGH ALL SUB FIELDS IN THE FIELD
 */
  for (sfIdx=0;sfIdx<df->ArrayLength;sfIdx++){

    /*  
     * match with all table entries, until found 
     */
    ptIdx=prefixSbTblMatch(pt_pfx,fld,sfIdx);
    if (ptIdx==-1){
      char m[200];
      sprintf(m, "No match for tag %s, sub field  $%c in prefix table. SubField ignored. \n",
	                            df->tag,        df->subFieldCodes[sfIdx]
	      );
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
      }
    }
    else{
      dataField *tmpDF;
      /*
       * Extract tag and indicator
       * from the prefix table entry (indexed
       * by ptIdx)
       */
      char *indicators=(char *)calloc(3,sizeof(char));
      char *tag=(char *)calloc(4,sizeof(char));
      char *subFieldCodes=(char *)calloc(MAX_SUBFIELDS_IN_DATA_FIELD,sizeof(char));
      char *subFieldData[10];

      if (extractFieldData(pt_pfx->toField[ptIdx], tag, indicators, subFieldCodes, subFieldData)==-1){
	char m[200];
	sprintf(m, " createMiniRecord() error extracting data from prefix table\n");
	if (ONETK_WriteLogFile(fildes, m)==-1){
	  /**Error handle**/
	}
	return NULL;
	
	/*error message, abort*/
      }
      
  
      
      tmpFld=createField(miniRcd, tag);
      tmpDF=tmpFld->datafield;
      strncpy(tmpDF->tag, tag, 3);
      tmpDF->indicators[0]='%';
      tmpDF->indicators[1]=*indicators;
      tmpDF->indicators[2]=*(indicators+1);

      /*
       * Use the subfield conversion routines
       * for splitting and  merging by the prefix
       * table.
       */
      switch(pt_pfx->fromFunction[ptIdx]){
      case 'd': break;
      case 'a':      
	if (strlen(subFieldCodes)==1){
	  P_directConvert(tmpFld, df->subFields[sfIdx], pt_pfx, ptIdx, *subFieldCodes);
	}
	else{
	  /** to do
	   * ERROR MESSAGE
	   **/
	  return NULL;
	}
	break;
      case 'c':
	if(P_splitSubField(tmpFld, df->subFields[sfIdx],
		      pt_pfx, ptIdx, subFieldCodes)==-1){
	  return NULL;
	};
	

      }/*switch*/

    } /*else */
  } /*for i = df....*/
  return miniRcd;
}

int convertUnimarcLinkingField(prefixing_table_str *ps,
			       record *outputRcd,
			       field *fromField,
			       field *toField
			       ){  

  
  record *miniRcd;

  miniRcd=createMiniRecord(ps, fromField);
  if (miniRcd==NULL){
    char m[200];
    sprintf(m, "convertUnimarcLinkingField() error in creating mini record, tag %s\n", fromField->datafield->tag);
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }

    return -1;
	

    
  }

 
  miniRcdToFld_ToUnimarc(miniRcd, toField);

  
  freeRecord(miniRcd);


}

/* * * * * * * * * * * * * * * * *    
 *         CONVERSION OF         *
 *        LINKING  FIELDS        *
 *         FROM  UNIMARC         *
 * * * * * * * * * * * * * * * * */
void *parseSubFieldsIntoMiniRecord(record *miniRcd, 
				    field *lnk_fld){
  int i,j;
  field *tmpFld;
  dataField *lnk_df=lnk_fld->datafield;
  for (i=0;i<lnk_df->ArrayLength;i++){
    char *indicators=(char *)calloc(3,sizeof(char));
    char *tag=(char *)calloc(4,sizeof(char));
    char *subFieldCodes=(char *)calloc(MAX_SUBFIELDS_IN_DATA_FIELD,sizeof(char));
    char *subFieldData[10];
    extractFieldData(lnk_df->subFields[i]->data, tag, indicators, subFieldCodes, subFieldData);
    tmpFld=createField(miniRcd, tag);
    tmpFld->datafield->indicators[0]='%';
    strncpy(tmpFld->datafield->indicators+1,indicators,2);

    /*
     * SUB FIELDS
     *
     */
    
    for (j=0;j<strlen(subFieldCodes);j++){
      subField *tmpSF;
      tmpSF=createSubField(tmpFld, *(subFieldCodes+j));
      tmpSF->data=subFieldData[j];
    }
  free(tag);
  free(subFieldCodes);
  free(indicators);
  }
}

int matchPtxEntry(PortionTable_Xiferp *ptx,
		  subField *sf){
  int i;
  for (i=0;i<ptx->ArrayLength;i++){
    if (ptx->fromSubFieldCode[i]==sf->subFieldCode)
      return i;
  }
  return -1;
}
PortionTable_Xiferp *findPortionTable_XFP(xiferping_table_str *xts,
					  char *tag
					  /** to do
					   * , Need a 
					   * to_tag 
					   * parameter
					   **/
					  ){
  int i;
  for (i=0; i< xts->ArrayLength;i++){
    if (strncmp(xts->fromTags[i], tag, 3)==0)
      return xts->Table[i];
  }
  return NULL;
}


void miniRecordToField_FromUnimarc(indicator_table_str *its,
				   xiferping_table_str *xts,
				   record *miniRcd,
				   field *toField,

				   /*
				    * Comes allocated, 3 characters long, 
				    * and with a leading '%' ("%##")
				    * if either of the indicators is 
				    * undefined - # is returned as the
				    * indicator value. This value will later be
				    * translated into the actual undefined value:
				    * ' ' or '0'
				    */
				   char *indicators){
  int i, j, ptxIdx, res;
  PortionTable_Xiferp *ptx;


  for (i=0;i<miniRcd->ArrayLength;i++){
    dataField *df=miniRcd->fields[i]->datafield;
    if (its!=NULL){
      /*********************
	Check indicator table
	**********************/
      /*
       * A temporary procedure for updating of indicators:
       * since the values of the linking field indicators are 
       * determined by the values inside the the minirecords, 
       * the indicators table  will be checked for every minirecord 
       * field (each run of the enclosing loop), assuming 
       * that at most one of the fields will give a non-undefined 
       * value to either of the indicators
       */

      /*indicator 1*/
      indicators[1] = indicators[1]=='#'? 
	setIndicatorZ(1, '\0', miniRcd, miniRcd->fields[i], its, NULL):
	  indicators[1];
      
      /*indicator 2*/
      indicators[2] = indicators[2]=='#'? 
	setIndicatorZ(2, '\0', miniRcd, miniRcd->fields[i], its, NULL):
	  indicators[2];
    }
    ptx=findPortionTable_XFP(xts,
			     df->tag 
			     /** to do
			      * , need a 
			      * toTag 
			      * parameter 
			      **/);
    
    /*
     * Each from_field goes to a subfield in the to_field.
     * Even though -  we use a for loop, because if it is a 
     * merge, we want to be sure to get an error message 
     * on failure
     */
    toField->datafield->indicators[1]=indicators[1];
    toField->datafield->indicators[2]=indicators[2];
    for (j=0;j<df->ArrayLength;j++){
      subField *sf=df->subFields[j];
      ptxIdx=matchPtxEntry(ptx, sf);
      if (ptxIdx==-1){
	char m[200];
	sprintf(m, "miniRecordToFld_FromUnimarc() No match for field %s, subField $%c %s\n", 
		df->tag, sf->subFieldCode, sf->data);
	if (ONETK_WriteLogFile(fildes, m)==-1){
	  /**Error handle**/
	}
	
      }
      else{
	switch(ptx->fromFunction[ptxIdx]){
	case 'b': 
	case 'e': 
	case 'g':
	case 'k': 
	case 'm': 
	case 'n': 
	case 'p': 
	case 's': 
	case 't': 
	case 'w':
	  res=X_mergeSubField(toField,miniRcd->fields[i], j, ptx, ptxIdx );
	  break;
	case 'a':
	  res=X_directConvert(toField, sf, ptx, ptxIdx);
	  break;
	}
      }
    }
  }
}


int convertLinkingFieldFromUNIMARC(indicator_table_str *its,
				   xiferping_table_str *xts,
				   field *fromF,
				   field *toF,
				   char *tmpInd
){
  record *miniRcd;
  /* 
   * char *tmpInd=(char *)calloc(4,sizeof(char));
   * strcpy(tmpInd, "%##");
   */
  miniRcd=createRecord();
  
  parseSubFieldsIntoMiniRecord(miniRcd, fromF);

  miniRecordToField_FromUnimarc(its, xts, miniRcd, toF, tmpInd);
}

int X_directConvert(field *toFld, 
		  subField *fromSF,
		  PortionTable_Xiferp *ptx, 
		  int index ){
  
  subField *toSF;
  int res=0;
  
  toSF=(subField *)createSubField(toFld, *(ptx->toSFCodes[index]));
  toSF->data=(char *)malloc((strlen(fromSF->data)+1)*sizeof(char));
  memset(toSF->data,'\0',strlen(fromSF->data)+1);
  strcat(toSF->data, fromSF->data);
  
  
  
  /**MAKE USE OF THE RETURN VALUE**/
  return res;
}

int X_mergeSubField(field *toFld, 
		    field *fromFld, 
		    int sbFldIdx, 
		    PortionTable_Xiferp *ptx, 
		    int index){

  dataField *toDtFld;
  subField *fromSF, *toSF;

  int res=0;

  if (toFld->datafield==NULL){
    toFld->datafield=(dataField *)calloc(1,sizeof(dataField));
  }
  toDtFld=toFld->datafield;

  /* The entire merge will be executed upon encountering the 
   * first of the source subfields in the from field. 
   * it means that the function takes
   * control, finds the other from_Subfields, and performs 
   * the merge. 
   * This means that the first thing is
   * to check if the merge has already been performed. 
   * A straightforward 
   * method is to check for the  existence of the to sub field 
   * string.     and if it exists - the    occurence of the 
   * from subfield string 
   * in the to sub field (probably unnecessary) 
   */
  fromSF=fromFld->datafield->subFields[sbFldIdx];
  toSF=accessSubField(toFld, *ptx->toSFCodes[index]);

  if (toSF->data!=NULL && strstr(toSF->data, fromSF->data)!=NULL){
    /*Merge already performed*/
    return res;
  }
  else{
    
    subField *tmpFromSF;
    char tmpFromSFCode;
    int sf_cnt=0;
    int i=0;
    int j=0;
    int cntSF, tmpIndex;
    int sfSize=findMergeSize(fromFld, ptx->treatment_par[index]);
    toSF->data=(char *)malloc((sfSize+1)*sizeof(char));
    memset(toSF->data, '\0', sfSize+1);
    cntSF=strlen(ptx->treatment_par[index]);

    /*Go through the cell in the conversion table  containing 
      the codes of the from sub fields to be merged, 
      1. find the subFields in the from record by its code
      2. Find the code in the conversion table and decide how
      to merge it
      3. Perform the merge	 */
    for (i=0;i<cntSF;i++){
      tmpFromSFCode=*(ptx->treatment_par[index]+i);
      tmpFromSF=findSubField(fromFld, tmpFromSFCode);

      /*Make sure that all the subfields to be merge are present
	in this from record. Otherwise you have to skip!*/
      if (tmpFromSF!=NULL){
	sf_cnt++;
	/*find correct merge code (m, p or s) in table ptvd*/
	for(j=0;j<ptx->ArrayLength;j++){
	  if (tmpFromSFCode==ptx->fromSubFieldCode[j]){
	    break;
	  }
	
	}

	switch (ptx->fromFunction[j]){
	case 'b':{		/*leading " =/"*/
	  if (sf_cnt>1) strcat(toSF->data, " =/ ");
	  strcat(toSF->data, tmpFromSF->data);
	  
	}
	  break;
	case 'e':{		/*leading " = "*/
	  if (sf_cnt>1) strcat(toSF->data, " = ");
	  strcat(toSF->data, tmpFromSF->data);
	  
	}
	  break;
	case 'h':{		/*leading " "*/
	  if (sf_cnt>1) strcat(toSF->data, " ");
	  strcat(toSF->data, tmpFromSF->data);
	  
	}
	  break;
	case 'k':{		/*leading " : "*/
	  if (sf_cnt>1) strcat(toSF->data, " : ");
	  strcat(toSF->data, tmpFromSF->data);
	  
	}
	  break;
	case 'm':{		/*trailing ", "*/
	  if (sf_cnt>1) strcat(toSF->data, ", ");
	  strcat(toSF->data, tmpFromSF->data);
	  
	}
	  break;
	case 'n':{		/*leading " ; "*/
	  if (sf_cnt>1) strcat(toSF->data, " ; ");
	  strcat(toSF->data, tmpFromSF->data);
	  
	}
	  break;
	case 'p':{		/*Put between parantheses*/
	  strcat(toSF->data, "(");
	  strcat(toSF->data, tmpFromSF->data);
	  strcat(toSF->data, ")");
	}
	  break; 
	case 's':{		/*leading period*/
	  strcat(toSF->data, ".");
	  if (sf_cnt>1) strcat(toSF->data, tmpFromSF->data);
	}
	  break;
	case 't':{		/*leading " / "*/
	  if (sf_cnt>1) strcat(toSF->data, " / ");
	  strcat(toSF->data, tmpFromSF->data);
	}
	  break;
	case 'w':{		/*No prefix*/
	  strcat(toSF->data, tmpFromSF->data);
	}
	  break;
	default: {
	  char m[200];
	  sprintf(m, "mergeSubField()\n   Tag: %s subField: %c - No merge subField.\n    Probably error in conversion table\n", fromFld->datafield->tag, tmpFromSFCode);
	  if (ONETK_WriteLogFile(fildes, m)==-1){
	    /**Error handle**/
	  }
	  
	}
	}
      }
    }
    if (toSF->data!=NULL){
      toSF->data=realloc(toSF->data, 1+strlen(toSF->data));
    }
    return res;
  }
  return res;
}



