        /* * * * * * * * * * * * * * * * *    
	 *  MARCconv        Version 2.3  *
	 *  File:    dataFields_sbFld.c  * 
	 *    Straight conversion of     * 
	 *          sub fields           * 
	 *    Last update: 28/01/1997    * 
	 *      Michael S. Preminger     * 
	 *      BRODD, OSLO COLLEGE      * 
	 *        THE ONE PROJECT        * 
	 * * * * * * * * * * * * * * * * */

#include <setjmp.h>
#include "MARCproto.h"



extern jmp_buf marcconv_env;

/**UPON EXTENDING THE REPERTOIRE OF CONVERSION ROUTINES
  FOR SUBFIELDS:
  ------------------------------------------------------
  -WRITE THE NEW ROUTINE AS AN 'INT' RETURNING FUNCTION, FOLLOWING
  THE CONVENTION IN 'directConvert()'
  -ADD THE ROUTINE TO THE SEQUENCE BELOW, AND ADD A CASE STATEMENT
  WITH AN APPROPRIATE CALL TO THE 'SWITCH-CASE' CONSTRUCT 
  IN convertSubField() DOWN THIS FILE**/

int updateFaultField(char *fromFormat,
		     record *toRcd,
		   field *toF,
		   field *fromF,
		   int sfIdx){


  dataField *toDF=toF->datafield;
  dataField *fromDF=fromF->datafield;
  subField *noConvSF=fromDF->subFields[sfIdx];
  subField *contentSF;
  field *FaultFld;
  char *cmntText=(char *)calloc(70,sizeof(char));
  int curLen, catLen;
  /*
   * Is the last field in the to_record a 999 field?
   * (which would mean we only need to update it). 
   * If not - create a new 999 field
   */
  if (strcmp(toRcd->tags[toRcd->ArrayLength-1], "999")!=0){
    /*
     * Then we do not yet have a 999 field. 
     * Just check then that nothing
     * wend wrong, and that the last field in the record is the current
     * field we are working on
     */
    if (strcmp(toRcd->tags[toRcd->ArrayLength-1], toDF->tag)!=0){
      /*ERROR MESSAGE*/
      char m[200];
      sprintf(m, 
	      " updateFaultField()\n   Something wrong: Cuurent field not properly initialized in record"
	      );
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
      }
      /*
       * exit(1);
       */
      free(cmntText);
      return -1;
      
    }
    sprintf(cmntText, "Cited subfields from field %s have no conversion to %s %s ",
	    fromDF->tag,
	    toRcd->format,
	    toDF->tag
	    );
    makePrivateField_PART(fromFormat,
			  toRcd,
			  fromF,
			  sfIdx,
			  cmntText);
    free(cmntText);
    return 0;


  }
  else{ /*
	 * Field already exists - add non-convertible sub field 
	 * to its content subfield .
	 */
    FaultFld=toRcd->fields[toRcd->ArrayLength-1];
    contentSF=findSubField(FaultFld, PRIVATE_FIELD_CONTENT_SF);
    if (contentSF==NULL){
      char m[200];
      sprintf(m, 
	      " updateFaultField()\n   No content sub field in current 999 field!!\n"
	      );
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
	longjmp(marcconv_env, 1);
	
      }
      free(cmntText);
      return -1;

    }
    if (contentSF->data==NULL){
      char m[200];
      sprintf(m, 
	      " updateFaultField()\n   No data in content sub field of current 999 field!!\n"
	      );
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
	longjmp(marcconv_env, 1);
	
      }
      free(cmntText);
      return -1;
    }
    if (noConvSF->data==NULL){

      char m[200];
      sprintf(m, 
	      " updateFaultField()\n   No data in current subfield!!\n"
	      );
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
	longjmp(marcconv_env, 1);
	 
      }
      free(cmntText);
      return -1;
    }  
    curLen=strlen(contentSF->data);
    catLen=strlen(noConvSF->data)
      +1/*$*/
	+1/*sub field code*/
	  +3;/*terminator + just in case*/
    contentSF->data=realloc(contentSF->data, 
			    curLen+catLen
			    );
    memset( contentSF->data+curLen,'\0', catLen);
    strncat(contentSF->data, "$",1);
    strncat(contentSF->data, &noConvSF->subFieldCode, 1);
    strcat(contentSF->data, noConvSF->data);
    free(cmntText);
    return 0;
  }
}





int directConvert(field *toFld, 
		  subField *fromSF,
		  PortionTable_VarDat *ptvd, 
		  int index, int line ){
  
  subField *toSF;
  int res=0;
  
#ifdef APPEND_TO_SUBFIELD
  toSF=(subField *)accessSubField(toFld, *(ptvd->toSubField[index]));
  if (toSF->data != NULL){
    char *newContents=(char *)malloc( (strlen(toSF->data)+strlen(fromSF->data)+1) * sizeof(char));
    memset (newContents, '\0', strlen(toSF->data) + strlen(fromSF->data)+1);
    strcat (newContents, toSF->data);
    strcat (newContents, fromSF->data);
    free(toSF->data);
    toSF->data=newContents;
    
  }else{
    toSF->data=(char *)malloc((strlen(fromSF->data)+1)*sizeof(char));
    memset(toSF->data,'\0',strlen(fromSF->data)+1);
  } 

  strcat(toSF->data, fromSF->data); 
#else
  toSF=(subField *)createSubField(toFld, *(ptvd->toSubField[index])); 

  toSF->data=(char *)malloc((strlen(fromSF->data)+1)*sizeof(char));
  /*printf("%x allocating, called from line %d, tag=%s\n", toSF->data, line, toFld->datafield->tag);*/
  memset(toSF->data,'\0',strlen(fromSF->data)+1);
  strcat(toSF->data, fromSF->data);
#endif  
  
  
  /**MAKE USE OF THE RETURN VALUE**/
  return res;
}

int updateFromCopyField(record *from_rcd,
			field *toFld, 
			PortionTable_VarDat *ptvd, 
			int index ){
  
  char *tag=(char *)calloc(4,sizeof(char));
  char *subFieldCodes=(char *)calloc((strlen(ptvd->treatment_par[index])-3),sizeof(char));
  int i, toDataLength=0;
  char *toData=(char *)calloc(MAX_RECORD_LENGTH,sizeof(char));
  subField *toSF, *copySF;
  field *copyField;
  

  
  tag=strncpy(tag, ptvd->treatment_par[index],4);
  subFieldCodes=strcpy(subFieldCodes, 
		       ptvd->treatment_par[index]+4);
  
  copyField=findField(from_rcd, tag);
  for (i=0;i<strlen(subFieldCodes);i++){
    if (strlen(toData) > 0) strcat(toData, ", ");
    copySF = findSubField(copyField, *(subFieldCodes+i));
    if (copySF!=NULL)
      strcat(toData, copySF->data);
  }
  
  toSF=(subField *)createSubField(toFld, *(ptvd->toSubField[index]));
  toSF->data=(char *)malloc((strlen(toData)+1)*sizeof(char));
  memset(toSF->data,'\0',strlen(toData)+1);
  strcpy(toSF->data, toData);
  free(toData);
  
}
int prefixSubField(field *toFld, PortionTable_VarDat *ptvd, int index){
}
int mergeSubField(field *toFld, 
		  field *fromFld, 
		  int sbFldIdx, 
		  PortionTable_VarDat *ptvd, 
		  int index){

  dataField *toDtFld;
  subField *fromSF, *toSF;

  int res=0;

  if (toFld->datafield==NULL){
    toFld->datafield=(dataField *)calloc(1,sizeof(dataField));
  }
  toDtFld=toFld->datafield;

  /* The entire merge will be executed upon encountering the 
   * first of the source subfields in the from field. 
   * it means that the function takes
   * control, finds the other from_Subfields, and performs 
   * the merge. 
   * This means that the first thing is
   * to check if the merge has already been performed. 
   * A straightforward 
   * method is to check for the  existence of the to sub field 
   * string.     and if it exists - the    occurence of the 
   * from subfield string 
   * in the to sub field (probably unnecessary) 
   */
  fromSF=fromFld->datafield->subFields[sbFldIdx];
  toSF=accessSubField(toFld, *ptvd->toSubField[index]);

  if (toSF->data!=NULL && strstr(toSF->data, fromSF->data)!=NULL){
    /*Merge already performed*/
    return res;
  }
  else/*1*/{
    
    subField *tmpFromSF;
    char tmpFromSFCode;
    int cntSF; /*The length of the treatment string*/ 
    int sf_cnt =0; /* actually merged sub fields*/
    int i=0;
    int j=0;
    int nextSF=0;
    int tmpIndex, tmpres;
    char *tmp;

    /*Allocate enough memory. We reallocate down to necessary size at the end */
    int sfSize=findMergeSize(fromFld, ptvd->treatment_par[index]);
    if (toSF->data!=NULL) {
      tmp=toSF->data;
      toSF->data=(char *)malloc((sfSize+1)*sizeof(char));
      memset(toSF->data, '\0', sfSize+1);
      free(tmp);
    }else{
      toSF->data=(char *)malloc((sfSize+1)*sizeof(char));
      memset(toSF->data, '\0', sfSize+1);
    }

    
    if (ptvd->treatment_par[index]==NULL){
      char m[200];
      sprintf(m, 
	      " mergeSubField()\n vdf table error:  Empty treatment_par entry to a merging function.\n tag %s subFIeld %c.\n  Omitting sub-field",
	      fromFld->datafield->tag,
	      fromFld->datafield->subFieldCodes[sbFldIdx]
	      );
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
      }
      /*
       * exit(1);
       */
      return -1;
    }

    /*This is not necessarily the count of subfields to be merged*/
    cntSF=strlen(ptvd->treatment_par[index]);

    /*Go through the cell in the conversion table  containing 
      the codes of the from sub fields to be merged, 
      1. find the subFields in the from record by its code
      2. Find the code in the conversion table and decide how
      to merge it
      3. Perform the merge	 */
    for (i=0;i<cntSF;i++){
      
      tmpFromSFCode=*(ptvd->treatment_par[index]+i);
      
      /*
       * Is the sub field repeatable? (has an asterix wildcard)
       * In this case fine all the occurences (not necessarily consecutive
       * and perform the merge on them. Afterwords proceed to the remaining subfields
       */
      nextSF=0;
      if (*(ptvd->treatment_par[index]+i+1)=='+'){

	i++;
	tmpFromSF=findSubField(fromFld,tmpFromSFCode);
	while(1==1){
	  if (tmpFromSF==NULL)
	    break;
	  nextSF=tmpFromSF->index+1;
	  sf_cnt++;
	  
	  /*find correct merge code (m, p or s) in table ptvd*/
	  for(j=0;j<ptvd->ArrayLength;j++){
	    if (tmpFromSFCode==ptvd->fromSubfieldCode[j]){
	      break;
	    }
	  }
	  if (tmpres=mergeCorrectly(tmpFromSF, toSF, ptvd->fromFunction[j], sf_cnt)!=0){
	    
	    char m[200];
	    sprintf(m, "mergeSubField()\n   Tag: %s subField: %c - No merge subField.\n    Probably error in conversion table\n", fromFld->datafield->tag, tmpFromSFCode);
	    if (ONETK_WriteLogFile(fildes, m)==-1){
	      /**Error handle**/
	    }
	    res=-1;
	    
	    /*Just go on*/
	  }
	  
	  tmpFromSF=findNextSubField(fromFld,nextSF,tmpFromSFCode);
	  
	}

	
      }
      else{
	/*Here we treat non-repeating subfields*/
	tmpFromSF=findSubField(fromFld, tmpFromSFCode);
	
	/*Make sure that all the subfields to be merge are present
	  in this from record. Otherwise you have to skip!*/
	if (tmpFromSF==NULL) continue;
	if (tmpFromSF!=NULL){
	  sf_cnt++;
	  
	  /*find correct merge code (m, p or s) in table ptvd*/
	  for(j=0;j<ptvd->ArrayLength;j++){
	    if (tmpFromSFCode==ptvd->fromSubfieldCode[j]){
	      break;
	    }
	
	  }

	  if ( tmpres=mergeCorrectly(tmpFromSF, toSF, ptvd->fromFunction[j], sf_cnt)!=0 ){

	    char m[200];
	    sprintf(m, "mergeSubField()\n   Tag: %s subField: %c - No merge subField.\n    Probably error in conversion table\n", fromFld->datafield->tag, tmpFromSFCode);
	    if (ONETK_WriteLogFile(fildes, m)==-1){
	      /**Error handle**/
	    }
	    res=-1;
	    
	    /*Just continue performing*/
	  }
	} 
      }

      /*FINISHED MERGING. REALLOCATE DOWN TO NECESSARY SIZE*/
      if (toSF->data!=NULL && sf_cnt==cntSF){
	/*toSF->data=realloc(toSF->data, 1+strlen(toSF->data));*/
	return res;
      }

    }
    return res;
  }
}

int mergeCorrectly(subField *tmpFromSF,
		   subField *toSF, 
		   char functionChar,
		   int sf_cnt
){
  int res=0;
  switch (functionChar){
  case 'b':{		/*leading " =/"*/
    if (sf_cnt>1) strcat(toSF->data, " =/ ");
    strcat(toSF->data, tmpFromSF->data);
    
  }
  break;
  case 'e':{		/*leading " = "*/
    if (sf_cnt>1) strcat(toSF->data, " = ");
    strcat(toSF->data, tmpFromSF->data);
    
  }
  break;

  case 'g':{              /*leading "-" */
    if (sf_cnt>1) strcat(toSF->data, "-");
    strcat(toSF->data, tmpFromSF->data);
    
  }
  break;
  case 'h':{		/*leading " "*/
    if (sf_cnt>1) strcat(toSF->data, " ");
    strcat(toSF->data, tmpFromSF->data);
    
  }
  break;
  case 'k':{		/*leading " : "*/
    if (sf_cnt>1) strcat(toSF->data, " : ");
    strcat(toSF->data, tmpFromSF->data);
    
  }
  break;
  case 'm':{		/*trailing ", "*/
    if (sf_cnt>1) strcat(toSF->data, ", ");
    strcat(toSF->data, tmpFromSF->data);
    
  }
  break;
  case 'n':{		/*leading " ; "*/
    if (sf_cnt>1) strcat(toSF->data, " ; ");
    strcat(toSF->data, tmpFromSF->data);
    
  }
  break;
  case 'p':{		/*Put between parantheses*/
    if (sf_cnt>1) strcat(toSF->data, " ");
    strcat(toSF->data, "(");
    strcat(toSF->data, tmpFromSF->data);
    strcat(toSF->data, ")");
  }
  break; 
  case 's':{		/*leading period*/
    strcat(toSF->data, ".");
    if (sf_cnt>1) strcat(toSF->data, tmpFromSF->data);
  }
  break;
  case 't':{		/*leading " / "*/
    if (sf_cnt>1) strcat(toSF->data, " / ");
    strcat(toSF->data, tmpFromSF->data);
  }
  break;
  case 'w':{		/*No prefix*/
    strcat(toSF->data, tmpFromSF->data);
  }
  break;
  default: res=-1;  
  }/*switch*/

  return res;
}

int splitSubField(field *toFld, 
		  subField *fromSF,
		  PortionTable_VarDat *ptvd, 
		  int index){
  /*
   * This is a version of splitSubField that only splits 
   * sub fields that split in 2. (let alone cases 
   * of character count split) 
   * Larger sub fieds are at the moment not split.
   * The entire sub field is converted into the first 
   * of the to sub fields, using directConvert()
   */
  int res=0;

  /*
   * SPLIT BY CHARACTER COUNT k|l|...|n
   * From sub field is split into subfields of 
   * k, l,...n characters
   * long by positions. 
   * One of the number may be unknown, and
   * denoted by 'x'. In such a case 
   * ptvd->treatment_par = e.g. "3|x|4" 
   */

  if (ptvd->treatment_par[index]==NULL){
    char m[200];
    sprintf(m, "splitSubField()\n   toTag: %s subField: %c - No splitting information in VDF table.\n", 
	    toFld->datafield->tag,
#ifdef VMS
	    ptvd->fromSubfieldCode[index]!='\0'?
#else
	    ptvd->fromSubfieldCode[index]!=(char)NULL?
#endif	    
	    ptvd->fromSubfieldCode[index]:
	    '#');
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    return -1;
    
  }
  
  /*
   * Check if split is done on number 
   * of characters k|l|...|n
   */
  
  if(strchr(ptvd->treatment_par[index], '|')!=NULL){
    char subFieldCodes[10];
    int lengths[10]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1}; /*length 0 means unknown (x)*/
    char *data[10]={NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
    char *ptr=ptvd->treatment_par[index];
    char *nr_chr=ptvd->treatment_par[index]+strlen(ptvd->treatment_par[index])-1;
    int i,j,s,t, Nelem=0;

    for(i=0;i<strlen(ptvd->toSubField[index]);i++){
      subFieldCodes[i]=*(ptvd->toSubField[index]+i);
      while(*ptr=='|')
	ptr++;
      if (*ptr=='x')
	lengths[i]=0;
      else
	lengths[i]=toNumber(*ptr);
      ptr++;
    }
    /*update the data[] array with data*/
    /*if x is not first - start at the beginning of the array*/


    s=0;
    for (j=0;j<i;j++){

      /*If the "rest" - unknown number of characters 
	(x) is not to be taken from the end of the subfield 
	text, then we need to count from the end.*/
      if (lengths[j]==0 ){
	int t = strlen(fromSF->data);
	int k;
	for (k=i-1;k>j;k--){
	  data[k]=(char *)malloc(lengths[k]+1);
	  memset(data[k], '\0', lengths[k]+1);
	  t=t-lengths[k];
	  if (t<s){
	    /*ERROR MESSAGE*/
	  }
	  else{
	    strncpy(data[k],fromSF->data+t,lengths[k]);
	  }
	}
	/*now k is on the "rest" position of the array */
	if (t > s){
	  data[k]=(char *)malloc(((t-s)+1)* sizeof(char));
	  memset(data[k], '\0', (t-s)+1);
	  strncpy(data[k],fromSF->data+s,t-s);
	  lengths[k]=t-s;
	}
	break;
      }
      else{
	data[j]=(char *)malloc(lengths[j]+1);
	memset(data[j], '\0', lengths[j]+1);
	strncpy(data[j],fromSF->data+s,lengths[j]);
	s+=lengths[j];
      }
    }
    
    
    /*Now construct the necessary sub fields*/
    i=0;
    while (lengths[i]!=-1){

      if (lengths[i]!=0){
	subField *toSF = 
	  (subField *)createSubField(toFld, 
				     subFieldCodes[i]);
	toSF->data=data[i];
      }
      i++;
    }
  }
  else{
  
    /*  
     *   SPLIT BY DELIMITER MATCH
     */
     
    /*
     * Check if there are more than 2 target subfields  
     * if so - reduce them to 2.
     */
    if (strlen(ptvd->toSubField[index])>2){
      /*Leave only the first two TO subfields.*/
      *(ptvd->toSubField[index]+2)='\0';

      /*Done without a check. The check belongs in the TABGEN MACRO*/
      *(ptvd->treatment_par+1)='\0';
    }
 
    if (strlen(ptvd->toSubField[index]) == 2 /*Should always yield true*/
	&&
	isalnum(*(ptvd->treatment_par[index]))==0
	/*With only two subfields to split, 
	 * on an ISBD character, 
	 * the splitting is going to make sense
	 */
	
	/*
	 * Now check that the splitting character 
	 * really is on the
	 * sub field
	 */
	&&
	strchr(fromSF->data, *(ptvd->treatment_par[index]))!=NULL
	)

      {
	int len1, len2;
	subField *toSF1 = 
	  (subField *)createSubField(toFld, 
				     *(ptvd->toSubField[index]));
	subField *toSF2 = 
	  (subField *)createSubField(toFld, 
				     *(ptvd->toSubField[index]+1)
				     );
      
	/*find lengths of 2 "split" strings*/
	/*len1=strcspn(fromSF->data, ptvd->treatment_par[index]);*/
	len1=mystrcspn(fromSF->data, ptvd->treatment_par[index]);
	len2=strlen(fromSF->data)- (len1+1);
      
	toSF1->data=(char *)malloc((len1+1)*sizeof(char));
	strncpy(toSF1->data, fromSF->data, len1);
	memset(toSF1->data+len1,'\0',1); /*terminate*/
	toSF2->data=(char *)malloc((len2+1)*sizeof(char));
	strncpy(toSF2->data,fromSF->data+len1+1,len2);
	memset(toSF2->data+len2,'\0',1); /*terminate*/
      }
    else /*MORE THAN 2  OR NON ISBD DELIMITERS*/
      directConvert(toFld, fromSF, ptvd, index, 646);
  }
  return res;
}


int makeFieldAndSubfield(record *rcd,subField *fromSF,PortionTable_VarDat *ptvd, int index){
  char *tag=(char *)calloc(4,sizeof(char));
  char *ind=(char *)calloc(4,sizeof(char));
  char *sfcodes=(char *)calloc(MAX_SUBFIELDS_IN_DATA_FIELD,sizeof(char));
  char *sFData[3];
  extractFieldData(ptvd->treatment_par[index],
		     tag, 
		     ind,
		     sfcodes,
		     sFData);
  insertF(tag, rcd, ind,(lookup_table *) NULL);
  insertSF(rcd, tag, *sfcodes, fromSF->data);
  return 0;  
}
int multiCopySubField(field *toFld, subField *fromSF,PortionTable_VarDat *ptvd, int index){


}

int sfToNewField(record *rcd,
		 subField *sf,
		 PortionTable_VarDat *ptvd, 
		 int index){

  char *fieldStr;
  
  int lgt;
  
  lgt=1+strlen(ptvd->treatment_par[index]);
  lgt+=strlen(sf->data);

  fieldStr=(char *)calloc(lgt, sizeof(char));
  strcat(fieldStr,ptvd->treatment_par[index]);
  strcat(fieldStr,sf->data);
  textToField(rcd, fieldStr);
  free(fieldStr);
}


/*-------------END OF SUBFIELD ROUTINE REPERTOIRE--------------------*/


int convertSubField(record *rcd_in,
		    record *rcd_out,
		    field *toF, 
		    field *fromF, 
		    int sfIndex , 
		    PortionTable_VarDat *ptvd, 
		    conditional_table_str *cts){
  
  subField *fromSF;
  int i=0;
  int res=1;
  fromSF=fromF->datafield->subFields[sfIndex];
  while (i<ptvd->ArrayLength){
    if (fromSF->subFieldCode==ptvd->fromSubfieldCode[i]){
      break;
    }
    i++;
  }
  /**UPON EXTENDING THE REPERTOIRE OF CONVERSION ROUTINES
    FOR SUBFIELDS, CHOOSE A NEW, UNIQUE 1-CHARACTER CODE, ADD THE 
    ROUTINE AS MENTIONED ABOVE, AND ADD A CASE STATEMENT
    WITH AN APPROPRIATE CALL BELOW. DONT FORGET THE 'BREAK;'! **/
  
  if (i<ptvd->ArrayLength){
    switch(ptvd->fromFunction[i]){
    case 'a':
      res=directConvert(toF, fromSF,ptvd, i, 721);
      break;
    case 'b':
    case 'e':
    case 'h':  
    case 'k':
    case 'm':
    case 'n':
    case 'p':
    case 's':
    case 't':
    case 'w':
      res=mergeSubField(toF,fromF, sfIndex, ptvd, i);
      break;
    case 'c':
      res=splitSubField(toF, fromSF,ptvd, i);
      break;
    case 'f':
      res=sfToNewField(rcd_out,fromSF,ptvd, i);
      break;

    case 'q':
      res=multiCopySubField(toF, fromSF,ptvd, i);
      break;
    case 'r':
      if (cts==NULL){
	  char m[200];
	  sprintf(m, "convertSubField()\n   Tag: %s subField: %c - conditional table not present - performing direct conversion\n", 
		  fromF->datafield->tag, 
		  fromF->datafield->subFieldCodes[sfIndex]);
	  if (ONETK_WriteLogFile(fildes, m)==-1){
	    /**Error handle**/
	  }
	

	}
      else{

	res=cond_convert(rcd_in, 
			 toF, 
			 fromF, 
			 sfIndex ,
			 ptvd->toTag, 
			 cts);
	
	  
      }
      
      break;
    case 'y':
      res=updateFromCopyField(rcd_in,toF,ptvd,i);
      break;
    case 'd':
      return 0;
      break;
    case 'o':
      res=updateFaultField(rcd_in->format, rcd_out,toF,fromF,sfIndex);
      break;
    default:
      {
	char m[200];
	
	sprintf(m, "function for code %c not yet implemented\n",ptvd->fromFunction[i]);
	if (ONETK_WriteLogFile(fildes, m)==-1){
	  /**Error handle**/
	}
      }
      break;
    }
    return res;
  }
  else{
    updateFaultField(rcd_in->format, rcd_out,toF,fromF,sfIndex);

  }
  
  return res;
}






























