      /* * * * * * * * * * * * * * * * *    
        *  MARCconv        Version 2.3  * 
        *   File:        freetbls.c     * 
        *    2.Freeing lookup table     * 
        *           memory              * 
        *    Last update: 28/01/1997    * 
        *      Michael S. Preminger     * 
        *      BRODD, OSLO COLLEGE      * 
        *        THE ONE PROJECT        * 
        * * * * * * * * * * * * * * * * */

/* * * * * * * * * * * * * * * * *
 *                               *
 *     DESTRUCTION FUNCTIONS     *
 *                               *
 * * * * * * * * * * * * * * * * */

#include <setjmp.h>
#include "MARCproto.h"

void *freeVarDat(struct PortionTable_VarDat *sptvd){
  int i;
  if (sptvd->NextPT_DT!=NULL){
        freeVarDat(sptvd->NextPT_DT);
	free(sptvd->NextPT_DT);
  }

  for (i=0;i<sptvd->ArrayLength;i++){
    if (sptvd->treatment_par[i]!=NULL)
      free(sptvd->treatment_par[i]);
    if (sptvd->ind1special[0]!=NULL || sptvd->ind1special[i]!=NULL)
      /*  free (sptvd->ind1special[i]);*/
    if (sptvd->ind2special[i]!=NULL)
      /*      free (sptvd->ind2special[i]);*/
    if (sptvd->toSubField!=NULL)
      free(sptvd->toSubField[i]);

  }
  if (sptvd->toTag!=NULL)
    free(sptvd->toTag);
  if (sptvd->text!=NULL)
    free(sptvd->text);
}

void msfree(char *str){
  memset(str, '\0', strlen(str));
  /*free(str);*/
}

void *freeSubPorCtl(subPortionTable_Control *ssptcl){
  int i;
  for (i=0;i<ssptcl->Arraylength;i++){
    if (ssptcl->fromValue[i]!=NULL)
      msfree(ssptcl->fromValue[i]);
    if (ssptcl->toTag[i]!=NULL)
      msfree(ssptcl->toTag[i]);
    if (ssptcl->toValue[i]!=NULL)
      msfree(ssptcl->toValue[i]);
  }
}


void *freeConversionTable(generic_table *tbl[]){
  int i,ii;
  PortionTable_VarDat *ptvd;
  PortionTable_Control *ptcl;
  for (i=0;i<1000;i++){
    if (tbl[i]!=NULL){
      if (tbl[i]->portion_table_vdt!=NULL){
	ptvd=tbl[i]->portion_table_vdt;
	if (ptvd->NextPT_DT!=NULL){
	  freeVarDat(ptvd->NextPT_DT);
	  free(ptvd->NextPT_DT);
	}
	for (ii=0;ii<ptvd->ArrayLength;ii++){
	  free(ptvd->treatment_par[ii]);
	  free(ptvd->toSubField[ii]);

	}

      }
      if (tbl[i]->portion_table_ctl!=NULL){
	ptcl=tbl[i]->portion_table_ctl;
	for(ii=0;ii<ptcl->Arraylength;ii++){
	  if (ptcl->consultValue1[ii]!=NULL)
	    free(ptcl->consultValue1[ii]);
	  if (ptcl->consultValue2[ii]!=NULL)
	    free(ptcl->consultValue2[ii]);
	  if (ptcl->subPortion_CTL[ii]!=NULL)
	    freeSubPorCtl(ptcl->subPortion_CTL[ii]);
	  if (ptcl->subPortion_CTL[ii]!=NULL)
	    free(ptcl->subPortion_CTL[ii]);
	}
	free(tbl[i]->portion_table_ctl);
      }
      if (tbl[i]->defaultText!=NULL)
	free(tbl[i]->defaultText);
      free(tbl[i]);
    }
  }
}

void freeConversionTableStr(conversion_tbl_str *cns){
  freeConversionTable(cns->Conversion_Table)  ;
  free(cns);
}
void *freePortionTableDcs(PortionTable_Decision *ptd)
{
  int i;
  if (ptd->NextPT_DCS!=NULL){
    freePortionTableDcs(ptd->NextPT_DCS);
    free(ptd->NextPT_DCS);
  }

  for (i=0;i<ptd->ArrayLength;i++){
    free(ptd->lowerLevelTable_txt[i]);
    free(ptd->lowerLevelTable_toTag[i]);
  }
  free(ptd->material);
  free(ptd->toTag);
  free(ptd->defaultToTag);
}

void *freeDecisionTableStr(decision_table_str *dts)
{
  int i;

  for (i=0;i<dts->ArrayLength;i++){
    freePortionTableDcs(dts->Table[i]);
    free(dts->Table[i]);
    free(dts->fromTags[i]);
      
  }
}
void *freePortionTableInd(PortionTable_Indicator *pti)
{
  int i;
  if (pti->NextPT_IND!=NULL){
    freePortionTableInd(pti->NextPT_IND);
    free(pti->NextPT_IND);
  }

  for (i=0;i<pti->ArrayLength;i++){
    free(pti->lowerLevelTable_txt[i]);
    regfree(pti->lowerLevelTable_compExp[i]);
  }
  if (pti->checkField!=NULL)
    free(pti->checkField);
  if (pti->checkField_compExp!=NULL)
    regfree(pti->checkField_compExp);
  if (pti->parameter!=NULL)
    free(pti->parameter);
}

void *freeIndicatorTableStr(indicator_table_str *its)
{
  int i;

  for (i=0;i<its->ArrayLength;i++){
    freePortionTableInd(its->Table[i]);
    if (its->Table[i]!=NULL)
      free(its->Table[i]);
    if (its->fromTags[i]!=NULL)
      free(its->fromTags[i]);
    if (its->toTags[i]!=NULL)
      free(its->toTags[i]);  

    if (its->toTags_compExp[i]!=NULL)
      regfree(its->toTags_compExp[i]);
  }
}
void *freePortionTableCnd(PortionTable_Conditional *ptc)
{
  int i;

  for (i=0;i<ptc->ArrayLength;i++){
    if (ptc->sf_contents[i]!=NULL)
      free(ptc->sf_contents[i]);
    if (ptc->sf_content_compExp[i]!=NULL)
      regfree(ptc->sf_content_compExp[i]);
    if (ptc->parameter[i]!=NULL)
      free(ptc->parameter[i]);
    if (ptc->toSubField[i]!=NULL)
      free(ptc->toSubField[i]);
    if (ptc->treatment_par[i]!=NULL)
      free(ptc->treatment_par[i]);

  }
}

void *freeConditionalTableStr(conditional_table_str *cts)
{
  int i;

  for (i=0;i<cts->ArrayLength;i++){
    if(cts->fromTags[i]!=NULL)
      free(cts->fromTags[i]);
    if (cts->toTags[i]!=NULL)
      free(cts->toTags[i]);  
    if (cts->Table[i]!=NULL){
      freePortionTableCnd(cts->Table[i]);
      free(cts->Table[i]);
    }
  }
}

void freeISBDSubPortion(subPortionTable_ISBD *spi)
{
  int i;

  for(i=0;i<spi->ArrayLength;i++){
    if (spi->treatment_par[i]!=NULL)
      free(spi->treatment_par[i]);
    if (spi->Punctuation[i]!=NULL)
      free(spi->Punctuation[i]);
  }
}

void *freePrefixPortion(PortionTable_Prefix *ptp){
  int i;
  for (i=0;i<ptp->ArrayLength;i++){
    if (ptp->sf_contents[i]!=NULL)
      free(ptp->sf_contents[i]);
    if (ptp->parameter[i]!=NULL)
      free(ptp->parameter[i]);
    if (ptp->toField[i]!=NULL)
      free(ptp->toField[i]);
    if (ptp->treatment_par[i]!=NULL)
      free(ptp->treatment_par[i]);
    if (ptp->sf_content_compExp[i]!=NULL)
      regfree(ptp->sf_content_compExp[i]);
  }

}

void *freePrefixTable(prefixing_table_str *pts){
  int i;
  for (i=0;i<pts->ArrayLength;i++){

    if (pts->fromTags[i]!=NULL){
      free(pts->fromTags[i]) ;
    }
    if (pts->Table[i]!=NULL){
      freePrefixPortion(pts->Table[i]);
      free(pts->Table[i]);
    }
  }
}

void *freeXiferpPortion(PortionTable_Xiferp *ptx){
  int i;
  for (i=0;i<ptx->ArrayLength;i++){
     if (ptx->toSFCodes[i]!=NULL)
       free(ptx->toSFCodes[i]);
     if (ptx->treatment_par[i]!=NULL)
       free(ptx->treatment_par[i]);
 }
}

void freeXiferpTable(xiferping_table_str *xts){
  int i;
  for (i=0;i<xts->ArrayLength;i++){
    if (xts->fromTags[i]!=NULL)
      free(xts->fromTags[i]);
    if (xts->ToTags_text[i]!=NULL)
      free(xts->ToTags_text[i]);
    if (xts->ToTags_compExp[i]!=NULL)
      regfree(xts->ToTags_compExp[i]);
    if (xts->Table[i]!=NULL)
      freeXiferpPortion(xts->Table[i]);
    free(xts->Table[i]);
  }
  
}

void *freeISBDPortion(PortionTable_ISBD *pti)
{
  int i;

  for(i=0;i<pti->ArrayLength;i++){
    if (pti->spt_ISBD[i]!=NULL){
      freeISBDSubPortion(pti->spt_ISBD[i]);
      free(pti->spt_ISBD[i]);
    }
  }
}

void freeISBDTable(PortionTable_ISBD *pt_ISBD[])
{
  int i;
  for (i=0;i<1000;i++)
    if (pt_ISBD[i]!=NULL){
      freeISBDPortion(pt_ISBD[i]);
      free(pt_ISBD[i]);
    }
}

void freeISBDTableStr(isbd_table_str *ists){
  freeISBDTable(ists->isbd_tbl);
}





void TABFREE(){

#ifndef _ONETK_LIB_BUILD_
  freeLookupTable(lt);
#endif

  freeISBDTableStr(iss);
}
void freeConversionSetByLt(lookup_table *lt){
  free(lt->fromFormatName);
  free(lt->toFormatName);
  if (lt->cns != NULL)
    freeConversionTableStr(lt->cns);
  freeDecisionTableStr(lt->dts);
  if (lt->its != NULL) 
    freeIndicatorTableStr(lt->its);
  if (lt->cts != NULL) 
    freeConditionalTableStr(lt->cts);
  free(lt);
}

void *freeConversionSet(char *from, 
			char *to){
  
  int i,j;
  for (i=0;i<lt_ArrayLength;i++){
    if (lt[i]!=NULL)
      if (strcmp(from, lt[i]->fromFormatName)==0
	  &&
	  strcmp(to, lt[i]->toFormatName)==0)
	break;
  }
  if (i==lt_ArrayLength){
          char m[200];
	  sprintf(m, "FreeLookupTableByFormatNames():\n  unable to free conversion set for %s to %s\n",
		  from,
		  to);
	if (ONETK_WriteLogFile(fildes, m)==-1){
	  /**Error handle**/
	}
	  
    
  }
  free(lt[i]->fromFormatName);
  free(lt[i]->toFormatName);
  freeConversionTableStr(lt[i]->cns);
  freeDecisionTableStr(lt[i]->dts);
  freeIndicatorTableStr(lt[i]->its);
  freeConditionalTableStr(lt[i]->cts);
  free(lt[i]);

  lt_ArrayLength--;

  /*
   * rearrange the lt array
   */
  for (j=i;j<lt_ArrayLength;j++)
    lt[j]=lt[j+1];
  lt[lt_ArrayLength]=NULL;
}

void freeLookupTable(lookup_table *lta[])
{
  int i;
  for (i=0;i<MAX_TABLES;i++)
    if (lta[i] != NULL)
      freeConversionSetByLt(lta[i]);
}

