        /* * * * * * * * * * * * * * * * *             
	 *  MARCconv        Version 2.3  *
	 *   File:       inputRecord.c   * 
         *   Reading records from file   *
	 *      into data structure      *
	 *    Last update: 28/01/1997    * 
	 *      Michael S. Preminger     * 
	 *      BRODD, OSLO COLLEGE      * 
	 *        THE ONE PROJECT        * 
	 * * * * * * * * * * * * * * * * */            

/* * * * * * * * * * * * * * * * * * * * * * * *
 * This file also includes routines to         *
 * test the validity of records, cleans USMARC *
 * records from ISBD characters, and so on     *
 * * * * * * * * * * * * * * * * * * * * * * * */

         
	    
#include <setjmp.h>
#include "MARCproto.h"


/*I1*/

extern jmp_buf marcconv_env;

char *itoa(int n, char *str)
{

  sprintf(str, "%d", n);
  return str;		
}

int findIndex(char *str, char chr){
  char *tmp;
  int i, res;
  int lgt=strlen(str);
  for (i=0;i<lgt;i++){
    if (*(str+i)==chr)
      return i;
  }
  return lgt;
}

int mystrcspn(char *str, char *substr){
  int sublgt=strlen(substr);
  int i, minidx=strlen(str), tmpidx=0;
  for (i=0;i<sublgt;i++){
    tmpidx=findIndex(str, *(substr+i));
    minidx= tmpidx<minidx ? tmpidx : minidx;
  }
  return minidx;
}

int min(int a, int b){
  if (b<a) return b;
  return a;
}

char *intToStr(int i, int length){
  int n;
  int lgn;

   
  char *raw;
  raw=(char *)calloc((length+1),sizeof(char));
  sprintf(raw,"%d",i);
  if (strlen(raw)==length)
    return raw;
  else{
    char *str;
    str=(char *)malloc((length+1)*sizeof(char));
    memset(str,'\0', length+1);
    memset(str,'0',length-strlen(raw));
    strcat(str,raw);
    return str;
  }
  
}
/*
 * Update the explaining text of the
 * input record. This is done for use in the
 * client in a non convert mode.
 * It is done using either the text of
 * the first toTag portion table, or if
 * NULL, the defaultText of thegeneric table.
 */
void *updateFieldText(field *fld,
		lookup_table *lte){
  dataField *df=fld->datafield;
  int tg=atoi(df->tag);
  int txtlgt;

  if (lte->cns->Conversion_Table[tg]!=NULL)
    if(lte->cns->Conversion_Table[tg]->portion_table_vdt!=NULL){
      if (lte->cns->Conversion_Table[tg]->portion_table_vdt->text!=NULL){
	txtlgt=
	  strlen(lte->
		 cns->
		 Conversion_Table[tg]->
		 portion_table_vdt->text)+1;
	if (df->text != NULL) free(df->text);
	df->text=(char *)malloc(txtlgt*sizeof(char));
	memset(df->text, '\0', txtlgt);
	strncpy(df->text,
		lte->
		cns->
		Conversion_Table[tg]->
		portion_table_vdt->text,
		txtlgt-1);
      }
    }
    else{ /* defaultText is used*/
      if (lte->cns->Conversion_Table[tg]->defaultText!=NULL){
	txtlgt=
	  strlen(lte->
		 cns->
		 Conversion_Table[tg]->
		 defaultText)+1;
	if (df->text != NULL) free(df->text);
	df->text=(char *)malloc(txtlgt*sizeof(char));
	memset(df->text, '\0', txtlgt);
	strncpy(df->text,
		lte->
		cns->
		Conversion_Table[tg]->
		defaultText,
		txtlgt-1);
	
      }
    }
}

Boolean removeISBD(field *fld,
		  int sfIndex,
		  subPortionTable_ISBD *si,
		  int siIndex )
{
  int i; /*counter for the si array entries*/
  dataField *dtFld;
  char *tmp;
  subField *csf; /*current-sub-field*/
  subField *psf; /*previous sub field*/
  dtFld=fld->datafield;
  csf=dtFld->subFields[sfIndex];

  
  if (strcmp(si->Punctuation[siIndex],"(")==0)
    /*Punctuation leading the subfield data: '('*/
    switch(si->function[siIndex]){
    case '\0':
      if (*(csf->data)=='('){
	/*char *tmp=(char *)malloc(strlen(csf->data)*sizeof(char));
	memcpy(tmp,csf->data+1,strlen(csf->data)-1);
	memset(tmp+strlen(csf->data)-1,'\0',1);
	*/
	int newDtLgt=strlen(csf->data)-1;
	memmove(csf->data, csf->data+1,newDtLgt);
	memset(csf->data+newDtLgt,'\0',1);
      }
      /***csf->data=concat("(", csf->data);*/
      return TRUE;
      break;
    case '!':/*None of parameter subfields precede*/
      if (strchr(si->treatment_par[siIndex],
		dtFld->subFieldCodes[sfIndex-1])==(char *)NULL){
	/***csf->data=concat("(", csf->data);*/
	if (*(csf->data)=='('){
	  int newDtLgt=strlen(csf->data)-1;
	  memmove(csf->data, csf->data+1,newDtLgt);
	  memset(csf->data+newDtLgt,'\0',1);
	}
       }
      return TRUE;
      break;
    case '+':
      {
      char m[200];
      sprintf(m, 
	      "treatISBD()\n   a + function is never associated with an opening parenthes. table error\n");
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
      }
    }
      break;
    }/*select*/
    else{
      int lgtPct=strlen(si->Punctuation[siIndex]);
      int lgtData=strlen(csf->data);
      /*Punctuation at end of sub field*/
      switch(si->function[siIndex]){
      case '\0':
	/***csf->data=concat(csf->data, si->Punctuation[siIndex]);*/
	if (memcmp(csf->data+lgtData-lgtPct,
		  si->Punctuation[siIndex],
		  lgtPct)==0)
	  memset(csf->data+lgtData-lgtPct,'\0',lgtPct);
	
	break;
      case '!':/*None of parameter subfield precede*/
	if (strchr(si->treatment_par[siIndex],
		   dtFld->subFieldCodes[sfIndex-1])==(char *)NULL){
	  /***csf->data=concat(csf->data, si->Punctuation[siIndex]);*/
	  if (memcmp(csf->data+lgtData-lgtPct,
		     si->Punctuation[siIndex],
		     lgtPct)==0)
	    memset(csf->data+lgtData-lgtPct,'\0',lgtPct);
	}
	break;
      case '+':/*One of parameter subfield precedes*/
	if (strchr(si->treatment_par[siIndex],
		   dtFld->subFieldCodes[sfIndex-1])!=NULL){
	  /***csf->data=concat(csf->data, si->Punctuation[siIndex]);*/
	if (memcmp(csf->data+lgtData-lgtPct,
		  si->Punctuation[siIndex],
		  lgtPct)==0)
	  memset(csf->data+lgtData-lgtPct,'\0',lgtPct);
	  
	}
	
	break;
      case '&': /*none of parameter subfields succeeds $*/
	if (sfIndex==dtFld->ArrayLength-1
	    ||
	    strchr(si->treatment_par[siIndex],
		   dtFld->subFieldCodes[sfIndex+1])==(char *)NULL)
	  /***csf->data=concat(csf->data, si->Punctuation[siIndex]);*/
	  if (memcmp(csf->data+lgtData-lgtPct,
		     si->Punctuation[siIndex],
		     lgtPct)==0)
	    memset(csf->data+lgtData-lgtPct,'\0',lgtPct);
	
	  else return TRUE;
	else return TRUE;
	break;
      }
    }

    return FALSE;
}
void *removeIsbdPunctuation(record *rcd,
			    PortionTable_ISBD *itbl[])
{
  int i; /*field (portion table) counter*/
  int j;/*sub field counter*/
  int k; /*sub portion table counter*/
  field *fld;
  dataField *dtFld;
  PortionTable_ISBD *pi;
  subPortionTable_ISBD *spi;
  Boolean Opp=FALSE;
  for (				/*All fields*/
       i=0;i<rcd->ArrayLength;i++){
    if (itbl[atoi(rcd->tags[i])]!=NULL){
      pi=itbl[atoi(rcd->tags[i])];
      fld=rcd->fields[i];
      dtFld=fld->datafield;
      for ( /*Actual subfields in field*/
	   j=0;j<dtFld->ArrayLength;j++){
	spi=findSubTableISBD(pi, dtFld->subFieldCodes[j]);
	if (spi!=NULL){
	  for (	/*All occurences of sub field 
		  code in table sub portion*/
	       k=0;k< spi->ArrayLength;k++){
	    if (/*subseq=NULL*/
		spi->subseq_sfc[k]=='\0'
		){
	      Opp=removeISBD(fld,j,spi,k);
			    
	      if (Opp==FALSE)
		break;
	    }
	    else 
	      if (/*subfield is the last in the field*/
		  j==dtFld->ArrayLength-1)
		{}
	      else 
		if (		/*subseq=='*' */
		    spi->subseq_sfc[k]=='*'){
		  Opp=removeISBD(fld,j,spi,k);
		  if (Opp==FALSE)
		    break;
		}
		else
		  if (/*subseq equals the following subfield code*/
		      dtFld->subFieldCodes[j+1]==spi->subseq_sfc[k]
		      )
		    {
		      Opp=removeISBD(fld,j,spi,k);
		      if (Opp==FALSE)
			break;
		    }

	  } /*for all occurences*/
	}
      }	/*subFields in field*/
    }/*if itbl[]!=NULL*/
  }/*all fields*/
}/*FUNCTION*/

void *insertF(char *tag, 
	      record *rcd, 
	      char *indicators,
	      lookup_table *lte)
{
  field *fld;
  
  fld=createField(rcd, tag);
  if (fld->datafield!=NULL){
    memcpy(fld->datafield->indicators+1,indicators,2);
    rcd->lgt[rcd->ArrayLength-1]=3;
  }
  if (lte!=NULL)
    updateFieldText(fld, lte);
}
void *insertSF(record *rcd, char *tag, char code, char *data){
  field *fld;
  dataField *df;
  subField *sf;
  fld=accessField(rcd, tag);
  sf=createSubField(fld, code);
  if (data!=NULL){
    sf->data=malloc(strlen(data)+1);
    memset(sf->data,'\0',strlen(data)+1);
    strcat(sf->data, data);
    *(sf->data+strlen(data))='\0';
  }
}
field *updateDataField(char *subString, record *rd, int arrayIndex){
  field *fld;
  dataField *DFPtr;
  subField *sf;
  int i=0, fieldLength, SFlength;
  int sfDataSize=0;
  char startOfSubField[3]={START_OF_SUBFIELD, END_OF_FIELD, '\0'};
  char *endOfField=(char *)calloc(2,sizeof(char));
  char *SFstring;
  char *fieldString, *restString;

  *endOfField=END_OF_FIELD;
  fld=createField(rd, rd->tags[arrayIndex] );
  DFPtr=fld->datafield;   
  fieldLength=findIndex(subString, END_OF_FIELD);
  fieldString=(char *)calloc((2+fieldLength),sizeof(char));
  /*Check actual length against directory-specified length*/
  if (rd->lgt[arrayIndex]!=fieldLength+1){
    char m[200];
    sprintf(m, 
	    "updateDataField()\n  mismatch in field size. Record rejected\n");
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }

    /*
     * exit(1);
     */
    if (fieldString!=NULL)
      free(fieldString);
    free(endOfField);
    return NULL;
  }

  strncpy(fieldString, subString, fieldLength+1);
  memset(fieldString+fieldLength+1,'\0',1);

  /******************
   *Update Indicators*
   ******************/
  DFPtr->indicators[0]='%';	/*To a void NULL*/
  DFPtr->indicators[1]=*fieldString;
  DFPtr->indicators[2]=*(fieldString+1);   
  DFPtr->indicators[3]='\0';
  DFPtr->ArrayLength=0;   
  restString=fieldString+2;
  if (*restString==START_OF_SUBFIELD)
    restString+=1;
  else{
    char m[200];
    sprintf(m, 
	    "updateDataField()\n  START_OF_SUBFIELD not following indicators. Record rejected\n");
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    /*
     * exit(1);
     */
    if (fieldString!=NULL)
      free(fieldString);
    free(endOfField);
    return NULL;
  }
       
  /*
   * restString now points at the subfield code of the first subfield
   *
   * update all sub fields.
   */

  while(*restString!=(char)NULL){
    SFlength=min(
		 findIndex(restString,START_OF_SUBFIELD),
		 findIndex(restString,END_OF_FIELD));
       
    sf=createSubField(fld, *restString);
    
    /*update data string*/
    sf->data=(char *)calloc(SFlength+10 , sizeof(char));
    strncpy(sf->data, restString+1, SFlength-1);

    restString=restString+SFlength+1;
  }

  /*Update number of subfields in field structure*/
    if (fieldString!=NULL)
      free(fieldString);
    free(endOfField);
  return fld;
}
field *updateControlField(char *stringRest, record *rd, int arrayIndex){
  
  field *fld;
  controlField *CFPtr;   
  int i;

  /** to do
   * USE THE RECORD ABSTRACTION
   **/  
  fld=createField(rd, rd->tags[arrayIndex]);
  CFPtr=fld->ctrlfield;

  /*Update data*/
  CFPtr->data=(char *)calloc((rd->lgt[arrayIndex]+10),sizeof(char));
  strncpy(CFPtr->data,stringRest,(rd->lgt[arrayIndex])-1);

  if (*(stringRest+(rd->lgt[arrayIndex]-1))!=END_OF_FIELD ){
    char m[200];
    sprintf(m, 
	    "updateControlField()\n  No end of field after field length counted. Record rejected\n");
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    return NULL;
  }
  else return fld;
}


/*input record with integrity check*/

record *inputRecord(char *rcdStr,
		    lookup_table *lte,
		    char *fromFormat){
  /*The function is presented a part of a stream
    containing a delimited record in a NULL terminated 
    string rcdStr.   The termingating NULL comes after 
    the record-terminate(oct035). 
    */

  record *rcd;
  field *fld;
  subField sfd;
  char *lgtchr, *poschr, *runStr;
  int i, numFld;

  /*NSU*/
  /*
   * Check that this is not a line record
   */
  /*  if (strchr(rcdStr, END_OF_FIELD)==NULL)
      return(inputLineRecord(rcdStr));*/
  /*end NSU*/

  /*
   * Check for carriage return within record.
   */
  
  if (memchr(rcdStr,'\n',strlen(rcdStr))!=NULL){
    char m[200];
    sprintf(m, 
	    "inputRecord()\n  carriage-return within record. corrupt_record - rejected\n");
    if (ONETK_WriteLogFile(fildes, m)==-1){
      /**Error handle**/
    }
    return NULL;
  }

  lgtchr=calloc((LONGEST_LENGTH_LENGTH+1),sizeof(char));
  *(lgtchr+4)='\0';
  poschr=calloc((LONGEST_START_POSITION_LENGTH+1),sizeof(char));
  *(poschr+5)='\0';
  
  rcd=createRecord();

  /*ONLY FOR TEST PURPOSES*/
#ifdef MARC_TEST_VARIABLES
  globRecord=rcd;
#endif
  rcd->string2709=rcdStr;
  /*
   * Update format name
   */
  strcpy (rcd->format, fromFormat); 

  /* 
   * Read position into   
   * leader array         
   */
  for (i = 0;i<LEADER_LENGTH;i++)
    rcd->leader[i]=*(rcdStr+i);
  memset(rcd->leader+LEADER_LENGTH,'\0',1); /*Terminate*/

  /* 
   *  READ FIELD-DIRECTORY ENTRY 
   */

  /*
   * put leader into fields[0]
   */
  fld=(field *)createField(rcd, "000");

  fld->ctrlfield->data=(char *)calloc((LEADER_LENGTH+1),sizeof(char));

  if (fld->ctrlfield->data==NULL){
    if (ONETK_WriteLogFile(fildes, "inputRecord() malloc failed")==-1){
      /**Error handle**/
    }
    /*
     * exit(1);
     */
    longjmp(marcconv_env, 1);
  }

 /*
  * Update leader
  */ 
  memset(fld->ctrlfield->data, '\0', LEADER_LENGTH+1);
  memcpy(fld->ctrlfield->data,rcd->leader,LEADER_LENGTH);

  rcd->lgt[0]= 24;
  rcd->pos[0]= -1; /*position is irrelevant for leader*/


  /*
   * READ ALL FIELDS INTO THE RECORD STRUCTURE
   * FIELD BY FIELD
   */
  numFld=1;
  while (*(rcdStr+i)!=END_OF_FIELD){

    if (numFld==MAX_FIELDS_IN_RECORD){
      char m[200];
      sprintf(m, 
	      "inputRecord()\n  Number of fields in record exceeds %d - rejected\n You can change MAX_FIELDS_IN_RECORD in datastruct.h\n", numFld);
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
      }
      /*
       * exit(1);
       */
      return NULL;
    }

      
    /* 
     * A check for directory validity - 
     * no '\x1E' terminator in a middle   
     * of a field representation 
     * e.g. within a group of 12 characters. 
     */               
    if (memchr(rcdStr+i,'\x1E',11)!=NULL){
      char m[200];
      sprintf(m, 
	      "inputRecord()\n  END_OF_FIELD within directory entry. corrupt_record - rejected\n");
      if (ONETK_WriteLogFile(fildes, m)==-1){
	/**Error handle**/
      }
      /*
       * exit(1);
       */
      return NULL;
    }
    
    /*
     * Use field directory to extract and update tag, 
     * length and
     * position information about the field
     */
    memcpy(rcd->tags[numFld],rcdStr+i,3); i+=3;
    rcd->tags[numFld][3]='\0' ;

    memcpy(lgtchr,rcdStr+i,4); 
    rcd->lgt[numFld]= atoi(lgtchr);

    i+=4;

    memcpy(poschr,rcdStr+i,5); 
    rcd->pos[numFld]= atoi(poschr);

    i+=5;

    numFld++;
  }

  /*
   * NOW WE HAVE LENGTH, POSITION AND TAG INFORMATION
   * ABOUT ALL OF THE FIELDS. READ FIELDS THEMSELVES
   */
  free(lgtchr);
  free(poschr);
  runStr=rcdStr+i+1;   /* Position 0 of data part */
  
  /*
   *     write field into    
   *  appropriate structure             
   */

  for (i=1;i<numFld;i++){
    
    if (atoi(rcd->tags[i])>9){
      if (updateDataField(runStr + rcd->pos[i], rcd, i)==NULL){
	freeInRecord(rcd);
	return NULL;
      }
      /*
       * if it is possible - update the text 
       * for the input record field
       */
      if (strcmp(fromFormat,lte->fromFormatName)==0)
	updateFieldText(rcd->fields[i] , lte);
    }
    else{
      if (updateControlField(runStr + rcd->pos[i], rcd, i)==NULL){
	freeInRecord(rcd);
	return NULL;
      }
    }
  } /*for (i=0;i<numFld;i++)*/

  /*
   * HERE YOU MAY INSERT  FIELD ENTRIES INTO THE RECORD 
   * JUST UPDATED  INTO THE PROGRAM. 
   * THIS IS A CONVENIENT WAY TO TEST SINGLE 
   * CONVERSION FUNCTIONS, WITHOUT MANIPULATING AN 
   * ISO2709 FORMATTED RECORD. USE THE FUNCTION 
   * insertF(), 
   * insertSF().
   * Example:
   *
   * insertF("850", rcd, "  ") ;                ; 
   * insertSF(rcd, "850", 'a', "merge-") ;
   * insertSF(rcd, "850", 'b', "sub-")   ;
   * insertSF(rcd, "850", 'g', "field")  ;
   *
   * Alternatively THESE FUNCTION MAY BE USED FROM THE 
   * DEBUGGER. 
   * With the GNU DEBUGGER (gdb), break execution at 
   * "return rcd" (the following
   * program line), and 'source' a file containing the lines:
   *
   * p insertF("700", rcd, "  ");
   * p insertSF(rcd, "700", 'a', "merge-")
   * p insertSF(rcd, "700", 'l', "sub-")
   * p insertSF(rcd, "700", 'm', "field") 
   *
   * Note that it is a bit time consuming.
   *
   * The file testcases, which is supplied with the installation
   * may be used to test some of the major functions, and
   * is used in NORMARC to USMARC conversion.
   *
   * Using this alternative you avoid getting the test fields
   * into all the records of the stream.
   */

 /*
 * insertSF(rcd, "245", 'u', "Title: Dollhouse, 1909") ;
 * insertF("760", rcd, "1 ", lte) ;                
 * insertSF(rcd, "760", 'a', "Ibsen, Henrik 1909") ;
 * insertSF(rcd, "760", 'd', "Title: Dollhouse, 1909") ;
 * insertF("830",rcd, " 4", lte);
 * insertSF(rcd, "830", 'a', "the one and only");

    insertF("850", rcd, "  ", lt[0]) ;                ; 
    insertSF(rcd, "850", 'a', "merge-") ;
    insertSF(rcd, "850", 'b', "sub-")   ;
    insertSF(rcd, "850", 'g', "field")  ;
 */
  return  rcd;

}
















