       /* * * * * * * * * * * * * * * * *    
        *  MARCconv        Version 2.3  * 
        *   File:        readtablu.c    * 
	*  Utilities for table reading  *
        *    Last update: 28/01/1997    * 
        *      Michael S. Preminger     * 
        *      BRODD, OSLO COLLEGE      * 
        *        THE ONE PROJECT        * 
        * * * * * * * * * * * * * * * * */

#include <setjmp.h>
#include "MARCproto.h"
extern jmp_buf marcconv_env;

/** to do: 
 * IN EACH INPUT FILE PLACE INTEGERS
 * FOR ALL OF THE "LONGEST" VALUES IN datastruct.h,
 * CHECKING THOSE AGAINST THE SET VALUES, AND PRODUCING
 * AN ERROR MESSAGE FOR EACH OVERFLOW. 
 **/

/* * * * * * * * * * * * * * * * *
 *                               *
 *      UTILITY FUNCTIONS        *
 *                               *
 * * * * * * * * * * * * * * * * */
char *toRegExp_firstWord(char *str){
  /*
   * Converts a simple string into a regular expression
   * in which the string can occur AT THE BEGINNING
   */
  char *tmp;
  int lgt;

  if (str==NULL)
    return NULL;


  lgt=(int)strlen(str)+20;

  tmp=(char *)calloc((lgt+1),sizeof(char));
  memset(tmp, '\0',lgt+1);
  strcpy(tmp, str);

  if (strncmp(str+strlen(str)-2,".*",2)!=0)
    strcat(tmp, ".*");

  return tmp;
}
char *toRegExp(char *str){
  /*
   * Converts a simple string into a regular expression
   * in which the string can occur anywhere
   */
  
  char *tmp;
  int lgt;

  if (str==NULL)
    return NULL;


  lgt=(int)strlen(str)+20;
  
  
  tmp=(char *)calloc((lgt+1),sizeof(char));

  
  
    /*Meaning we have detected regular expression
				  syntax elements in the string *str. We then
				  assume that the string looks like .*something.*, 
				  and need only add start and end anchors*/


/*    if (strncmp(str,"^",1)!=0){
      strncpy(tmp, "^", 1);
      strcat(tmp, str);
      strcat(tmp, "$");
    }
    else
      strcat(tmp, str);
  }
 */ 
/*else { 
	  * We add both anchors, and "anys" to place our occurence
	  * anywhere in the string

    strcat(tmp, "^.*");
    strcat(tmp, str);
    strcat(tmp,".*$");
  }
	  */   
    if (strncmp(str,".*",2)!=0)
      strcat(tmp, ".*");

    strcat(tmp, str);
    if (strncmp(str+strlen(str)-2,".*",2)!=0)
      strcat(tmp, ".*");
    
  return tmp;
}


char *strtolower(char *str){
  char *ptr_s;
  ptr_s = str;

  while ( ptr_s && *ptr_s ){
     *ptr_s = tolower(  *ptr_s );
     ptr_s++;
  }
  return( str );     
}

/* * * * * * * * * * * * * * * * *
 *                               *
 *    CONSTRUCTION FUNCTIONS     *
 *                               *
 * * * * * * * * * * * * * * * * */

PortionTable_Control  *newPortionTable_ctl(int index, generic_table  *tbl[]){
  generic_table *gn_tbl;
  PortionTable_Control  *ptctl;
  tbl[index]=
    (generic_table *)calloc(1,sizeof(generic_table));
  gn_tbl=tbl[index];
  gn_tbl->portion_table_ctl=
    (PortionTable_Control *)calloc(1,
				   sizeof(PortionTable_Control)); 
  ptctl= gn_tbl->portion_table_ctl; 
  return ptctl;
}
/*OBSOLETE!!!*/
PortionTable_VarDat  *newPortionTable_vdt(int index, Boolean Special_Treatment, generic_table *tbl[]){
  generic_table *gn_tbl;
  PortionTable_VarDat  *ptvdt;
  tbl[index]=
    (generic_table *)calloc(1,sizeof(generic_table));
  gn_tbl=tbl[index];
  gn_tbl->specialTreatment=Special_Treatment;
  gn_tbl->portion_table_vdt=
    (PortionTable_VarDat *)calloc(1,
				   sizeof(PortionTable_VarDat)); 
  ptvdt= gn_tbl->portion_table_vdt;

  /*initialize char variables*/
  memset(ptvdt->ind1fromValue,'\0',CNT_POSSIBLE_INDICATOR_VALUES_PLUS_1);
  memset(ptvdt->ind2fromValue,'\0',CNT_POSSIBLE_INDICATOR_VALUES_PLUS_1);
  
  return ptvdt;
}
void *new_TableSubPortion_ctl(){
}

PortionTable_ISBD *newPortionTable_ISBD(int tag,
					PortionTable_ISBD *itbl[]
					)
{
  itbl[tag]=(PortionTable_ISBD *)calloc(1,sizeof(PortionTable_ISBD));
  return itbl[tag];					       
}

subPortionTable_ISBD *newSubPortionTable_ISBD(PortionTable_ISBD *pt)
{
  pt->spt_ISBD[pt->ArrayLength]=
    (subPortionTable_ISBD *)calloc(1,sizeof(subPortionTable_ISBD));

  return pt->spt_ISBD[pt->ArrayLength];
}







